/* xhkl2k.c     */
/* utilitaire reinjectant les iobs dans le fichier .k */

#include <stdio.h>
#include <string.h>

#define BUF_SIZE  200

char buffer[BUF_SIZE + 1];

typedef struct
{   int     h, k, l, coda;
    double  obs, codb; 
    }  HKL;


HKL * p_hkl, *l_hkl;
int  max_hkl;

char hkl_name[80];
char k_name[80];
char new_name[80];
char *prg_name;

FILE *hkl_file;
FILE *k_file;
FILE *new_file;


int erreur();
int termine();

int main (argn, argc)
int argn;
char **argc;
{
    char *pos;

    int n_hkl;
    int phase = 0;
    int lambda = 0;
    double mini = 0;
    int passage = 0;


    int s_hkl;
    int ip, ih, ik, il, iw, i;
    double obs;

    prg_name = *argc;
   printf (" %s 1.00 : transfert des i_obs du fichier .hkl dans le fichier .k\n", 
            prg_name);
   switch (argn)
   {    case 2 : strcpy (k_name,  argc[1]);
                 strcpy (hkl_name, k_name);
                 strcpy (new_name, k_name);
                 strcat (hkl_name, ".hkl");
                 strcat (k_name, ".k");
                 strcat (new_name, ".k2");
                 break;
        case 3 : strcpy (k_name, argc[1]);
                 strcpy (hkl_name, argc[2]);
                 strcpy (new_name, k_name);
                 strcat (new_name, "2");
                 break;
        default : return erreur (" nombre d'arguments invalide");
        }
        
   hkl_file = fopen (hkl_name,"r");
   k_file = fopen (k_name,"r");
   new_file = fopen (new_name,"w");
   if (hkl_file == NULL || k_file == NULL || new_file == NULL)
          return erreur("erreur en ouverture de fichier");

   max_hkl = 300;
   p_hkl = (HKL *) malloc (max_hkl * sizeof(HKL));
   if (p_hkl == NULL) return erreur ("allocation memoire hkl");

   do
   {   
   n_hkl = s_hkl = 0;
   l_hkl = p_hkl;


   while (!feof(k_file) )
   {     fgets (buffer, BUF_SIZE, k_file);
         fputs (buffer, new_file);
         if (buffer[0] != '#') continue;
         pos = strstr (buffer, "BEGIN_HKL2K" );
         if (pos != NULL) break;
         }
   if (feof(k_file))
   {    if (passage == 0 && pos == NULL) 
              return erreur ("BEGIN_HKL2K non trouve");
        else break;
        }
   sscanf (pos," %*s %d %d %lf", &phase, &lambda, &mini);
   printf (" lecture des hkl et i_obs de la phase %d pour lambda %d, obs_mini = %.1lf\n",
             phase, lambda, mini);

   /* la dimension du developpement */
   do
   {   fgets (buffer, BUF_SIZE, k_file);
       fputs (buffer, new_file);
       } while (sscanf(buffer, "%d", &i) != 1);

   while (!feof(k_file) )
   {     fgets (buffer, BUF_SIZE, k_file);
         if (strlen(buffer))
         if (buffer[0] != '#') 
         {    i=sscanf(buffer, "%d %d %d %lf %d %lf",
                &l_hkl->h, &l_hkl->k, &l_hkl->l, &l_hkl->obs, 
                &l_hkl->coda, &l_hkl->codb);
              if (i >= 5)
              {   n_hkl++;
                  if (n_hkl == max_hkl)
                  {    max_hkl += 300;
                       p_hkl = (HKL *) realloc (p_hkl, max_hkl * sizeof(HKL));
                       if (p_hkl == NULL) 
                               return erreur ("reallocation memoire hkl");
                       l_hkl = p_hkl + n_hkl;
                       }
                   else l_hkl++;
               }   }
         else
         {     pos = strstr (buffer, "END_HKL2K" );
               if (pos != NULL) break;
               }
         }
   if (feof(k_file) || pos == NULL) return erreur ("END_HKL2K non trouve");
   printf (" %d hkl trouves dans %s, recherche dans %s\n", n_hkl, k_name, hkl_name);
   max_hkl = n_hkl;
   passage++;

   
   n_hkl = 0;
   fseek (hkl_file, 0L, 0);
   fgets (buffer, BUF_SIZE, hkl_file);
   fgets (buffer, BUF_SIZE, hkl_file);
   while (!feof(hkl_file) )
   {     fgets (buffer, BUF_SIZE, hkl_file);
         sscanf (buffer, 
             "%*[^(]%*[(]%d%*[)]%d%d%d%*[^(]%*[(]%d%*[)]%*lf %*c %lf",
              &ip, &ih, &ik, &il, &iw, &obs) ;
        if ( ip == phase && iw == lambda)
        {    for (i = 0, l_hkl = p_hkl; i < max_hkl; i++, l_hkl++)
              if (l_hkl->h == ih && l_hkl->k == ik && l_hkl->l == il)
              {    n_hkl++;
                   l_hkl->obs = obs;
                   break;
                   }
             if (i >= max_hkl)
             {    if (obs < mini) obs = mini;
                  printf (" %3d %3d %3d %8.1lf  0\n", ih, ik, il, obs);
                  s_hkl++;
                  }
            }
         }
    printf (" %d hkl effectivement trouvees dans le fichier .hkl\n", n_hkl );
   if (s_hkl) printf (" %d hkl listes non contenu dans le fichier .k\n", s_hkl);

   for (i = 0, l_hkl = p_hkl; i <max_hkl; i++, l_hkl++)
   {    
        if (l_hkl->obs < mini) 
        {    l_hkl->obs = mini;
             if (l_hkl->coda > 0) l_hkl->coda *= -1;
             }
        fprintf (new_file," %3d %3d %3d %8.1lf %3d", 
          l_hkl->h, l_hkl->k, l_hkl->l, l_hkl->obs, l_hkl->coda);
        if (abs(l_hkl->coda) > 10) fprintf (new_file, " %.5lf",l_hkl->codb);
        fprintf (new_file,"\n");
        }
   fputs ("#END_HKL2K\n", new_file);
   


   }
   while (!feof(k_file) );
   
   
   fclose (k_file);
   fclose (hkl_file);
   fclose (new_file);
   printf (" Le nouveau fichier .k est %s\n", new_name);
   return 0;
   }


int erreur( message)
char *message;
{
    printf ("Usage:\n %s base_name ( fichier .hkl .k )\n\
%s k_name hkl_name (si les extensions sont differentes)\n\
La conversion est faite entre les lignes #BEGIN_HKL2K et #END_HKL2K du fichier .k\n\
On peut preciser sur la ligne #BEGIN_HKL2K le numero de la phase, de la longueur a utiliser\n\
Le fichier .k est nomme .k2\n", prg_name, prg_name);
if (message != NULL) puts(message);
return (-1); }
