/*  XHKLSTAT.C analyse hkl xnd    definitions generales */

/* reconnait le compilateur Borland comme specifique MSDOS  */
#ifdef __TURBOC__
/* verifie dans ce cas le modele de memoire utilisee */

#ifndef __LARGE__
/* #error modele de memoire incorrect : LARGE necessaire sous MSDos */
#endif

#define  MS_DOS
#define  SECU_ALLOC   16       /* 16 for PC */
#define  MAX_ALLOC 65520L      /* 64kO-16 for PC */

#else
  	 /* ANSI defined prototypes not known in K.R. (SUN3.5) */
#define  NO_PROTO
#define  SECU_ALLOC   0       /* 16 for PC */
#define  MAX_ALLOC 500000L    /* 500 k dans le meme tableau, par exemple */
#endif
 


/* #define T_HKL 1 */


#ifdef   NO_PROTO
#define  PROTO(a)  ()
#define  P_(a)

#else
#define  PROTO(a)  a
#define  P_(a)     a

#include <stdlib.h>
#include <stdarg.h>
#endif

#include <stdio.h>
#include <values.h>
#include <math.h>
#include <ctype.h>
#include <string.h>

#define  VERS       "XhklSTAT 0.8"
#ifndef  __DATE__
#define	 __DATE__   "15/3/93"
#endif

#define  NAME_LG      200	/* string length */

#define  PROG_PATH ""
#define  EPSILON  1.0E-12	/* in some tests */

#ifndef LN_MAXFLOAT
#define  LN_MAXFLOAT  89.6	/* ln(MAXFLOAT) */
#endif

#define  RAD            ( M_PI / 180.0 )

typedef struct
{     char    nom[NAME_LG];
      char    systeme;
      char    holoedre;
      char    bravais;
      char    centro;
      char    nops;
      float   coef[12];    /* (xx, xy, xz, tx, yx......zz, tz ) * nops */
      }       SYMGRP;

typedef struct
{      float    matr[6];
       float    vect[3];
       }        SYMOP;

typedef struct
{      int h,k,l;
       float t;
       float fo;
       float eo;
       }       BRAGG;



 char  titre[NAME_LG];
 char  *str_time;
				     /*  file system */
 FILE  *list_fich;
 FILE  *coord_fich;
 FILE  *hkl_fich;
 FILE  *rho_fich;

 SYMGRP *symgrp;
 BRAGG  *hkl,*l_hkl;
				   /* actual parameters */
int    lambda,phase,mode;
int    n_hkl,m_hkl;
float  ztotal, volume, lambda_val;



BRAGG   act;
#define H act.h
#define K act.k
#define L act.l
#define F act.fo
#define E act.eo
#define T act.t

#include <string.h>
#include <time.h>
/* ------------------------------------------------------------------ */

void termine PROTO((int cas, char * msg));

/* ------------------------------------------------------------------ */
void strup (P_(char *) string)
#ifdef NO_PROTO
char * string;
#endif
{	char *c;
	c = string;
	while (*c !=0)
	{	if (islower(*c)) *c = toupper(*c);
		c++;

	}	};

/* ------------------------------------------------------------------ */
#define  E_ALLOC "Allocation Memoire %u * %u : %s\n"

#ifndef NO_PROTO
void tst_abort (int test, char *format, ... )
{   char msg[80];
    va_list argptr;
    if (test)
    {    va_start (argptr, format);
	 vsprintf (msg,format, argptr);
	 va_end (argptr);
	 termine(2, msg);
    };   };
#else
#include <varargs.h>
void tst_abort (va_alist)
va_dcl
{   va_list args;
    int test;
    char *format;
    char msg[80];
    va_start (args);
    test = va_arg(args, int);
    if (test)
    {    format = va_arg(args, char *);
	 vsprintf (msg,format, args);
	 va_end (args);
	 termine(2, msg);
    };   };
#endif


void *tst_alloc (P_(int) nb, P_(int) size, P_(char *) name)
#ifdef NO_PROTO
int nb;
int size;
char *name;
#endif
{   void  *ptr;
    char msg[80];
    if (size * (long) nb > MAX_ALLOC)
    {    sprintf (msg," Alloc %d * %d %s > %l",nb,size,name,MAX_ALLOC);
	 termine (1,msg);
	 };
    if (nb && size) ptr = (void *) calloc (nb,size); else ptr = NULL;
    if (ptr==NULL && nb!=0)
	{    sprintf (msg,E_ALLOC,nb,size,name);
	while (ptr == NULL)
	{	nb = (nb * 3) / 4;
		ptr = (void *) calloc (nb,size);
		if (ptr != NULL)
		{   	 fprintf(list_fich," Memoire restante disponible pour %u elements de dimension %u\n",nb, size);	
			 termine (1, msg);
			}
		if (nb <= 2)
		{ 	fprintf (list_fich," Aucune memoire disponible\n");
			 termine (1, msg);
			}
	}	 };
    return ptr;
    };


/* ------------------------------------------------------------------ */

void fprint_xyz_pos (P_(FILE *) file, P_(float *) l_coef, P_(char) end_char)
#ifdef NO_PROTO
FILE *file;
float *l_coef;
char end_char;
#endif
{   int   i,j;
	float val;
	float *coef;
	int   num,deno,first;

	fprintf(file,"  ");
	for (j=0,coef=l_coef; j<3; j++,coef++)
	{   	first =1;
		for (i=0; i<4; i++)
		{   val = coef[3*i];
			if (fabs(val)>EPSILON)
			{   if (val>0) num = floor (val * 24 + EPSILON);
				else num = ceil (val*24 - EPSILON);
				deno = 24;
				while ((num%2==0) && (deno%2==0)) { num/=2; deno/=2; };
				while ((num%3==0) && (deno%3==0)) { num/=3; deno/=3; };
				if (i==3) fprintf (file,"%+d",num);
				else if (num==1) fprintf (file,"%s%c",first?"":"+",'X'+i);
				else if (num==-1) fprintf (file,"-%c",'X'+i);
				else fprintf (file,"%d%c",num,'X'+i);
				if (deno!=1) fprintf (file,"/%d",deno);
				first = 0;
				};
			 };
		if (j!=2) fprintf (file,", ");
		};
	fprintf (file,"%c",end_char);
	};

/* ------------------------------------------------------------------ */

void imprime_sym(P_(SYMGRP *) symgrp, P_(int) cas)
#ifdef NO_PROTO
SYMGRP *symgrp;
int cas;
#endif
{   int i;
    float *l_coef;

	if (cas) fprintf(list_fich," groupe de symetrie '%s'\n", symgrp->nom);
	fprintf(list_fich, " systeme %c holoedrie %d, %d %s, %d operations \n",
		symgrp->systeme,symgrp->holoedre, symgrp->centro,
		symgrp->centro==1?"(-x,-y,-z) * ":"NonCentro",symgrp->nops);
	for (i=0,l_coef=symgrp->coef; i<symgrp->nops; i++,l_coef+=12)
    {   fprintf (list_fich," #%2d ",i);
		fprint_xyz_pos (list_fich, l_coef, '\n');
		 };
    fprintf(list_fich,"\n");
    };

/* ------------------------------------------------------------------ */

void analyse_xyz_pos(P_(char *) ligne, P_(float *) l_coef, P_(SYMGRP *) l_sym)
#ifdef NO_PROTO
char *ligne;
float *l_coef;
SYMGRP *l_sym;
#endif
{   float  num,deno;
    int    div,dig,sig;
	int    j;
    char   *ligne_p,car;

	if (strlen(ligne)>=NAME_LG) ligne[NAME_LG-1]=0;
	strup (ligne);
	ligne_p=ligne;
	num = deno = 0;
	j = dig = div = 0;
	sig = 1;
	while ((car= *ligne_p)!=0)
	{   ligne_p++;
		if (isdigit(car))
		{   dig++;
			if (div==0) num = num*10+car-'0';
			else deno = deno*10+car-'0';
			}
	     else if (car=='/')
	     {   if (num==0) num = 1;
			 div=1;
			 }
	     else switch (car)
		 {   case 'X' :
			 case 'Y' :
			 case 'Z' : if (div!=0) num /= deno;
						if (num==0) num = 1;
						l_coef [j+3*(car-'X')] = sig*num;
						sig = 1; num=deno=0; div=0;
						break;
			 case ',' :
			 case '-' :
			 case '+' : if (div!=0)  num /= deno;
						if (num!=0) l_coef [j+9] = sig*num;
						num=deno=0; div=0;
						sig = car=='-'?-1:1;
						if (car==',') j++;
						break;
			 default  : if (car!=' ')
						{  if (l_sym!=NULL) fprintf (list_fich," Groupe '%s'",l_sym->nom);
						   fprintf(list_fich,"  Erreur interpretation de '%c' dans '%s'\n",
							  car,ligne);
						   };
			 };
		};
	if (div!=0)  num /= deno;
	if (num!=0) l_coef [j+9] = sig*num;
	};

/* ------------------------------------------------------------------ */

SYMGRP *lecture_sym (P_(FILE *) file)
#ifdef NO_PROTO
FILE *file;
#endif
{   char  ligne[60], copie[60];
    int   i,j;
    char  systeme,bravais;
    int   holo,centro,nops;
    float  *l_coef;
    SYMGRP *l_sym;

    fscanf(file,"  %s %[CQHTROMNA] %d%d%d",ligne,copie,&holo,&centro,&nops);
    if (strlen(ligne)>=NAME_LG) ligne[NAME_LG-1]=0;
    systeme = copie[0];
    bravais = ligne[0];
    strup(ligne);
    l_sym = (SYMGRP *)tst_alloc(1,sizeof(SYMGRP)+12*(nops-1)*sizeof(float), "symgrp");
    strcpy(l_sym->nom,ligne);
    l_sym->systeme=systeme;
    l_sym->holoedre=holo;
    l_sym->bravais=bravais;
    l_sym->centro=centro;
    l_sym->nops=nops;
    for (j=0,l_coef=l_sym->coef;j<nops*12;j++,l_coef++) *l_coef = 0;
    for (i=0,l_coef=l_sym->coef;i<nops;i++,l_coef+=12)
	{   fscanf(file," %[^;\n]%*[;\n]",ligne);
		analyse_xyz_pos (ligne, l_coef, l_sym);
		};
    return(l_sym);
    };

/* ------------------------------------------------------------------ */
int lecture_hkl (P_(int) pos)
#ifdef NO_PROTO
int pos;
#endif
{   int   p,l;
    float io,ic,fa,fb;
    float mu,orien,cor,dphi;
    BRAGG *deb,*bragg;
    int    hh,kk,ll;
    int     ii,i,j,n;
    float    *l_coef;
    do
	{   i = fscanf (hkl_fich,
" %*d %*[(]%d%*[)]%d%d%d %*[(]%d%*[)]%f %*c%f%f %*[(]%f%f%*[)]%*f%*f%*f%*f%f%f%f %*[^\n]",
	   &p,&H,&K,&L,&l,&T,&io,&ic,&fa,&fb,&mu,&orien,&cor);
#ifdef T_HKL
	  fprintf  (list_fich," (%d) %d %d %d (%d) %.3f Io %.1f %.1f  F %.2f %.2f\n",p,H,K,L,l,T,io,ic,fa,fb);
#endif
	if (i != 13 && !feof(hkl_fich) )
	{ 	fprintf (list_fich,"Erreur lecture hkl %d (%d,%d,%d) %.3f %.1f %d valeurs lues \n",pos,H,K,L,T,io,i);
		printf ("Erreur lecture hkl %d\n",pos);
		return (0);   };
	if (i == -1 || feof(hkl_fich) )
	{ 	return (0);   };
	        }
    while ((p!=phase || l!=lambda) && !feof(hkl_fich));
    if (p!=phase || l!=lambda) return (0);
	if (io<=0) io=0;

    F=sqrt(io/mu*orien*cor);
#ifdef T_HKL
	  fprintf  (list_fich," F %f cor %f\n", F, cor);
#endif
	 
    *l_hkl = act;
    deb = l_hkl;
    l_hkl++;
    n=1;
    for (i=0,l_coef=symgrp->coef;i<symgrp->nops;i++,l_coef+=12)
    {   hh = l_coef[0] * H + l_coef[1] * K + l_coef[2] * L;
	kk = l_coef[3] * H + l_coef[4] * K + l_coef[5] * L;
	ll = l_coef[6] * H + l_coef[7] * K + l_coef[8] * L;
	ii=0;
	for (j=0,bragg=deb;j<n;j++,bragg++)
	   if (hh==bragg->h && kk==bragg->k && ll==bragg->l) ii++;
	if (ii==0)
	{    l_hkl->h = hh;
	     l_hkl->k = kk;
	     l_hkl->l = ll;
	     l_hkl->t = act.t;
	     l_hkl->fo = act.fo;
	     l_hkl->eo = act.eo;
#ifdef T_HKL
	  fprintf  (list_fich," (%d) ajoute %d %d %d  dphi %f fo %f phi %f\n",n,hh,kk,ll,dphi,l_hkl->fo_abs,l_hkl->fo_phi);
#endif
	     l_hkl++;
	     n++;
	     };
	};
	return n;
  	};

/* ------------------------------------------------------------------ */

void read_init (P_(int) argn, P_(char **) argv)
#ifdef NO_PROTO
int argn;
char **argv;
#endif
{    char   file_name[NAME_LG];
     int i, nl_hkl;

	if (argn < 2)
	{   printf ("Usage : '%s data_file'   consulter '%sxhklstat_doc.d'\n", 
		argv[0],PROG_PATH);
		exit (3);
		};

       coord_fich = fopen ( argv[1], "rt");
       printf ("\n %s : %s (%s)\n",argv[0],VERS,__DATE__);
	if (coord_fich==NULL)
	{	printf(" Impossible d'ouvrir '%s'\n",argv[1]);
		exit (3);
		}
    fscanf (coord_fich," %[^\n]%*[\n] %[^\n]",titre,file_name);

    list_fich = freopen ( file_name, "w",stderr);
    if (list_fich==NULL)
    {    printf (" Impossible d'ouvrir le listing '%s'\n",file_name);
	   exit (3);
	   };
    fprintf (list_fich," %s : %s (%s) :  %s\n\n fichiers '%s' --> '%s ':  %s",
	    argv[0],VERS,__DATE__,titre,argv[1],file_name,str_time);

    i = fscanf  (coord_fich,"%f%f%f%d%d%d",
	      &ztotal,&volume,&lambda_val,&nl_hkl,&phase,&lambda);
    fprintf (list_fich," ztotal %f  volume %.1f  lambda %.4f\n\
 %d HKL a lire : Phase # %d lambda # %d\n",
 ztotal,volume,lambda_val,nl_hkl,phase,lambda);
	tst_abort ((i<6),"  ERREUR lecture param init (1-6)");
  if (volume <= 0) volume = 1;
  if (ztotal <= 0) ztotal = 1;
  if (lambda_val <= 0) lambda_val = 1;
  
    fscanf (coord_fich," %[^\n]%*[n]",file_name);
    hkl_fich = fopen ( file_name, "rt");
    if (hkl_fich==NULL)
    {    printf (" impossible d'ouvrir hkl :'%s'\n",file_name);
	   exit (3);
	   };
    fprintf (list_fich," fichier HKL : %s\n",file_name);
   fflush (list_fich);

   symgrp = lecture_sym (coord_fich);
   imprime_sym (symgrp, 1);
   fflush (list_fich);

   m_hkl =  (nl_hkl+1)*symgrp->nops;
   n_hkl=0;
   fprintf(list_fich," %d HKL reserves\n",m_hkl);
   l_hkl =  hkl = (BRAGG *) tst_alloc (m_hkl,sizeof(BRAGG),"bragg");
   fscanf (hkl_fich," %[^\n]%*[\n] %*[^\n]%*[\n]",file_name);
   fprintf(list_fich," HKL : %s\n",file_name);
   for (i=0;i<nl_hkl && !feof(hkl_fich);i++) n_hkl += lecture_hkl (i);
   fprintf(list_fich," %d HKL utilises \n",n_hkl);
   fflush (list_fich);
   fflush(list_fich);
   };


long  secs_start;

void   normalise PROTO((void));
void   statistique ();

void main (P_(int) argn, P_(char **) argv)
#ifdef NO_PROTO
int argn;
char **argv;
#endif
{   int i,j,n,ix,iy,iz;

    time (&secs_start);
    str_time= ctime(&secs_start);

    read_init (argn, argv);
    
    normalise ();
    
    statistique ( 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, "hkl");
    
    statistique ( 1, 0, 0, 2, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, "hkl, h=2n");
    statistique ( 1, 0, 0, 2, 1, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, "hkl, h!=2n");
    statistique ( 0, 1, 0, 2, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, "hkl, k=2n");
    statistique ( 0, 1, 0, 2, 1, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, "hkl, k!=2n");
    statistique ( 0, 0, 1, 2, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, "hkl, l=2n");
    statistique ( 0, 0, 1, 2, 1, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, "hkl, l!=2n");

    statistique ( 0, 1, 1, 2, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, " A ");
    statistique ( 0, 1, 1, 2, 1, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, " !A ");
    statistique ( 1, 0, 1, 2, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, " B ");
    statistique ( 1, 0, 1, 2, 1, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, " !B ");
    statistique ( 1, 1, 0, 2, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, " C ");
    statistique ( 1, 1, 0, 2, 1, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, " !C ");
    statistique ( 1, 1, 1, 2, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, " I ");
    statistique ( 1, 1, 1, 2, 1, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, " !I ");
    statistique ( 1, 1, 0, 2, 0, 1, 0, 1, 2, 0, 0, 1, 1, 2, 0, " F ");

    statistique ( 0, 1, 0, 0, 0, 1, 0, 0, 2, 0, 0, 0, 0, 1, 0, " h0l , h= 2n");
    statistique ( 0, 1, 0, 0, 0, 1, 0, 0, 2, 1, 0, 0, 0, 1, 0, " h0l , h= !2n");
    statistique ( 0, 1, 0, 0, 0, 0, 0, 1, 2, 0, 0, 0, 0, 1, 0, " h0l , l= 2n");
    statistique ( 0, 1, 0, 0, 0, 0, 0, 1, 2, 1, 0, 0, 0, 1, 0, " h0l , l= !2n");
    statistique ( 0, 1, 0, 0, 0, 1, 0, 1, 2, 0, 0, 0, 0, 1, 0, " h0l , h+l= 2n");
    statistique ( 0, 1, 0, 0, 0, 1, 0, 1, 2, 1, 0, 0, 0, 1, 0, " h0l , h+l= !2n");
    
    statistique ( 0, 0, 1, 0, 0, 1, 0, 0, 2, 0, 0, 0, 0, 1, 0, " hk0 , h= 2n");
    statistique ( 0, 0, 1, 0, 0, 1, 0, 0, 2, 1, 0, 0, 0, 1, 0, " hk0 , h= !2n");
    statistique ( 0, 0, 1, 0, 0, 0, 1, 0, 2, 0, 0, 0, 0, 1, 0, " hk0 , lk= 2n");
    statistique ( 0, 0, 1, 0, 0, 0, 1, 0, 2, 1, 0, 0, 0, 1, 0, " hk0 , lk= !2n");
    statistique ( 0, 0, 1, 0, 0, 1, 1, 0, 2, 0, 0, 0, 0, 1, 0, " hk0 , h+k= 2n");
    statistique ( 0, 0, 1, 0, 0, 1, 1, 0, 2, 1, 0, 0, 0, 1, 0, " hk0 , h+k= !2n");
    
    statistique ( 1, 0, 0, 0, 0, 0, 1, 0, 2, 0, 0, 0, 0, 1, 0, " 0kl , k= 2n");
    statistique ( 1, 0, 0, 0, 0, 0, 1, 0, 2, 1, 0, 0, 0, 1, 0, " 0kl , k= !2n");
    statistique ( 1, 0, 0, 0, 0, 0, 0, 1, 2, 0, 0, 0, 0, 1, 0, " 0kl , l= 2n");
    statistique ( 1, 0, 0, 0, 0, 0, 0, 1, 2, 1, 0, 0, 0, 1, 0, " 0kl , l= !2n");
    statistique ( 1, 0, 0, 0, 0, 0, 1, 1, 2, 0, 0, 0, 0, 1, 0, " 0kl , k+l= 2n");
    statistique ( 1, 0, 0, 0, 0, 0, 1, 1, 2, 1, 0, 0, 0, 1, 0, " 0kl , k+l= !2n");
    
    statistique ( 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 2, 0, " h00 , h= 2n");
    statistique ( 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 2, 1, " h00 , h!= 2n");
    statistique ( 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 2, 0, " 0k0 , k= 2n");
    statistique ( 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1, 0, 2, 1, " 0k0 , k!= 2n");
    statistique ( 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 2, 0, " 00l , l= 2n");
    statistique ( 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 2, 1, " 00l , l!= 2n");
    
    termine (0, "");
    };

void termine (P_(int) cas, P_(char *) msg)
#ifdef NO_PROTO
int cas;
char *msg;
#endif
{   long secs_now;
    time (&secs_now);
    str_time = ctime (&secs_now);
	fprintf (list_fich,"\n %s %s \n duree %lds STOP %d,  %s\n\n",cas==0?"":"ERROR",
	      msg,secs_now-secs_start,cas,str_time);
    printf ("\n %s %s \n duree %lds STOP %d, %s",cas==0?"":"ERROR",
	      msg,secs_now-secs_start,cas,str_time);
    fclose (list_fich);
    exit (cas);
    };


void normalise ()
{  int i;
    float echelle, sum_f;
    
    sum_f = 0;
    l_hkl = hkl;
    for (i=0; i<n_hkl; i++, l_hkl++)
    {    sum_f += l_hkl->fo;
         l_hkl->eo = l_hkl->fo;
         }
    echelle = ztotal /sum_f;
    l_hkl = hkl;
    for (i=0; i<n_hkl; i++, l_hkl++)
    {    sum_f += l_hkl->fo;
         l_hkl->eo = echelle * l_hkl->fo;
         }
   
    fprintf (list_fich," la somme des %d fo est %f\n", n_hkl, sum_f);


    };

void statistique ( h1, k1, l1, mod1, res1, h2, k2, l2, mod2, 
                   res2, h3, k3, l3, mod3, res3, text)
int h1, k1, l1, mod1, res1;
int h2, k2, l2, mod2, res2;
int h3, k3, l3, mod3, res3;
char *text;
{
    int i, nb, hkl_sum;
    int ok1, ok2, ok3;
    float f_min, f_max, f_moy, e_min, e_max, e_moy;
    f_min= f_max= f_moy= e_min= e_max= e_moy = 0;
    nb = 0;
    
    fprintf (list_fich, "\ncondition(s):%s\n", text);
    ok1 =  ( abs(h1) + abs(k1) +abs(l1) + abs(res1) != 0);
    if ( ok1 )
    {   if (mod1 != 0) fprintf(list_fich, " (%d * h +% d * k + %d * l) %% %d == %d\n", 
        h1, k1, l1, mod1, res1);
        else  fprintf(list_fich, " (%d * h +% d * k + %d * l) == %d\n", 
        h1, k1, l1, res1);
        }
    ok2 = ( abs(h2) + abs(k2) +abs(l2) + abs(res2) != 0);
    if ( ok2 )
    {
       if (mod2 != 0)fprintf(list_fich, " (%d * h +% d * k + %d * l) %% %d == %d\n", 
        h2, k2, l2, mod2, res2);
        else  fprintf(list_fich, " (%d * h +% d * k + %d * l) == %d\n", 
        h2, k2, l2, res2);
        }
    ok3 = ( abs(h3) + abs(k3) +abs(l3) + abs(res3) != 0);
    if (ok3 )
    {   if (mod3 != 0 )    fprintf(list_fich, " (%d * h +% d * k + %d * l) %% %d == %d\n", 
        h3, k3, l3, mod3, res3);
        else  fprintf(list_fich, " (%d * h +% d * k + %d * l) == %d\n", 
        h3, k3, l3, res3);
        }
    l_hkl = hkl;
    for (i=0; i<n_hkl; i++, l_hkl++)
    {    
         if ( ok1 )
         {   hkl_sum = h1 * l_hkl->h + k1 * l_hkl->k + l1 * l_hkl->l;
             if ( mod1 != 0 ) hkl_sum %= mod1; 
             if ( hkl_sum < 0 ) hkl_sum += mod1;
             if ( hkl_sum != res1 ) continue;
             }
         if ( ok2 )
         {   hkl_sum = h2 * l_hkl->h + k2 * l_hkl->k + l2 * l_hkl->l; 
             if ( mod1 != 0 ) hkl_sum %= mod1; 
             if ( hkl_sum < 0 ) hkl_sum += mod2;
             if ( hkl_sum != res2 ) continue;
             }
         if ( ok3 )
         {   hkl_sum = h3 * l_hkl->h + k3 * l_hkl->k + l3 * l_hkl->l; 
             if ( mod3 != 0 ) hkl_sum %= mod3; 
             if ( hkl_sum < 0 ) hkl_sum += mod3;
             if ( hkl_sum != res3 ) continue;
             }
         nb++;
         if (nb == 1 || l_hkl->fo <f_min) f_min = l_hkl->fo;
         if (nb == 1 || l_hkl->eo <e_min) e_min = l_hkl->eo;
         if (nb == 1 || l_hkl->fo >f_max) f_max = l_hkl->fo;
         if (nb == 1 || l_hkl->eo >e_max) e_max = l_hkl->eo;
         f_moy += l_hkl->fo;
         e_moy += l_hkl->eo;
         
         }
    if (nb > 0)
       fprintf (list_fich, " %d hkl      <f> %.2f (%.2f, %.2f)       <e> %.2f (%.2f, %.2f)\n",
                nb, f_moy/nb, f_min, f_max, e_moy, e_min, e_max);
    else
        fprintf (list_fich, " pas de raies pour ce critere\n");            

};
