/* XND_BLK  Preparations des blocs rigides, transparents ensuite */

#include "xnd_def.h"
#include "xnd_cah.h"

typedef float VEC3  [3];
typedef VEC3  MAT33 [3];

/* du repere ortho x, y=b*, z=c au repere relatif a, b, c */
/*static void ch_base (P_(float) base P_([3][3]) )  */
static void ch_base (P_(MAT33) base )
#ifdef NO_PROTO
MAT33 base;
#endif
{  float angle, bx;
   float s_b, c_b, c_a, c_c;
   float a, b, c;

   VAR_init (&l_phase->cell);
   a = var_valeur(1);
   b = var_valeur(2);
	c = var_valeur(3);
   angle = RAD * var_valeur(4);
   c_a = cos (angle);
   angle = RAD * var_valeur(5);
   c_b = cos (angle);
   s_b = sin (angle);
   angle = RAD * var_valeur(6);
   c_c = cos (angle);
   angle = sqrt(1 - (c_a*c_a + c_c*c_c - 2 *c_a*c_b*c_c) /(s_b*s_b));
   bx = (c_c - c_a *c_b)/s_b;
   base[1][2] = base[1][0] =  base[0][2] = 0;
   base[0][0] = 1/(a * s_b);
   base[0][1] = -base[0][0] * bx / angle;
   base[1][1] = 1/(b * angle);
   base[2][0] = -c_b/(c * s_b);
   base[2][1] = (c_b * bx / s_b  - c_a )/(c * angle);
   base[2][2] = 1/c;
   }

static float ligcol33 (P_(VEC3) mat, P_(VEC3) vect)
#ifdef NO_PROTO
VEC3 mat;
VEC3 vect;
#endif
{   return (mat[0]*vect[0]+mat[1]*vect[1]+mat[2]*vect[2]);
    }

static void mulmat33 ( P_(MAT33) mat, P_(MAT33) base, P_(MAT33) euler)
#ifdef NO_PROTO
MAT33 mat;
MAT33 base;
MAT33 euler;
#endif
{  int i,j,k;
	for (i=0;i<3;i++)for (j=0;j<3;j++)
	{  mat[i][j]=0;
		for (k=0;k<3;k++) mat[i][j] += base[i][k] * euler[k][j];
      }
   }

void ini_euler (P_(MAT33)mat, P_(MAT33)mat_dt, P_(MAT33)mat_dp,
		 P_(MAT33)mat_dq, P_(MAT33)base, P_(int)b_deb)
#ifdef NO_PROTO
MAT33 mat, mat_dt, mat_dp, mat_dq;
MAT33 base;
int b_deb;
#endif
{  int i,j;
   float angle,c_tet,s_tet,c_phi,s_phi,c_psi,s_psi;
	MAT33 euler;
   angle = RAD * var_valeur(3+b_deb);
   c_tet = cos(angle); s_tet = sin(angle);
   angle = RAD * var_valeur(4+b_deb);
   c_phi = cos(angle); s_phi = sin(angle);
	angle = RAD * var_valeur(5+b_deb);
   c_psi = cos(angle); s_psi = sin(angle);
   euler[0][0] = c_phi * c_psi - s_phi * s_psi * c_tet;
   euler[0][1] = -c_phi * s_psi - s_phi * c_psi * c_tet;
   euler[0][2] = s_phi * s_tet;
   euler[1][0] = s_phi * c_psi + c_phi * s_psi * c_tet;
   euler[1][1] = -s_phi * s_psi + c_phi * c_psi * c_tet;
   euler[1][2] = -c_phi * s_tet;
   euler[2][0] = s_psi * s_tet;
	euler[2][1] = c_psi * s_tet;
   euler[2][2] = c_tet;
	mulmat33 (mat, base, euler);
   if (fini) return;
/* derivee en teta */
	euler[0][0] = s_phi * s_psi * s_tet;
	euler[0][1] = s_phi * c_psi * s_tet;
	euler[0][2] = s_phi * c_tet;
   euler[1][0] = -c_phi * s_psi * s_tet;
   euler[1][1] = -c_phi * c_psi * s_tet;
   euler[1][2] = -c_phi * c_tet;
   euler[2][0] = s_psi * c_tet;
   euler[2][1] = c_psi * s_tet;
   euler[2][2] = -s_tet;
   for (i=0;i<3;i++)for (j=0;j<3;j++,mat++) euler[i][j] *= RAD;
   mulmat33 (mat_dt, base, euler);
/* derivee en phi */
   euler[2][0] = euler[2][1] = euler[2][2] = 0;
   euler[0][0] = -s_phi * c_psi - c_phi * s_psi * c_tet;
   euler[0][1] = s_phi * s_psi - c_phi * c_psi * c_tet;
   euler[0][2] = c_phi * s_tet;
   euler[1][0] = c_phi * c_psi - s_phi * s_psi * c_tet;
   euler[1][1] = -c_phi * s_psi - s_phi * c_psi * c_tet;
   euler[1][2] = s_phi * s_tet;
   for (i=0;i<3;i++)for (j=0;j<3;j++,mat++) euler[i][j] *= RAD;
	mulmat33 (mat_dp, base, euler);
/* derivee en psi */
   euler[2][2] =  euler[1][2] =  euler[0][2] = 0;
   euler[0][0] = -c_phi * s_psi - s_phi * c_psi * c_tet;
	euler[0][1] = -c_phi * c_psi - s_phi * s_psi * c_tet;
   euler[1][0] = -s_phi * s_psi + c_phi * c_psi * c_tet;
   euler[1][1] = s_phi * c_psi - c_phi * s_psi * c_tet;
	euler[2][0] = c_psi * s_tet;
   euler[2][1] = -s_psi * s_tet;
   for (i=0;i<3;i++)for (j=0;j<3;j++,mat++) euler[i][j] *= RAD;
   mulmat33 (mat_dq, base, euler);
   }

static i0[6] = { 0, 1, 2, 0, 0, 1 };
static i1[6] = { 0, 1, 2, 1, 2, 2 };

void ini_blk(P_(int) print_code)
#ifdef NO_PROTO
int print_code;
#endif
{  int a,b,i,j,k,l,n,ip;
   int b_dim, b_deb, b_ord;
   int o_dim, o_siz, o_ord;
   int r_dim, r_siz, r_ord, rb_dim;
	MAT33 mat, mat_dt, mat_dp, mat_dq;
	MAT33 base;
   VEC3  orig;
   float x_ortho[COORD_DIM];
	float *d_mat[3];
   float *v, *s;
   int   *p;
   ATOM *relat, *ortho;
	d_mat[0] = mat_dt[0];
   d_mat[1] = mat_dp[0];
   d_mat[2] = mat_dq[0];
	ch_base (base);
   l_bloc= &l_phase->bloc;
   for (b=0;b<l_phase->nb_bloc;b++)
   {   VAR_init(l_bloc);
       b_ord = l_bloc->ordre;
       b_dim = l_bloc->dim;
       b_deb = b * 6;
/* calcul du nombre de parametres effectifs dus au bloc */
       rb_dim = 0;
       for (io=0;io<b_ord;io++)
       {   j = 0;
	   for (i=0;i<3;i++)
	   {  for (id=0,k=0;id<b_dim;id++) if (var_param(k+b_deb)) k++;
	      if (k > j) j = k;
	    }
	   for (id=0;id<b_dim;id++)
	   for (i=3;i<6;i++) if (var_param(i+b_deb)) j++;
	   if (j > rb_dim) rb_dim = j;
	   }
/* le calcul est fait a T, les termes du dev seront nul */
       for (j=0;j<3;j++) orig[j] = var_valeur(j+b_deb);
		 ini_euler (mat, mat_dt, mat_dp, mat_dq, base, b_deb);
       if (print_code)
       fprintf(list_fich,"\n Coordonnees relatives du bloc #%d\n",b);
		 l_phase->bl_relat[b] = relat =
				(ATOM *) tst_alloc(l_phase->bl_atom[b],sizeof(ATOM),"atomes");
       for (a=0,ortho=l_phase->bl_ortho[b];
		   a<l_phase->bl_atom[b]; a++,relat++,ortho++)
       {   *relat = *ortho;
	   VAR_init(&ortho->x);
	   o_siz = ortho->x.size;
	   o_dim = ortho->x.dim;
	   o_ord = ortho->x.ordre;
	   for (i=0;i<o_siz;i++) x_ortho[i] = var_valeur(i);
/* calcul du nombre de parametres effectifs dus a l'atome */
	   r_dim = 0;
	   for (io=0;io<o_ord;io++)
	   {   j = 0;
	       for (id=0;id<o_dim;id++)
	       for (i=0;i<3;i++) if (var_param(i)) j++;
	       if (j>r_dim) r_dim = j;
	       j = 0;
	       if (o_siz==10 || o_siz==13)
	       for (id=0;id<o_dim;id++)
	       for (i=4;i<10;i++) if (var_param(i)) j++;
	       if (j>r_dim) r_dim = j;
	       }
	   r_dim += rb_dim;
	   for (io=0;io<o_ord;io++)
	   {   k = 0;
	       for (id=0;id<o_dim;id++) if (var_param(3)) k++;
	       if (k>r_dim) r_dim = k;
	       k = 0;
	       if (o_siz==5 || o_siz==8)
	       for (id=0;id<o_dim;id++)
	       for (i=4;i<o_siz;i++) if (var_param(i)) k++;
	       if (k>r_dim) r_dim = k;
	       k = 0;
	       if (o_siz==13)
	       for (id=0;id<o_dim;id++)
	       for (i=10;i<13;i++) if (var_param(i)) k++;
	       if (k>r_dim) r_dim = k;
		}
	    if (r_dim==0) r_dim += 1;
	    relat->x.ordre = r_ord = (b_ord > o_ord )? b_ord : o_ord;
	    relat->x.dim = r_dim;
	    relat->x.size = r_siz = o_siz;
	    l = r_dim *  (k = r_siz * r_ord);
	    relat->x.value = v = (float *) tst_alloc (k,sizeof(float),"var");
	    relat->x.shift = (float *) tst_alloc (l,sizeof(float),"var");
	    relat->x.param = (int *) tst_alloc (l,sizeof(int),"var");
/* calculs des valeurs en coordonnees relatives */
	    for (i=0;i<r_siz;i++)
/* pour x,y,z */
	    {  if (i<3) *v = orig[i] + ligcol33 ( mat[i], x_ortho);
	       else if (i>=4 && (o_siz == 10 || o_siz == 13))
/* pour bij */
	       {   k = i -4;
	           *v = 0;
	           for (l=0; l<3;l++)
		   *v += mat[i0[k]][i0[l]] * mat[i1[k]][i1[l]] * x_ortho[4+l];
	           for (l=3; l<6;l++)
		   *v += 2 * mat[i0[k]][i0[l]] * mat[i1[k]][i1[l]] * x_ortho[4+l];
		   }
/* t ou b */
	       else *v = x_ortho[i];
	       v++;
	       for(j=1;j<r_ord;j++,v++) *v = 0;
	       } ;
/* composantes pour le calcul des derivees */
	    if (!fini || minli != 0)
	    {  for (i=0;i<r_siz;i++) for (io=0;io<r_ord;io++)
   	    {  ip = (i * r_ord + io ) * r_dim;
   	       s = relat->x.shift + ip;
   	       p = relat->x.param + ip;
   	       ip = 0;
   	       *s = *p = 0;
	       if (i<3)
/* sur les coordonnees */
	       {   VAR_init (l_bloc);
	           for (id=0;id<b_dim;id++)
	           if ((n=var_param(i+b_deb))!=0)
	           {   *p = n;
		       *s = var_shift();
		       ip++; *(++s) = 0; *(++p )= 0;
		       }
	           for (id=0;id<b_dim;id++) for (j=3;j<6;j++)
	           if ((n=var_param(j+b_deb))!=0)
	           {   *p = n;
				 *s = ligcol33(d_mat[j-3]+3*i, x_ortho) * var_shift();
		       ip++; *(++s) = 0; *(++p )= 0;
		       }
	           VAR_init (&ortho->x);
	           for (id=0;id<o_dim;id++) for (j=0;j<3;j++)
	           if ((n=var_param(j))!=0)
	           {   *p = n;
		       *s = (mat[0][i] + mat[1][i] + mat[2][i]) * var_shift();
		       ip++; *(++s) = 0; *(++p )= 0;
		       }
		    }
	       else if (i>=4 && (o_siz == 10 || (o_siz == 13 && i< 10)))
/* sur les bij */
	       {   k = i -4;
		   VAR_init (l_bloc);
	           for (id=0;id<b_dim;id++) for (j=3;j<6;j++)
	           if ((n=var_param(j))!=0)
	           {   *p = n;
	               *s = 0;
	                for (l=0; l<6;l++)
			*s += ( d_mat[j-3][3*i0[k]+i0[l]] * mat[i1[k]][i1[l]]
			    + mat[i0[k]][i0[l]] * d_mat[j-3][3*i1[k]+i1[l]] )
			   * x_ortho[4+l];
			*s *=  var_shift();
		        ip++; *(++s) = 0; *(++p )= 0;
		        }
		   VAR_init (&ortho->x);
	           for (id=0;id<o_dim;id++) for (j=4;j<10;j++)
	           if ((n=var_param(j))!=0)
	           {   *p = n;
		       *s = (mat[i0[k]][i0[j-4]] * mat[i1[k]][i1[j-4]])
		       		* var_shift();
		       ip++; *(++s) = 0; *(++p )= 0;
		       }
		   }
	       else
/* sur les t, b ... */
	       {   VAR_init (&ortho->x);
		   for (id=0;id<o_dim;id++) for (j=3;j<o_siz;j++)
	           if ((n=var_param(j))!=0)
	           {   *p = n;
		       *s = var_shift();
		       ip++; *(++s) = 0; *(++p )= 0;
  		       }
  		    }
/* on complete eventuellement par des 0 */		
	       for (k=ip+1;k<r_dim;k++)
	       {   *(s++) = *(p++) = 0;
		   }
 		}
  	     } /* if (!fini) for i et io */
	    else if (print_code)
	    {    fprintf (list_fich,"  %6s  x %7.4f  y %7.4f  z %7.4f  t %7.4f",
	   	 relat->nom,relat->x.value[0],relat->x.value[1],
	   	 relat->x.value[2],relat->x.value[3]);
	         if (o_siz==10 || o_siz == 13)
	         fprintf (list_fich,"\n     bij  %f   %f   %f   %f   %f   %f\n",
	               relat->x.value[4],relat->x.value[5],relat->x.value[6],
	               relat->x.value[7],relat->x.value[8],relat->x.value[9]);
	         else fprintf (list_fich," b  %f\n",relat->x.value[4]);
 		 }
	    } /* atom */
	if (print_code) fflush(list_fich);
       } /* bloc */
   }



void free_blk(P_(void))
{  int b,a;
   for (b=0;b<l_phase->nb_bloc;b++)
   {  for (a=0,l_atom=l_phase->bl_relat[b];a<l_phase->bl_atom[b];a++,l_atom++)
      {  free (l_atom->x.value);
	 free (l_atom->x.shift);
	 free (l_atom->x.param);
	 }
      free (l_phase->bl_relat[b]);
      }
   }

