/* XND_BRG  Calcul R_Bragg ... */

#include "xnd_def.h"
#include "xnd_cah.h"

#include <string.h>

/* ----------------------------------------------------------- */
#ifndef THINK_C
int compare_bragg(P_(const void *) p1, P_(const void *) p2)
#else
int compare_bragg(P_(void *) p1, P_(void *) p2)
#endif
#ifdef NO_PROTO
void *p1, *p2;
#endif
{   float dif;
    dif =  ((BRAGG *) p1)->dtheta - ((BRAGG *) p2)->dtheta;
    if (dif>0) return (1);
    if (dif<0) return(-1);
    return(0);
    }

/* ----------------------------------------------------------- */
#ifndef SEEK_SET
#define SEEK_SET 0
#endif

#define s_iobs  s[0]
#define s_di    d[0]
#define s_fobs  s[1]
#define s_df    d[1]
#define s_wiobs s[2]
#define s_wdi   d[2]
#define s_wfobs s[3]
#define s_wdf   d[3]
#define n_i     n[0]
#define n_f     n[1]

void residu_hkl(P_(void))
{   int   i, j, pos;
    int   num_phase, nombre;
    float ic,pobs,pcal,dd,assym;
    float iobs,iobs1,iobs2,ic2;
    float wobs, wi1, wi2, wdf;
    float fobs, pfobs;
    float s[4];
    float d[4];
    int   n[4];
    float *s_phase, *d_phase;
    float dg, dl, ratio;
    float swbg, swobs;
    BRAGG *bragg, *l_bragg;
    int   *m_phase;
    int  fprecis, iprecis;
    int  atomique;
    char qualite;
    char txt[15];
    float c_bragg_repart = 1. - bragg_repart;
    int n_strong = 0;
    
    push_err_msg("function residu_hkl");
    fprintf (list_fich, "\n");
    ini_res_brg (n , s, d);

    if (tot_phase>1)
    {   s_phase = (float *) tst_alloc(4*tot_phase,sizeof(float),
							  "R Bragg phase");
	d_phase = (float *) tst_alloc(4*tot_phase,sizeof(float),
							  "R Bragg phase");
	m_phase = (int *) tst_alloc(4*tot_phase,sizeof(int),"R Bragg phase");
	}

    if (dim_bragg > MAX_ALLOC / sizeof(BRAGG))
	 {   fprintf (list_fich," Too much Bragg lines for allocating memory : %d",
	dim_bragg);
	dim_bragg = MAX_ALLOC / sizeof (BRAGG);
	fprintf (list_fich, " truncated at %d\n", dim_bragg);
	}

    l_bragg = bragg = (BRAGG *) malloc(dim_bragg*sizeof(BRAGG));
    if (l_bragg == NULL)
	 {    fprintf (list_fich,"enable to allocate memory for Bragg calculation\n");
	 return;
	 }
	 if (fseek(bragg_fich, 0, SEEK_SET)!=0)
	 {    fprintf (list_fich,"seek error in the Bragg file\n");
	 return;
	 }
    for (i=0;i<dim_bragg;i++,l_bragg++)
	if (fread (l_bragg,sizeof(BRAGG),1,bragg_fich) !=1)
	{    fprintf (list_fich,"error reading Bragg file\n");
	     return;
	     }

    l_bragg = bragg;
    qsort (l_bragg, dim_bragg, sizeof(BRAGG), compare_bragg);

    if (prt_hkl) 
    {   fprintf (hkl_fich,"#%s a %f\n#     p   h  k  l      2theta    i_obs i_calc (   f_a     f_b )",
            l_exper->nom,l_diag->temp);
	if (dif_nature == EXPER_RXA) fprintf (hkl_fich,"( fano_a fano_b )");
	fprintf (hkl_fich,"   w_l   w_g    as_1 as_3 mu orien cor d_hkl   s_i\n");
       }
    for (i=1, l_bragg = bragg; i<=dim_bragg; i++,l_bragg++)
    {    nombre = 0;
	 ic = iobs1 = iobs2 = ic2 = swobs = 0;
	 act = *l_bragg;
	 ini_profil ();
	 if (influence)
	 {    pos = act.deb;
	      l_points = &l_diag->points[pos];
	      if (pos<n_pts)
	      while (pos<=act.fin)
	      {   dt = *l_points-DTH;
		  pcal = profil();
		  pobs = get_iobs(pos) - (bg = get_back(pos));
		  dd = get_ical(pos);
		  pobs *= ratio =  (dd>EPSILON) ? pcal / get_ical(pos) : 1;
		  dg = (pos!=0) ? *l_points - *(l_points-1) : 0;
		  dl = (pos!=n_pts-1) ? *(l_points+1) - *l_points : 0;
		  if ((dl >0) && (dg > 2*dl) && (pos==act.deb)) dg = dl;
		  else  if ((dg >0) && (dl > 2*dg) && (pos==act.fin)) dl= dg;
		  dd = 0.5 * (dg+dl);
                  pobs *= dd;
                  pcal *= dd;
		  iobs1 += pobs;
		  iobs2 += pobs * pcal;
		  ic += pcal;
		  ic2 += pcal * pcal;
		  /* estimation large de s_iobs : ratio non utilise */
		  wobs = get_wght(i);
		  if ( wobs > 0 ) swobs += dd * dd / wobs;
		  l_points++;
		  nombre++;
		  pos++;
		  }
	      }
	 iobs1 /= ic;
	 iobs2 /= ic2;
	 iobs = I_C * ( bragg_repart * iobs1 + c_bragg_repart * iobs2);
         if ( swobs > 0 )
         {    swobs = I_C / ic * sqrt ( swobs );
              wobs = 1.0 / ( swobs * swobs ); 
              } else wobs = 0;
	 qualite = 'f';
	 if (iobs > 0)
	 {    j = floor(100.0 * fabs ((iobs1 -iobs2)/(iobs1+iobs)));
	      if (j < 1)  qualite =  'a';    /* 2% */
	      else if (j < 2) qualite = 'b';
	      else if (j < 4) qualite = 'c';
	      else if (j < 8) qualite = 'd';
	      else if (j < 16) qualite = 'e';
	      else qualite = 'f';
	      }
	 s_iobs += iobs;
	 s_di += pobs = (iobs>I_C) ? iobs - I_C : I_C - iobs;
         s_wiobs += wi1 = iobs * iobs * wobs;
         s_wdi += wi2 = pobs * pobs * wobs;
	 n_i++;
	 if (act.mu > 0) atomique = 1;
	 else
	 {   atomique = 0;
	     act.mu = - act.mu;
	     }
	 if (atomique && iobs > 0)
	 {    ratio = act.mu *act.cor* act.orien* act.ech;
              fobs = sqrt ( iobs / ratio);
	      s_fobs += fobs;
	      s_df += pfobs = fabs ( fobs - sqrt(F_A * F_A + F_B * F_B));
	      n_f++;
              swbg = 4 * wobs * iobs * ratio;
              s_wdf += wdf = swbg * pfobs * pfobs;
              s_wfobs += swbg *= fobs * fobs;
	      }
	 if (tot_phase>1)
	 {  num_phase = 4 * act.phase;
            m_phase[num_phase]++;
	    d_phase[num_phase] += pobs;
	    s_phase[num_phase] += iobs;
	    d_phase[2+num_phase] += wi2;
	    s_phase[2+num_phase] += wi1;
	    if (atomique && iobs > 0)
	    {   m_phase[1+num_phase]++;
		d_phase[1+num_phase] += pfobs;
		s_phase[1+num_phase] += fobs;
		d_phase[3+num_phase] += wdf;
		s_phase[3+num_phase] += swbg;
		}
	    }
	 if (prt_hkl)
	 {  
             iprecis = (iobs >= 10000 || I_C >= 10000 ) ? 0 : 1; 
             fprecis = (l_exper->nature) ? 1 : 0;
	     fprintf (hkl_fich,"%4d (%d)%3d%3d%3d (%d) %7.3f %c %6.*f %6.*f (%7.*f %7.*f)",
	     i, act.phase, H, K, L, act.lambda, DTH, qualite, iprecis, iobs, iprecis, I_C,
             fprecis, F_A, fprecis, F_B);
	     if (dif_nature == EXPER_RXA) fprintf (hkl_fich,"(%7.*f %7.*f)",
	     fprecis, act.f_am, fprecis, act.f_bm);
	     fprintf (hkl_fich,"  %5.3f %5.3f  % 5.2f% 5.2f %2d %4.2f %4.*f %6.*f %4.1f %6.2f%6.2f\n",
	     W_L, W_G, act.assym[0], act.assym[1], act.mu, act.orien, 
             act.cor > 10.0 ? 1 : 2 , act.cor,act.dist > 10.0 ? 3 : 4 , act.dist, 
             swobs, l_diag->points[act.deb], l_diag->points[act.fin]);
             }
	 for (j = 0, assym = 0; j < max_assym; j++) assym += fabs(act.assym[j]);
	 if ( fabs(assym) > 1 && n_strong < 3 )
	 {    n_strong++;
	      fprintf (list_fich,"ASSYM : %4d (%d)%3d%3d%3d (%d) %7.3f assym ",
	        i, act.phase, H, K, L, act.lambda, DTH);
	      for (j = 0; j < max_assym; j++)  fprintf (list_fich," %5.2f ", act.assym[j]);
	      fprintf (list_fich," is strong, meaningless points may appear\n");
	      if (n_strong == 3) fprintf (list_fich,"ASSYM : further warning not printed\n\n");
	      }
	 }
    if (tot_phase>1)
    {    for (i=0;i<tot_phase;i++)
	{    sprintf (txt, "  PHASE #%d", i);
	     put_res_brg (list_fich, txt, m_phase+4*i, s_phase+4*i, d_phase+4*i);
	     }
	 free(s_phase);
	 free(m_phase);
	 }

    put_res_brg (list_fich, "\n          ", n, s, d);

    for (i=0; i<4; i++)
    {    obrg_d[i] += d[i];
	 obrg_s[i] += s[i];
	 obrg_n[i] += n[i];
	 }
    pop_err_msg();
    }

/* ----------------------------------------------------------- */
void ini_res_brg (P_(int *) n, P_(float *) s, P_(float *) d)
#ifdef NO_PROTO
int * n;
float * s;
float * d;
#endif
{   int i;
     for (i=0; i < 4; i++)
     {   *(n++) = 0;
	 *(d++) = *(s++) = 0;
	 }
     }
/* ----------------------------------------------------------- */
void put_res_brg (P_(FILE *) file, P_(char *) txt, P_(int *) n, P_(float *) s, P_(float *) d)
#ifdef NO_PROTO
FILE * file;
char * txt;
int * n;
float * s;
float * d;
#endif
{    int i;
     char * c;
     c = txt;
     while (*c == '\n') c++;
     i = strlen(c);
 
     if (s[0] > 0) fprintf (file,
				"%s R_Bragg=%.4f (%3d hkl, S_I=%9.3g)   Rw_B=%.4f (S_wI=%9.3g)\n",
	       txt, d[0]/s[0],  n[0], s[0], sqrt(d[2]/s[2]), s[2]);
     else fprintf (file,"%s R_Bragg=***  (%3d hkl S_I=%.1f)\n",
	       txt, n[0], s[0]);
     if (n[1])
       if (s[1] > 0) fprintf (file,
			  "%*s Rf=%.4f     (%3d hkl, Sf=%9.3g)   Rwf=%.4f (S_wF=%9.3g)\n",
		 i, " ", d[1]/s[1], n[1], s[1], sqrt(d[3]/s[3]), s[3]);
     else fprintf (file,"%*s Rf=***      (%3d hkl, Sf=%.1f)\n",
		 i, " ", n[1], s[1]);
     }
/* ----------------------------------------------------------- */


