/*  XND_CAH.H   header for XND_CALcul, _PROfil, _HKL and _BACK modules */

EXTERN float  echelle, exper_echelle, phase_echelle;

				   /* diag actual parameters */
EXTERN int    i_lambda, i_eclair;
EXTERN int    dim_bragg;
EXTERN float  temp_exper;
EXTERN float  minimum;
EXTERN float  diag_p0, diag_pn;
EXTERN float  q_min,q_max;
EXTERN float  t_min,t_max;
EXTERN float  lambda, zero, centrage, eclair, polar;

 				   /* phase */
EXTERN int    cas_mag_mod;
EXTERN int    i_intens;
EXTERN int    deriv_atom;
EXTERN int    t_bragg,n_bragg,m_bragg;  /* total, non neglig, effect */
EXTERN int    org_orien;   /*current origine in orien functions */
EXTERN float  *d_echelle;
EXTERN float  bg;
EXTERN float  *orien_val, *orien_prof;

				    /* raie */
EXTERN float  influence;
EXTERN float  s;
EXTERN float  sin_t, cos_t;
EXTERN float  tan2, tan_2t, sin_2t, cos_2t, cos2_2t, tan_tm;
EXTERN float  x_orien, y_orien, z_orien;
EXTERN float  *fa_deriv, *fb_deriv, *fam_deriv, *fbm_deriv;
EXTERN float  *vecteur_deriv;
EXTERN float  t_assym, sin_a, sin_b, absorb, dcor_asym;
EXTERN float  fhkl_2;
EXTERN float  phase_wg, phase_wl;
EXTERN float  sign_onde, sign_instru0, sign_instru2, sign_phase;
				/* point */
EXTERN float  dt;
EXTERN float  d_p_t,d_p_l,d_p_g,d_p_a[MAX_ASSYM];
EXTERN float  dd_p_ll, dd_p_gg, dd_p_lg;



/*         prototype des fonctions                */
/*  --------------------------------------------- */
/* in XND_CAL.C  pattern and derivatives calculations */

void  traite_hkl PROTO(( void ));
float f_echelle PROTO(( int i, float *d) );
void  residu PROTO(( void));
/*  --------------------------------------------- */
/* in XND_BRG.C  R_Bragg */

void residu_hkl PROTO((void));
void ini_res_brg PROTO((int *n, float *s, float *d));
void put_res_brg PROTO((FILE *file, char *txt, int *n, float *s, float *d));

/*  --------------------------------------------- */
/* in XND_PRO.C  profil functions */

int  def_profil PROTO((void));
int  ini_profil PROTO((void));
float profil    PROTO((void));
void d_pil   PROTO((void));

/*  --------------------------------------------- */
/* in XND_BAC.C  the back_ground functions */
void inter_back  PROTO((void));
void spline_back PROTO((void));
void ini_back_ground PROTO((void));
EXTERN void (*back_ground) PROTO((void));

/*  --------------------------------------------- */
/* in XND_BLK.C  preparation des blocs rigides    */

void ini_blk PROTO((int print_code));
void free_blk PROTO((void));

/*  --------------------------------------------- */
/* in XND_HKL.C :  structure factors, gen hkl     */
	  /* redirection de fhkl_atom */
EXTERN int (*fhkl_eff) PROTO((int pos, int mul));
int  fhkl_atom PROTO((int pos, int mul));
	  /* redirection de hkl_std */
EXTERN void (*hkl_eff) PROTO((void));
void hkl_std PROTO((void));
void gen_hkl PROTO((void));
void get_hkl PROTO((void));

/*  --------------------------------------------- */
/* in XND_MOD.C : magnetic or modulated structure factors */
/* int  fhkl_magnet PROTO((int pos, int mul));    */
void hkl_modul    PROTO((void));
void magnet_hkl PROTO((void));
/*  --------------------------------------------- */
/* in XND_INC.C : incomensurate modulated structure factors */
 int  fhkl_incmod PROTO((int pos, int mul));     
/*  --------------------------------------------- */
/* in XND_COM.C : comensurate modulated structure factors */
 int  fhkl_commod PROTO((int pos, int mul));     

/*  --------------------------------------------- */
/* in XND_DIF.C :               fdif              */
 /* redirection de x_valdif ... */
EXTERN float (*valdif)PROTO((void));
float x_valdif PROTO((void));
float b_valdif PROTO((void));
float ux_valdif PROTO((void));
float ub_valdif PROTO((void));

void  ini_anodif PROTO((void));
float anodif PROTO((void));
float anodif_b PROTO((void));
float magdif PROTO((void));
/*  --------------------------------------------- */
/* in XND_COR.C : orientation, LP_cor             */
float f_orien PROTO((int n, int cas));
void ini_orientation PROTO((void));
void orientation PROTO((void));
void valcor PROTO((void));

/*  --------------------------------------------- */
/* in XND_MET.C : metric and bravais symmetry     */

void  ini_d_metrique PROTO((void));
float scalaire PROTO((float *u, float *gv, float *v));
float d_dmetric PROTO((int j, float *u, float *v));

int multiplicite PROTO((void));
void gen_holoedre PROTO((void));
int extinction PROTO((void));
/*  --------------------------------------------- */
/* in XND_UNC.C : uncoherent, diffuse...     */

void  gen_uncoherent  PROTO((void));
void  gen_tds     PROTO((void));
void  gen_tds_hkl PROTO((void));
