/* XND_CAL  Calcul Theta hkl ... */

#include "xnd_def.h"
#include "xnd_cah.h"

#ifndef _INCLUDE_HPUX_SOURCE
#include <time.h>
/* required for rand init */
#endif

#include <string.h>

/* ----------------------------------------------------------- */
static int search_first ( P_(FLOAT) valeur)
#ifdef NO_PROTO
float valeur;
#endif
{   int  act=0;
    int  sup=n_pts;
    int  inf=0;
    int  dif;
    FLOAT *l_pt;
    l_pt = l_points;
    while (sup!=inf)
    {    act += (dif = (sup+inf-1)/2 - act);
	 l_pt += dif;
	 if ( valeur >= *l_pt )
	     inf = act+1;
	 else sup = act;
	 }
    l_points = l_pt;
    return (sup);
    }

/* ----------------------------------------------------------- */
static int profil_point (P_(int) pos)
#ifdef NO_PROTO
int pos;
#endif
/* this procedure is called at each point, that is why most calculations */
/* are done directly without call to specialised procedure               */
{   int   ii,i,j,ip,ib,ia;
    int   dxpos;
    float z,val,val_f;

    dt = *l_points-DTH;
    put_ical(pos) +=  val = profil ();
    if (fini==0 && minli==0)
/* calcul des derivees en ce point, pos,2wg2,wl,as.. */
    {   d_pil ();
	val_f = fhkl_2 > EPSILON ? 2 * val / fhkl_2 : 0;
	temp = &temp_exper;
/* onde */
	VAR_init(l_onde);
	VAR_io_id  for (i=act.lambda*LAMBDA;i<act.lambda*LAMBDA+LAMBDA;i++)
	if ((j=var_param(i))!=0)
	{  switch (i%LAMBDA)
	 { case 0 : z = d_p_t * tan_t  / (RAD * lambda);   break;
		case 1 : z = val / exper_echelle;               break;
		case 2 : z = d_p_l * fabs(tan_t-tan_tm) * sign_onde;        break;
	   case 3 : z = d_p_g * sqr(tan_t-tan_tm) * var_valeur(i);
	   }
	   dy_dp[put_dydp(pos,j)] +=  z * var_derive();
	 }
/* zero, polar, eclair .... */
    	VAR_init(l_reglage);
	VAR_io_id  for (i=0;i<l_reglage->size;i++)
	if ((j=var_param(i))!=0)
	{  switch (i)
	 { case 0 : z = d_p_t;                         break;
	   case 1 : z = val *(cos2_2t-1)/((1+cos2_2t*polar)*(1+polar)); break;
	   case 2 :
	       	VAR_init(l_onde);
		z = - d_p_l * var_valeur(act.lambda*LAMBDA+2);
		if (tan_tm > tan_t) z = -z;
	 	z -=  d_p_g * (tan_t-tan_tm) *
	 		sqr(var_valeur(act.lambda*LAMBDA+3));
	    	VAR_init(l_reglage); break;
	   case 3 : z =  sin_t<eclair ? - val /eclair : 0; break;
	   case 4 : if (l_exper->techn == 1) z = 0;
	   case 5 : z = 0;
	   }
	   dy_dp[put_dydp(pos,j)] +=  z * var_derive();
	  }
/* instru */
    	VAR_init(l_instru);
	VAR_io_id  for (i=0;i<INSTRU;i++)
	if ((j=var_param(i))!=0)
	{  switch (i)
	{  case 0 : z = d_p_l * sign_instru0;    break;
	   case 1 : z = d_p_g *  var_valeur(1);    break;
		case 2 : z = d_p_l / fabs(tan_2t) * sign_instru2;    break;
	   case 3 : z = d_p_g / sqr(tan_2t) * var_valeur(3);    break;
	    }
	    dy_dp[put_dydp(pos,j)] +=  z * var_derive();
	  }
/* assym */
    	VAR_init(l_assym);
	VAR_io_id  for (ip=0;ip<max_assym;ip++)for (i=0;i<ASSYM;i++)
	if ((j=var_param(i+ip*ASSYM))!=0)
	{  switch (i)
	{  case 0 : z = d_p_a[ip] / tan_2t;       break;
	   case 1 : z = d_p_a[ip] / tan_t;        break;
	   case 2 : z = d_p_a[ip] * sin_2t;       break;
	   }
	   dy_dp[put_dydp(pos,j)] +=  z * var_derive();
	  }

	 temp = &temp_phase;
/* phase scale , overall B */
    	VAR_init(&l_phase->ech);
	VAR_io_id  for (i=0;i<l_phase->ech.size;i++)
	if ((j=var_param(i))!=0)
	    dy_dp[put_dydp(pos,j)] += val * var_derive() * *(d_echelle+i);
/* phase transition scale */
    	VAR_init(&l_phase->transit);
	VAR_io_id  for (i=0;i<l_phase->transit.size;i++)
	if ((j=var_param(i))!=0)
	    dy_dp[put_dydp(pos,j)] += val * var_derive() * *(d_echelle+l_phase->ech.size+i);
/* cell parameters */
	if (l_phase->nature != PHASE_PARASITE)
	{  VAR_init(&l_phase->cell);
	   VAR_io_id  for (i=0;i<l_phase->cell.size;i++)
	   if ((j=var_param(i))!=0)
	   {   z = i!= 0 ? d_metrique[i-1] : cos_t;
	       dy_dp[put_dydp(pos,j)] += z * d_p_t * var_derive();
	    } }

/* phase orien */
	if (l_phase->n_orien)
	{
    	VAR_init(&l_phase->orien);
	VAR_io_id  for (ip=0;ip<l_phase->n_orien;ip++) for (i=0;i<ORIEN;i++)
	  if ((j=var_param((org_orien+ip)*ORIEN+i))!=0)
		  dy_dp[put_dydp(pos,j)] += val * orien_val[ORIEN*ip+i]
	                   / act.orien * var_derive() ;
	   }
/* phase line width and assym */
   	if (l_phase->n_prof) {
 	VAR_init(&l_phase->prof);
	VAR_io_id  for (ip=0;ip<l_phase->n_prof;ip++) for (i=0;i<PROF;i++)
	if ((j=var_param(ip*PROF+i))!=0) if (i<PROF_ANG)
	{ switch (i%PROF)
	   {     case 0 : z = sign_phase * d_p_l / cos_t;    break;
	         case 1 : z = d_p_g  * phase_wg/ cos_t;      break;
		 case 2 : z = sign_phase * d_p_l * tan_t;    break;
	         case 3 : z = d_p_g * phase_wg * tan_t;      break;
	         }
	 dy_dp[put_dydp(pos,j)] +=  z * orien_prof[ip*ORIEN_PROF] * var_derive();
	    }  
	 else /* if (i<PROF_ANG) */
	 { z = d_p_l * orien_prof[ip*ORIEN_PROF+3]
	     + d_p_g * orien_prof[ip*ORIEN_PROF+4];
	   for (ia=0;ia<max_assym;ia++) z += d_p_a[ia] *  orien_prof[ip*ORIEN_PROF+5+ia];
	   dy_dp[put_dydp(pos,j)] +=  z * orien_prof[ip*ORIEN_PROF+i-PROF_ANG] * var_derive();
        } 
        VAR_init(&l_phase->assym);
	VAR_io_id  for (ip=ib=0;ip<l_phase->n_prof;ip++) 
	   for (ia=0;ia<max_assym;ia++,ib++)   for (i=0;i<PASSYM;i++)
	if ((j=var_param(ib*PASSYM+i))!=0) 
	{  switch (i%PASSYM)
	  {      case 0 : z =  d_p_a[ia];                   break;
		 case 1 : z =  d_p_a[ia] * tan_t;           break;
	         }
		dy_dp[put_dydp(pos,j)] +=  z * orien_prof[ip*ORIEN_PROF] * var_derive();
	   }  
        }
/* modulation vectors */
		  if ((l_phase->nature == PHASE_MAGNET || l_phase->nature == PHASE_MODUL)
                  &&  (cas_mag_mod & 6) )
        {
         VAR_init (&l_magnet->vecteur);
         VAR_io_id   for (i=0; i<3*l_magnet->dimension; i++)
	   if ((j=var_param(i))!=0)
	   {   z = vecteur_deriv[i];
	       dy_dp[put_dydp(pos,j)] += z * d_p_t * var_derive();
	    } }
         
/* atomic parameters */
	 if (deriv_atom)
	 {   dxpos = 0;
	     for (ii=0,l_atom=l_phase->atom; ii<l_phase->n_atom;
		ii++,l_atom++)
	     {   VAR_init(&l_atom->x);
		 VAR_io_id  for (i=0;i<l_atom->nb;i++)
		 if ((j=var_param(i))!=0)
		  {    z = F_A * fa_deriv[dxpos+i];
		       if (!centro) z += F_B * fb_deriv[dxpos+i];
		       dy_dp[put_dydp(pos,j)] += z * val_f * var_derive();
		       }
		  dxpos+=l_atom->nb;
		  if (l_atom->n_modul) 
		  {   VAR_init(&l_atom->modul);
		      VAR_io_id  for (i=0;i<l_atom->n_modul*AMODUL;i++)
		      if ((j=var_param(i))!=0)
		      {    z = F_A * fa_deriv[dxpos+i];
		           if (!centro) z += F_B * fb_deriv[dxpos+i];
		           dy_dp[put_dydp(pos,j)] += z * val_f * var_derive();
                           }
		      dxpos+=l_atom->n_modul*AMODUL;
		      }       
		  }
/* blocs rigides exprimes ici dans les coordonnees atomiques relatives */
	      for (ib=0; ib<l_phase->nb_bloc;ib++)
	      for (ii=0,l_atom=l_phase->bl_relat[ib]; ii<l_phase->bl_atom[ib];
		     ii++,dxpos+=l_atom->nb,l_atom++)
	     {   VAR_init(&l_atom->x);
		 VAR_io_id  for (i=0;i<l_atom->nb;i++)
		 if ((j=var_param(i))!=0)
		  {    z = F_A * fa_deriv[dxpos+i];
			if (!centro) z += F_B * fb_deriv[dxpos+i];
		   dy_dp[put_dydp(pos,j)] += z * val_f * var_derive();
		  }   }
	      }
	 else if (l_phase->n_atom==0 && i_intens)
/* cas des intensites definies , parasites puis phases normales ou quasi*/
	 {   VAR_init(&l_phase->intens);
	     VAR_io_id
	     if (l_phase->nature == PHASE_PARASITE)
	     {   ii=2*(i_intens-1);
	         if ((j=var_param(ii))!=0)
		 dy_dp[put_dydp(pos,j)] -= 2/RAD * tan_t * s * d_p_t * var_derive();
		 if ((j=var_param(ii+1))!=0)
		 dy_dp[put_dydp(pos,j)] += val*var_derive()/var_valeur(ii+1);
	     } else
	     {   ii=i_intens-1;
	         if ((j=var_param(ii))!=0)
		 dy_dp[put_dydp(pos,j)] += val*var_derive()/var_valeur(ii);
	     }  }
      } /* if !fini */
    return (val > minimum);
    }

/* ----------------------------------------------------------- */
static int profil_hkl (P_(void))
{   float fin,debut;
    int   nombre=0;
    int   pos,pos0;

    fin = DTH + influence;
    if (fin>diag_pn) fin= diag_pn;
    debut = DTH - influence;
    if (debut<diag_p0) debut = diag_p0;
    l_points = l_diag->points;
    pos = pos0 = search_first (DTH);
    if (pos0<n_pts)
    {     l_points = &l_diag->points[pos];
	  while ((pos<n_pts) && (profil_point (pos) || *l_points<=fin))
	  {     l_points++;
		nombre++;
		pos++;
                }
	  act.fin = pos-1;
	  pos = pos0 - 1;
          l_points = &l_diag->points[pos];
 	  while (( pos >= 0 )&& (profil_point (pos)|| *l_points>=debut))
	      {    l_points--;
		   nombre++;
		   pos--;
	       }
	  act.deb = pos+1;
          }
    return(nombre);
    }
/* ----------------------------------------------------------- */
void traite_hkl(P_(void))
{    int vu = 2;
     push_err_msg("traite_hkl");
     n_bragg++;
     if (def_profil())
     {    if (ini_profil() != 0)
	  {   if (fini==0) ini_d_metrique ();
	      vu = 1;
	      if (profil_hkl() != 0)
	      {   m_bragg++;
	          vu = 0;
		  if (fini && bragg_fich != NULL)
		     fwrite (&act,sizeof(BRAGG),1,bragg_fich);
		  }
	      } 
	 if (fini && prt_hkl > 1 && vu)  fprintf (list_fich,
 "   (%d)%3d%3d%3d (%d) %7.3f %6.1f (%6.1f %6.1f) %s\n",
	 act.phase,H,K,L,act.lambda,DTH,I_C,F_A,F_B,vu==2?"negligeable":"non visible");
	 }
    else fprintf (list_fich,
 " --- (%d)%3d%3d%3d (%d) %6.3f %2d %7.2f %7.2f %6.0f (%5.1g %5.1g) %5.3f sqrt(%5.3f) largeur negative\n",
	 act.phase,H,K,L,act.lambda,DTH,act.mu,act.cor,
	 act.orien,I_C,F_A,F_B,W_G,act.w_lorentz);
    pop_err_msg();
    }

/* ----------------------------------------------------------- */
void residu(P_(void))
{    int i,j,jj;
     float w,v,d,a,dd,sw;
     float i_obs,back,val,val_b;
     float z;
     float ex_dd = 0;
     float ex_d = 0;
     float ex_a = 0;
     float max_d,max_dt;
     float max_dd = 0;
     float zl = 0;
     float nz = 1;
     float uz;
	  float mod_y=0;
	  float *mod_m;
     int   add_lin = 0;
     int   signe;
     int   not_bg;
     int   lsq_correl = mod_lsq & 4;
     int   vraisemb = mod_lsq & 2;
     int   lsq_bkg = mod_lsq & 8;
     int   genere;
     char  semi;
     char  plg_format[80];
     int   plg_accuracy;
#if defined ( __STDC__ ) || defined ( THINK_C )
     time_t t_srand;
#else
     long   t_srand;
#endif

     push_err_msg("function residu");
     if (fini && minli==0)
     {  semi = ( prt_plg & PLG_ADDSEMI) ? ';' : ' ';
        plg_accuracy = 2;
        if ( l_diag->w_mini > MINFLOAT ) plg_accuracy = 2 - floor(log10(l_diag->w_mini));
        if ( plg_accuracy < 2) plg_accuracy = 2;
        sprintf (plg_format," %%9.4f%c %%8.%df%c %%8.%df%c %%8.%df%c %%7.%df%c %%5.1f%c\n",
        semi, plg_accuracy, semi, plg_accuracy, semi, plg_accuracy, semi, plg_accuracy, semi, semi); 
        if (prt_plg && !(prt_plg & PLG_NHEADER) ) fprintf (plg_fich,"# %s\n# %f\n",
                        l_exper->nom, l_diag->temp);
	 }
       else if (lsq_correl) mod_m = (float *) tst_alloc (n_par,sizeof(float),"mod_lsq");
     if (cycle == 0 && minli == 0 && l_exper->dfich == 0) 
     {  genere = 1;
        srand((unsigned) time (&t_srand));
	} else genere = 0;

     for (i=0,l_points=l_diag->points;i<n_pts;i++,l_points++)
     {   val_b = get_ical(i);
	 not_bg = val_b > minimum;
	 val = val_b + (back = get_back(i));
         /* bruit approx Poisson, i_obs si pas de exper */
#define MAX_POISSON   70
	 if (genere)
	 {   if  (val <= 0) i_obs = 0;
	     else
	     {   a = val < MAX_POISSON ? val : MAX_POISSON;
	         d = fsrand() * exp (a);
	         i_obs = 0; dd = z = 1;
	         while (dd < d)
	         {    i_obs += 1; z *= a/i_obs;  dd += z; }
	         if (val > MAX_POISSON )
	         {    i_obs += (d - dd) / ( d /( a * (i_obs-1)) - dd);
	              i_obs = (i_obs - MAX_POISSON) * sqrt (val / MAX_POISSON);
	              i_obs = floor (val + i_obs);
	          }   }
	       if (i_obs > 0) w = 1 / i_obs;  else w = 1;
	       put_iobs(i) = i_obs; put_wght(i) = w;
	      }
	 else 
         {   i_obs = get_iobs(i);
             if ( vraisemb )
	     {   if (val > 0) w = 1 / val;  else w = 1;
                 put_wght(i) = w;
                 }
             else w=get_wght(i); 
	     }
	 sw = sqrt (w);
	 d = i_obs  - val;
	 a = sw * d;
	 l_indic->so_wp += i_obs * i_obs * w;
	 l_indic->sd_wp += dd = d*d * w;
	 l_indic->so_p  += i_obs;
	 l_indic->sd_p  +=  d>=0 ? d :-d;
	 if (not_bg)
	 {   l_indic->so_wp_b += sqr(i_obs - back) * w;
	     l_indic->sd_wp_b += d*d * w;
	     l_indic->so_p_b  += i_obs-back;
	     l_indic->sd_p_b  +=  d>=0 ? d :-d;
	     l_indic->s_n_b += 1;
             }
	 if (i!=0) l_indic->d_val += (a-ex_a)*(a-ex_a);
	 ex_a = a;
         /* to know the worst point  */
	 if (dd > max_dd)
	 {       max_d = d;
		 max_dd = dd;
		 max_dt = *l_points;
		 }
         /* calculation for serial correlations indicator */
	 signe = d * ex_d > 0;
	 if (signe)
	 {   uz = dd + ex_dd;
/* modification 20/11/91 car sinon incorrect en l'absence de correlation */
             z = uz * sqrt (2*M_PI * ( uz));
	     z /= (2 + 2 * uz + z);
	     zl +=  z * a;
	     add_lin++;
	     }
	 else
	 {   if (add_lin) l_indic->sd_wp_cor += zl*zl;
	     z = zl = 0;
	     }
	 nz = 1 - z * z;
	 l_indic->sd_wp_cor += nz * dd;

	 if (fini && minli==0)
	 {   if (prt_plg)
	       fprintf (plg_fich, plg_format, *l_points, i_obs, val, back, d, a);
	     }
	 else if (!lsq_bkg || not_bg)
	 {    uz = lsq_correl ==0 ? 1 : nz;
	      for (j=0;j<n_par;j++)
		 if((v=uz*w*dy_dp[get_dydp(i,j+1)])!=0.0)
	      {    y_vect[j] += d * v;
		   for (jj=0;jj<=j;jj++) matrice[(j*(j+1))/2+jj]
			 += v * dy_dp[get_dydp(i,jj+1)];
		   }
	      if (lsq_correl)
	      /* le terme de ponderation non-diagonal */
	      {    if ( signe )
			{    mod_y += z * a;
			for (j=0;j<n_par;j++)
			  if((v=dy_dp[get_dydp(i,j+1)])!=0.0)
			   mod_m[j] += z * sw * v;
			}
		   else
		   {   if (add_lin)
		       for (j=0;j<n_par;j++)
		       {    y_vect[j] += mod_y * mod_m[j];
			    for (jj=0;jj<=j;jj++) matrice[(j*(j+1))/2+jj]
			      += mod_m[jj] * mod_m[j];
			    }
		    }  }
	      }
	 if (!signe && add_lin)
	 {    add_lin = 0;
	      if (lsq_correl) for (j=0;j<n_par;j++) mod_m[j] = 0;
	      }
	 ex_d = d;
	 ex_dd = dd;
	 }
     if (fini && minli==0)
     {  if (prt_plg && (prt_plg & PLG_ADDEND)) fprintf (plg_fich, plg_format,
                999.9, 999, 999, 999, 999, 999);
	}
     else if (lsq_correl) free (mod_m);
    l_indic->s_n = n_pts;
    if (minli==0)
    {   l_indic->s_n = n_pts;
	if (nt_diag>1)  fprt_indic(l_indic,0);
	if (n_pts * max_dd > 5 * l_indic->sd_wp)
   fprintf (list_fich,"\n Erreur maximale a %.3f : %.1f, %+.1f sigma, %.4f R\n",
		  max_dt,max_d,sqrt(max_dd),max_dd/l_indic->sd_wp);
     }  
     pop_err_msg();
     }

/* ----------------------------------------------------------- */
/* calcul echelle : exp(a) / (exp(a)+exp(-a)) = 1/(1+exp(-2a)  */
/* avec  a = signe(t-to) * dt * abs(t-to)^t_ex                 */
/* deriv est divise par sa valeur cf son usage */
float f_echelle(P_(int) i, P_(float *) d)
#ifdef NO_PROTO
int i;
float *d;
#endif
{   int j; 	
	 float to,dt,ex,tex;
	float u,a,b,c,rt,et;
	float *deriv;

	j = i;
	deriv = d + l_phase->ech.size + j;
	*deriv = *(deriv+1) = *(deriv+2) = 0;
	VAR_init (&l_phase->transit);
	to = var_valeur (j);
	dt = var_valeur (1+j);
	ex = var_valeur (2+j);
        u = (l_diag->temp - to);
	if (u < 0 )  { a = -1;  u = -u; } else a=1;
        b = a * dt;
	if ( u > EPSILON )
	{   tex = -2 * b * ( c = pow(u,ex));
		if (tex < LN_MAXFLOAT)
		{   rt = ( 1 / ( 1 + (et = exp (tex))));
			et *=  2*rt;        /* rt^2/rt cf usage */
			*deriv =  -et * b * ex * c / u;
			*(deriv+1) = et * a * c;
			*(deriv+2) = et * b * c * log(u);
			return (rt);
			}
		return (0);
		}
	return (0.5);
	}

/* ----------------------------------------------------------- */
