/* XND_COM.C   traitements specif des struct modules comensurables */
/*    */

#include "xnd_def.h"
#include "xnd_cah.h"

/* ---------------------------------------------------------- */
/* ---------------------------------------------------------- */
/* procedure for calculation of structure factor for          */
/*    comensurate modulated phases                            */
/*    pos contient la position de depart dans le tableau des  */
/*         derivees des coordonnees atomiques                 */
/*    mul                                                     */
/*    return : nombre de parametres atomiques                 */
/*    les  valeurs de F_A, F_B sont modifiees                 */    
/* ---------------------------------------------------------- */
/*static int dbg =0; */
int  fhkl_commod (P_(int) pos, P_(int) mul )
#ifdef NO_PROTO
int pos, mul;
#endif
{
    int    ii, jj, o;
    int    i, j, nb, pos_mod;
    int    isym;
    int    step, nb_step;
    float  step_width;
    float  f, fm, fbm;
    float  x_coord[3], h_sym[3], h_phi[3];
    float  bb[6], hk_sym[6];
    float  *l_coef;
    double trans, phi4, sym4;
    float  h_mod[3], hs_mod[3];
    double phi,c_phi,s_phi,debye;
    float  *x_modul;
    float  t_coord, t_eff;
	 double t, m_sat;
    double phase, c_p, s_p;
    double a_mod, b_mod, a_tmod, b_tmod, phi_mod;
    double c_a, s_a, c_b, s_b, d_a, d_b;
    double *s_modul, *c_modul;
    double *as_modul, *ac_modul, *bs_modul, *bc_modul;
    double *as_tmodul, *ac_tmodul, *bs_tmodul, *bc_tmodul;

    double a = 0;
    double b = 0;
    int omax = l_atom->n_modul;
    int nb_mod = AMODUL * omax;

    m_sat = l_satel->hkl_sat[0];
    pos_mod = pos + l_atom->nb;
    nb = l_atom->nb + nb_mod;
    if (deriv_atom)   for (j=0;j<nb;j++)
    {    fa_deriv[pos+j] = 0;
	 if (!centro) fb_deriv[pos+j] = 0;
	 }
    /* check if atom coordinates are really modulated */
    if (l_atom->n_modul == 0) 
    {    if (m_sat == 0) return fhkl_atom(pos, mul);
         else return nb;
         }
/* tst_abort ((l_magnet->dimension !=1), "Only ONE dim modulation has been implemented!"); */ 
    VAR_init (&l_magnet->vecteur);
    for (i=0; i<3; i++) h_mod[i] = m_sat * var_valeur(i);

    nb_step = l_magnet->nature; 
    
    VAR_init (&l_atom->x);
    for (i=0; i<3; i++) x_coord[i] = var_valeur(i);
    t_coord = var_valeur(3);
    if ((l_atom->nature & B_ANISO) == 0)
    {   debye = exp (-0.25 * var_valeur (4) * q);
         }
    else for (i=0;i<6;i++) bb[i] = var_valeur (i+4);

    if (l_atom->n_modul != 0)
    {    x_modul = (float *) tst_alloc(nb_mod, sizeof(float),"fhkl_modul");
         s_modul = (double *) tst_alloc( omax, sizeof(double),"fhkl_modul");
         c_modul = (double *) tst_alloc( omax, sizeof(double),"fhkl_modul");
         if (deriv_atom) {
            as_modul = (double *) tst_alloc( omax, sizeof(double),"fhkl_modul");
            ac_modul = (double *) tst_alloc( omax, sizeof(double),"fhkl_modul");
            bs_modul = (double *) tst_alloc( omax, sizeof(double),"fhkl_modul");
            bc_modul = (double *) tst_alloc( omax, sizeof(double),"fhkl_modul");
            as_tmodul = (double *) tst_alloc( omax, sizeof(double),"fhkl_modul");
            ac_tmodul = (double *) tst_alloc( omax, sizeof(double),"fhkl_modul");
            bs_tmodul = (double *) tst_alloc( omax, sizeof(double),"fhkl_modul");
            bc_tmodul = (double *) tst_alloc( omax, sizeof(double),"fhkl_modul");
            }
         VAR_init (&l_atom->modul);
         for (i=0;i<nb_mod;i++) x_modul[i] = var_valeur (i);
         }

  
    for (isym=0, l_coef=l_symgrp->coef; isym<l_symgrp->nops; isym++, l_coef+=12)
    {   for (i=0; i<3; i++) 
           h_sym[i] = l_coef[3*i] * H + l_coef[3*i+1] * K + l_coef[3*i+2] * L;
	trans = H * l_coef[9] + K * l_coef[10] + L * l_coef[11];
        for (i=0; i<3; i++) 
          hs_mod[i] = h_sym[i] +l_coef[3*i] * h_mod[0] 
                    + l_coef[3*i+1] * h_mod[1] + l_coef[3*i+2] * h_mod[2];

        /* operation de symetrie sur les phases de la modulation */
        /* sym4=epsilon; phi4=tau; m_sat est m (ou bien k_4) */
	sym4 = (l_magnet->symgrp)->coef[2*isym];
        phi4 = (l_magnet->symgrp)->coef[2*isym+1];
        /* les termes en phi4 viennent d'un changement de variable dans integr */
        phi =  trans + m_sat * phi4;
        for (i=0; i<3; i++) phi += ( h_phi[i] = hs_mod[i] - sym4 * h_mod[i] ) * x_coord[i] ;
	phi *= M_2PI;

	if (l_atom->nature & B_ANISO)
	 {    hk_sym[0] = h_sym[0] * h_sym[0];
	      hk_sym[1] = h_sym[1] * h_sym[1];
	      hk_sym[2] = h_sym[2] * h_sym[2];
	      hk_sym[3] = h_sym[0] * h_sym[1];
	      hk_sym[4] = h_sym[0] * h_sym[2];
	      hk_sym[5] = h_sym[1] * h_sym[2];
              debye = 0;
              for (i=0;i<6;i++) debye += bb[i] * hk_sym[i];
	      debye = exp(-debye);
	      }
        /* using a super structure cell F = sigma e( i H X )                 */
        /* with H = alpha h and X = x /alpha   where alpha is the cell ratio */
        /* the sum includes the alpha equivalent atom of the super cell      */    
        /* for one atom f = e(i H X) sigma(  n(t) e(i H x(t+to)) ) */
        /* les termes en phi4 viennent d'un changement de variable dans integr */
	c_phi = debye * cos(phi);
	s_phi = debye * sin(phi);
	/* now, integrating over the modulation */
        /* integr(0,1) exp(2pi.i(hm.x_sin.sin(2pi.o.t)+hm.x_cos.cos(2pi.o.t)+km ...))  */
        /* le changement de variable sur t impose le signe de step_width  mais rattrape par bornes */
        step_width = 1.0 / nb_step;
        a_mod = b_mod = a_tmod = b_tmod = 0;
        if ( deriv_atom) for (o=0; o<omax; o++, jj++) 
             as_modul[o] = ac_modul[o] = bs_modul[o] = bc_modul[o] = 
             as_tmodul[o] = ac_tmodul[o] = bs_tmodul[o] = bc_tmodul[o] = 0;
        for (step=0, t=0; step< nb_step; step++, t+=step_width )
        {    phi_mod  = sym4 * m_sat * t;
             t_eff = t_coord;
             for (o=0; o<omax; o++)  {
                   phase = M_2PI*(o+1)*t;
                   s_modul[o]=sin(phase);
                   c_modul[o]=cos(phase);
                   }
             for (o=0; o<omax; o++) 
             {    for ( i=0,ii=o*AMODUL; i<3; i++, ii+=2)
                     phi_mod += hs_mod[i] * ( x_modul[ii]   * s_modul[o]  
                             + x_modul[ii+1] * c_modul[o] ); 
                  t_eff  += x_modul[ii] * s_modul[o] + x_modul[ii+1] * c_modul[o];
                  }
             a_mod +=  (c_p = cos(M_2PI * phi_mod));
             b_mod += (s_p = sin(M_2PI * phi_mod));
             a_tmod += t_eff * c_p;
             b_tmod += t_eff * s_p;

             if (deriv_atom) 
             {    for (o=0; o<omax; o++) 
                  {    as_modul[o] += c_p * s_modul[o];  
                       ac_modul[o] += c_p * c_modul[o];  
                       bs_modul[o] += s_p * s_modul[o];  
                       bc_modul[o] += s_p * c_modul[o];  
                       as_tmodul[o] -= M_2PI * t_eff * s_p * s_modul[o];  
                       ac_tmodul[o] -= M_2PI * t_eff * s_p * c_modul[o];  
                       bs_tmodul[o] += M_2PI * t_eff * c_p * s_modul[o];  
                       bc_tmodul[o] += M_2PI * t_eff * c_p * c_modul[o];  
                       }  
                  } /* deriv_atom */                
             } /* for step */
       /* le facteur de structure global*/
        s_a = s_phi * a_tmod / nb_step;
        c_b = c_phi * b_tmod / nb_step;
        a += c_a = c_phi * a_tmod / nb_step;
        a -= s_b = s_phi * b_tmod / nb_step;
        if (!centro)   b += s_a + c_b;
        if (deriv_atom)
	{    d_a = - M_2PI * (s_a + c_b); 
             for (i=0; i<3; i++)        fa_deriv [pos+i] += h_phi[i] * d_a;  
	     fa_deriv [pos+3]   += c_phi * a_mod - s_phi * b_mod;
	     if (l_atom->nature & B_ANISO)
	     {     d_a = - (s_a + c_b);
                   for (i=0; i<6; i++)  fa_deriv [pos+4+i] += hk_sym[i] * d_a;
                   }
             for (ii=o=0; o<omax; o++, ii+=2) 
             {     for ( i=0; i<3; i++, ii+=2)
                   {    fa_deriv [pos_mod+ii] += h_sym[i] * ( c_phi * as_tmodul[o] - s_phi * bs_tmodul[o]);
                        fa_deriv [pos_mod+ii+1] += h_sym[i] * ( c_phi * ac_tmodul[o] - s_phi * bc_tmodul[o]);
                        }
                   fa_deriv [pos_mod+ii]   += c_phi * as_modul[o] - s_phi * bs_modul[o];
                   fa_deriv [pos_mod+ii+1] += c_phi * ac_modul[o] - s_phi * bc_modul[o];
                   }    
             if (!centro) 
             {    d_b = - M_2PI * (s_b - c_a);
                  for (i=0; i<3; i++)   fb_deriv [pos+i]   += h_phi[i] * d_b;
                  fb_deriv [pos+3] += s_phi *a_mod - c_phi *b_mod;
	          if (l_atom->nature & B_ANISO)
	          {    d_b = - (s_b - c_a);
                       for (i=0; i<6; i++) fb_deriv [pos+4+i] += hk_sym[i] * d_b;
                       }
                  for (o=0; o<omax; o++) 
                  {    for ( i=0,ii=o*AMODUL; i<3; i++, ii+=2)
                       {    fb_deriv [pos_mod+ii+1] +=  h_sym[i] * (s_phi * as_tmodul[o] + c_phi * bs_tmodul[o]);
                            fb_deriv [pos_mod+ii+1] +=  h_sym[i] * (s_phi * ac_tmodul[o] + c_phi * bc_tmodul[o]);
                            }
                       fb_deriv [pos_mod+ii]   += s_phi * as_modul[o] + c_phi * bs_modul[o];
                       fb_deriv [pos_mod+ii+1] += s_phi * ac_modul[o] + c_phi * bc_modul[o];
                       }
                  }  /*! centro */
           }        
	} /* for isym */

    f = (*valdif)();
    /* si diffusion anomale on traite a part la contrib imaginaire de f */
    if (dif_nature == EXPER_RXA)  f += anodif();
    fm = f * mul;
    F_A += fm * a;
    if (!centro)  F_B += fm * b;
    
    if (dif_nature == EXPER_RXA)
    {    fbm = mul * anodif_b();
	 act.f_am += fbm * a ;
	 if (!centro)  act.f_bm += fbm * b;
	 }

    free(x_modul);    free(s_modul);  free(c_modul);

    if (deriv_atom==0) return (0);
    free(as_modul);   free(ac_modul); free(bs_modul); free(bc_modul);
    free(as_tmodul);   free(ac_tmodul); free(bs_tmodul); free(bc_tmodul);

    if ((l_atom->nature & B_ANISO)==0) fa_deriv[pos+4] = -0.25 * q * a;
    for (j=0;j<nb;j++)  fa_deriv[pos+j] *= fm;
    if (dif_nature == EXPER_RXA)
	 for (j=0;j<nb;j++)  fam_deriv[pos+j] = fa_deriv[pos+j] * fbm/fm;
    if (centro) return (nb);

    if ((l_atom->nature & B_ANISO)==0) fb_deriv[pos+4] = -0.25 * q * b;
    for (j=0;j<nb;j++)  fb_deriv[pos+j] *= fm;
     if (dif_nature == EXPER_RXA)
	 for (j=0;j<nb;j++)  fbm_deriv[pos+j] = fb_deriv[pos+j] * fbm/fm;
    return (nb);
    }

 /* ---------------------------------------------------------- */
