/* XND_HKL    F_hkl, generate HKL... */

#include "xnd_def.h"
#include "xnd_cah.h"

 /* ---------------------------------------------------------- */
int  fhkl_atom (P_(int) pos, P_(int) mul )
#ifdef NO_PROTO
int pos, mul;
#endif
{
    int i,j,nb;
    float x,y,z,f,fm;
    float bb[6];
    float hh,kk,ll;
    float *l_coef;
    float fbm;
    double trans, taux;
    double phi, c_phi, s_phi, debye, d_a, d_b;
    double a = 0;
    double b = 0;

    nb = l_atom->nb;
    VAR_init (&l_atom->x);
    x = var_valeur (0);
    y = var_valeur (1);
    z = var_valeur (2);
    if ((l_atom->nature & 1) == 0)
	debye = exp (-0.25 * var_valeur (4) * q);
    else for (i=0;i<6;i++)
	bb[i] = var_valeur (4+i);
    if (deriv_atom)   for (j=0;j<nb;j++)
    {    fa_deriv[pos+j] = 0;
	 if (!centro) fb_deriv[pos+j] = 0;
	 }
    for (i=0,l_coef=l_symgrp->coef;i<l_symgrp->nops;i++,l_coef+=12)
    {   hh = l_coef[0] * H + l_coef[1] * K + l_coef[2] * L;
	kk = l_coef[3] * H + l_coef[4] * K + l_coef[5] * L;
	ll = l_coef[6] * H + l_coef[7] * K + l_coef[8] * L;
	trans = H * l_coef[9] + K * l_coef[10] + L * l_coef[11];
	phi = 2 * M_PI * (hh * x + kk * y + ll * z + trans);
	if (l_atom->nature & B_ANISO)
	 {   debye = exp(-(bb[0]*hh*hh+bb[1]*kk*kk+bb[2]*ll*ll
			   +bb[3]*hh*kk+bb[4]*hh*ll+bb[5]*kk*ll));
	    }
	a += c_phi = debye * cos(phi);
	b += s_phi = debye * sin(phi);
	if (deriv_atom)
	{    d_a = - 2 * M_PI * s_phi;
             fa_deriv [pos]   += hh * d_a;
	     fa_deriv [pos+1] += kk * d_a;
	     fa_deriv [pos+2] += ll * d_a;
	     if (!centro)
	     {    d_b = 2 * M_PI * c_phi;
                  fb_deriv [pos]   += hh * d_b;
		  fb_deriv [pos+1] += kk * d_b;
		  fb_deriv [pos+2] += ll * d_b;
		  }
	     if (l_atom->nature & B_ANISO)
	     {     fa_deriv [pos+4] -= hh * hh * c_phi;
		   fa_deriv [pos+5] -= kk * kk * c_phi;
		   fa_deriv [pos+6] -= ll * ll * c_phi;
		   fa_deriv [pos+7] -= hh * kk * c_phi;
		   fa_deriv [pos+8] -= hh * ll * c_phi;
		   fa_deriv [pos+9] -= kk * ll * c_phi;
		   if (!centro)
		   {    fb_deriv [pos+4] -= hh * hh * s_phi;
			fb_deriv [pos+5] -= kk * kk * s_phi;
		        fb_deriv [pos+6] -= ll * ll * s_phi;
		        fb_deriv [pos+7] -= hh * kk * s_phi;
		        fb_deriv [pos+8] -= hh * ll * s_phi;
		        fb_deriv [pos+9] -= kk * ll * s_phi;
		   }   }
	     }
	}
    f = (*valdif)();
    /* si diffusion anomale on traite a part la contrib imaginaire de f */
    if (dif_nature == EXPER_RXA)  f += anodif();
    fm = f * mul * ( taux = var_valeur (3) );
    F_A += fm * a;
    if (!centro)  F_B += fm * b;
    if (dif_nature == EXPER_RXA)
    {    fbm = mul * taux * anodif_b();
    	 act.f_am += fbm * a ;
	 if (!centro)  act.f_bm += fbm * b;
/* fprintf(list_fich,"XND_HKL.C hkl %3d %3d %3d %8s %6.3f %6.3f %6.3f (%6.1f  %6.1f) (%6.1f  %6.1f)\n",
/*   H, K, L, l_atom->nom, x, y, z, F_A, F_B, act.f_am, act.f_bm);*/
	 }
    if (deriv_atom==0) return (0);
    if ((l_atom->nature & B_ANISO)==0) fa_deriv[pos+4] = -0.25 * q * a;
    for (j=0;j<3;j++)  fa_deriv[pos+j] *= fm;
    fa_deriv[pos+3] = f * mul * a;
    for (j=4;j<nb;j++)  fa_deriv[pos+j] *= fm;
    if (dif_nature == EXPER_RXA)
    	 for (j=0;j<nb;j++)  fam_deriv[pos+j] = fa_deriv[pos+j] * fbm/fm;
    if (centro) return (nb);
    if ((l_atom->nature & B_ANISO)==0) fb_deriv[pos+4] = -0.25 * q * a;
    for (j=0;j<3;j++)  fb_deriv[pos+j] *= fm;
    fb_deriv[pos+3] = f * mul * b;
    for (j=4;j<nb;j++)  fb_deriv[pos+j] *= fm;
    if (dif_nature == EXPER_RXA)
   	 for (j=0;j<nb;j++)  fbm_deriv[pos+j] = fb_deriv[pos+j] * fbm/fm;
    return (nb);
    }

 /* ---------------------------------------------------------- */
static float  fhkl (P_(void))
{   int i,j;
    int pos=0;

    push_err_msg("fhkl");
    temp = &temp_phase;
    F_A = F_B = act.f_am = act.f_bm = 0;
    if ( l_phase->nb_atom == 0 ) F_A = 1;
    for (i=0,l_atom=l_phase->atom;i<l_phase->n_atom;i++,l_atom++)
	pos +=  (*fhkl_eff) (pos, fhkl_mult);
    for (j=0;j<l_phase->nb_bloc;j++)
		for (i=0,l_atom=l_phase->bl_relat[j];i<l_phase->bl_atom[j];i++,l_atom++)
	pos += (*fhkl_eff) (pos, fhkl_mult);

    fhkl_2 = F_A * F_A + F_B * F_B;
     /* anomal sur poudre , moyenne sur hkl et -hkl */
    if (dif_nature && EXPER_RXA) fhkl_2 += act.f_am*act.f_am +act.f_bm+act.f_bm;
    pop_err_msg();
    return (fhkl_2);
    }

 /* ---------------------------------------------------------- */
void hkl_std(P_(void))
{
         h_eff = H;
     k_eff = K;
     l_eff = L;
     }
 /* ---------------------------------------------------------- */
 /* ---------------------------------------------------------- */
#ifdef OS_CHECK_ABORT
#ifdef MAC_OS
#include <OSEvents.h>
void chk_for_abort(P_(void))
{    EventRecord  event;    /* pour intercepter Pomme . */
/*  if ( GetNextEvent(KeyDownMask, event) ) return 1;  */
      return ;
     }
#endif      
#ifdef MS_DOS
#include <conio.h>
void chk_for_abort(P_(void))
{   if (kbhit())   getch();    /* pour une gestion du Controle_C */
    } 
#endif
#endif
 /* ---------------------------------------------------------- */
int exist_hkl (P_(int) ihkl)
#ifdef NO_PROTO
int ihkl;
#endif
{
static char exist_msg[30];
     sprintf(exist_msg,"exist_hkl (%d) %d %d %d", l_phase->nature, H, K, L);
     push_err_msg(exist_msg);
#ifdef OS_CHECK_ABORT
    chk_for_abort();
#endif
      switch (l_phase->nature)
	{ case PHASE_QUASI : 
                h_eff = H + K * M_GOLD;
                q = g_aa * h_eff;
		break;
	  case PHASE_PARASITE : VAR_init (&l_phase->intens);
		q = 1/var_valeur(2*ihkl);
		q *= q;
		break;
	  default :
		if (H==0 && K==0 && L==0 || extinction()!=0) 
		{     pop_err_msg();  return(0);  }
		hkl_eff();
                q = h_eff * ( h_eff * g_aa + k_eff * g_ab + l_eff * g_ac);
                q += k_eff * ( k_eff * g_bb + l_eff * g_bc ) + l_eff * l_eff * g_cc;
	}
	if (q<q_min || q>q_max) {    pop_err_msg(); return (0); }
	s=sqrt(q);
	DTH=2/RAD * asin((double) (sin_t=0.5*s*lambda));
	if (DTH<t_min || DTH>t_max) { pop_err_msg(); return (0); }
        push_err_msg("valid hkl");
	t_bragg++;
	act.dist = 1/s;
	cos_t = sqrt (1-sin_t*sin_t);
	tan_t = sin_t / cos_t;
	tan2  = tan_t * tan_t;
	sin_2t = 2 * sin_t * cos_t;
	cos2_2t = 1-sin_2t*sin_2t;
	cos_2t =  sqrt (cos2_2t);
	if ( tan_t > 1 ) cos_2t *= -1.0;
	tan_2t =  sin_2t / cos_2t;
	DTH += zero + centrage * cos_t;
	i_intens = (l_phase->intens.ordre==0) ? 0 : ihkl+1;
	if (l_phase->nature >= 0 || l_phase->nature == PHASE_MAGNET ||
                 l_phase->nature == PHASE_MODUL )
	{	orientation();
		act.mu = multiplicite();
		}
	else
	{	act.orien =1;
		act.mu =1;
		}
	valcor();
	act.ech = echelle * exp ( -0.25 * bg * q);
	I_C = act.orien * act.ech;
	if (i_intens==0)  I_C *=  act.mu * act.cor * fhkl();
	else
	{     VAR_init (&l_phase->intens);
	      if (l_phase->nature == PHASE_PARASITE) 
                     I_C *= var_valeur(2*i_intens-1);
		else I_C *= var_valeur(i_intens-1);
		act.mu = - act.mu;
		}
	*(d_echelle+1) = -0.25 *q  ;
	if (I_C>EPSILON)  
        {    traite_hkl();
             if (fini && prt_hkl > 100)  fprintf (list_fich,
 "   (%d)%3d%3d%3d (%d) %7.3f %6.1f (%6.1f %6.1f) traitee\n",
	 act.phase,H,K,L,act.lambda,DTH,I_C,F_A,F_B);
               }
	else if (fini && prt_hkl > 2)  fprintf (list_fich,
 "   (%d)%3d%3d%3d (%d) %7.3f %6.1f (%6.1f %6.1f) nulle\n",
	 act.phase,H,K,L,act.lambda,DTH,I_C,F_A,F_B);
        if ( l_phase->nb_tds==1) gen_tds_hkl();
	pop_err_msg();
	pop_err_msg();
	return (1);
	}

 /* ---------------------------------------------------------- */

void gen_hkl (P_(void))
{   int    k_min, k_max;
	int    h_min, h_max;
	float  sol_k, sol_h;
	float  val, val_kl, val_kk, val_ko;
	float  val_a, val_b, val_c;

    push_err_msg("gen_hkl");
    	val_b = sqr (g_bc - 0.5 * g_ab * g_ac / g_aa);
	val_a = 4 * (g_bb - 0.5 * g_ab * g_ab / g_aa);
	val_c = g_cc - 0.5 * g_ac * g_ac / g_aa;
	L = 0;
	val_ko = val_a * q_max;
	val_kk= val_b - val_a * val_c;
	if (val_kk < 0) val_kk = - val_kk;    /* metriques tres tordues */
	do
	{   sol_k= val_ko - L*L* val_kk;
	    if (sol_k>0)
	    {   sol_k = sqrt(sol_k)/2 / g_bb;
		val   = -L * g_bc / (2 * g_bb);
		k_max = ceil (val+sol_k);
		if ((systeme=='A' || systeme=='L') && L != 0) k_min = floor(val-sol_k);
		else if (systeme=='C' || systeme=='T') k_min = L;
		else k_min = 0;
		for (K=k_min;K<=k_max;K++)
		{   sol_k = (L*L) * g_cc + (K*K) * g_bb + (K*L) * g_bc;
			val_kl = L * g_ac + K * g_ab;
			sol_h = sqr (val_kl) - 4 * g_aa *  (sol_k -q_max);
			if (sol_h>0)
			{   sol_h = sqrt(sol_h) / (2 * g_aa);
			    val = -val_kl / (2 * g_aa);
			    h_max = ceil (val+sol_h);
			    if ( (systeme=='M' && L!=0) || (systeme=='N' &&  K!=0)
				||  (systeme=='A' && (L!=0 || K!=0)))
				h_min = floor(val-sol_h);
			    else if (systeme=='C'|| systeme=='R' || systeme=='T'
				|| systeme=='Q' || systeme=='H')
				h_min = K;
			    else h_min = 0;
			    for (H=h_min;H<=h_max;H++)
			    {  if (exist_hkl(0) && !l_symgrp->holoedre)
				   gen_holoedre ();
			       if (systeme=='T')
			       { if (K!=0 || L!=0)
				{   H = -H;
				    if (exist_hkl(0) && !l_symgrp->holoedre)
				    gen_holoedre ();
				    H = -H;
				    }
			       if (K!=0 && K!=H && L!=0)
				{   K = -K;
				    if (exist_hkl(0) && !l_symgrp->holoedre)
				    gen_holoedre ();
				    K = -K;
				 }
			       if (L!=0 && L!=K)
				{   L = -L;
				    if (exist_hkl(0) && !l_symgrp->holoedre)
				    gen_holoedre ();
				    L = -L;
				 } }
			       if (systeme=='R' && (L!=0 && ( H!=0 || K!=0) ))
				{   L = -L;
				    if (exist_hkl(0) && !l_symgrp->holoedre)
				    gen_holoedre ();
				    L = -L;
				    }
				 }
		     }         /* if sol_h */
			 }    /* for k */
		}	     /* if sol_k */
	     L++;
	 } while (sol_k >= 0);
     pop_err_msg();
     }
 /* ---------------------------------------------------------- */
void get_hkl (P_(void))
{   int    i,n_hkl;
	HKL    *l_hkl;
	l_hkl = l_phase->hkl;
	n_hkl = l_phase->nb_hkl;
	for (i=0;i<n_hkl;i++,l_hkl++)
	{       if (l_phase->nature != PHASE_PARASITE)
		{   H = l_hkl->h[0];
		    K = l_hkl->h[1];
		    L = l_hkl->h[2];
		    } else H = K = L = 0;
		exist_hkl (i);
		}
	}

 /* ---------------------------------------------------------- */
void make_hkl (P_(void))
{
     push_err_msg("make_hkl");
	l_symgrp = l_phase->symgrp;
	VAR_init (&l_phase->cell);
	if (l_phase->nature != PHASE_PARASITE) centrage = var_valeur (0);
	else centrage = 0;
	if (l_symgrp != NULL)
	{	systeme = l_symgrp->systeme;
		bravais = l_symgrp->bravais;
		centro  = l_symgrp->centro;
		}
	if (l_phase->n_orien)
	{     orien_val = (float *) tst_alloc (ORIEN*l_phase->n_orien,sizeof(float),"orien");
              ini_orientation();
              }
	else orien_val = NULL;
	if (l_phase->n_prof)
	orien_prof = (float *) tst_alloc (ORIEN_PROF*l_phase->n_prof,sizeof(float),"orien");
	else orien_prof = NULL;
	if (l_phase->nb_bloc) ini_blk( fini && minli==0 );
        fhkl_mult = centro ? 2 : 1;
        if ( bravais=='A'|| bravais=='B'|| bravais=='C'|| bravais=='I') fhkl_mult *= 2;
	    else if ( bravais=='R'|| bravais=='S')  fhkl_mult *= 3;
	    else if ( bravais=='F') fhkl_mult *= 4;
                
	if ((minli==0 && fini==0) && l_phase->nb_par)
	{	deriv_atom=l_phase->nb_par;
		fa_deriv = (float *) tst_alloc (deriv_atom,sizeof(float),"deriv");
		if (!centro)
		fb_deriv = (float *) tst_alloc (deriv_atom,sizeof(float),"deriv");
		if (dif_nature==EXPER_RXA)
		{   fam_deriv = (float *) tst_alloc (deriv_atom,sizeof(float),"deriv");
		    if (!centro)
		    fbm_deriv = (float *) tst_alloc (deriv_atom,sizeof(float),"deriv");
		    }
		}
	else deriv_atom = 0;
	temp = &temp_exper;

	t_min = (diag_p0+zero+centrage) * 0.98 - 1.0;
	if (t_min<0) t_min =0;
	t_max = (diag_pn+zero+centrage) * 1.02 + 1.0;
	if (t_max>180) t_max =180;
	for (act.lambda=0;act.lambda<l_exper->n_lambda;act.lambda++)
	{   VAR_init (l_onde);
	    lambda = var_valeur (act.lambda * LAMBDA);
	    if (dif_nature == EXPER_RXA) ini_anodif();
	    exper_echelle = var_valeur (act.lambda*LAMBDA + 1);
	    echelle = phase_echelle * exper_echelle;
	    q_min=sqr(2*sin(0.5*RAD*t_min)/lambda);
	    q_max=sqr(2*sin(0.5*RAD*t_max)/lambda);
	    fhkl_eff = fhkl_atom;
	    hkl_eff    = hkl_std;
	    switch (l_phase->nature)
	    {     case PHASE_GENERE  : gen_hkl();
			    break;
		  case PHASE_MAGNET : magnet_hkl ();
			    break;
		  case PHASE_MODUL  : magnet_hkl ();
			    break;
		  default : get_hkl ();
			    break;
		  }
	      }
	if (deriv_atom)
	{   free (fa_deriv);
		if (!centro) free (fb_deriv);
		if (dif_nature==EXPER_RXA)
		{     free (fam_deriv);
		      if (!centro)
		      free (fbm_deriv);
		}     }
	if (l_phase->nb_bloc) free_blk();
	if (orien_val) free (orien_val);
	if (orien_prof) free (orien_prof);
	if (minli==0) fprintf(list_fich," %d hkl (%d non nuls, %d generes)\n",m_bragg,n_bragg,t_bragg);
	pop_err_msg();
	}
 /* ---------------------------------------------------------- */


