/* XND_MAIN.C  module contenant le programme principal */

#define EXTERN                /* to create the variables in XND_VAR.H */
#include "xnd_def.h"

#include "xnd_cah.h"

#include <string.h>

#ifndef _INCLUDE_HPUX_SOURCE
#include <time.h> 
#endif

#ifdef MSDOS
extern unsigned _stklen = 0x2000;
#endif

#ifdef MAC_OS
#include <console.h>
#endif

static INDIC indic;                 /* overall sums */
static FLOAT t_pen, t_eff;
static int n_tot, nt_par;

#if defined ( __STDC__ ) || defined ( MAC_OS )
static time_t secs_start, secs_now;
static clock_t clock_start, clock_now;
static clock_t clock_cal, clock_inv, clock_min, clock_prt, clock_ini;
#else
static long   secs_start, secs_now;
static long clock_start, clock_now;
static long clock_cal, clock_inv, clock_min, clock_prt, clock_ini;
#endif

/* ------------------------------------------------------------------ */
int  calcul PROTO(( void));
void boucle PROTO((void));
void min_lin PROTO((void));


/* ------------------------------------------------------------------ */
int main (P_(int) argn, P_(char **) argv)
#ifdef NO_PROTO
int argn;
char **argv;
#endif
{   int i;
	 FLOAT sum0, summ;

    clock_start=clock();
    time (&secs_start);
    str_time= ctime(&secs_start);
    clock_cal= clock_inv= clock_min= clock_prt= 0;
    clear_err_msg();
    read_init (argn, argv);
    ini_back_ground();
    clock_ini=clock()-clock_start;
    
    nt_par = n_par;
    for (cycle=0; cycle<=max_cycle;cycle++)
    {     clear_err_msg();
          if (cycle==max_cycle) fini=1;
      if (fini==0)
      {   memset (y_vect,0,n_par*sizeof(FLOAT));
          memset (matrice,0,n_mat*sizeof(FLOAT));
          }
      else
      {   if (cycle!=0)
          {    if (prt_cor) prt_correl ();
           free (y_vect);
           free (matrice);
           }
          prt_b_equiv();
#ifdef  OS_CHECK_ABORT    
    /* pour forcer une actualisation du catalogue */
    list_fich = freopen (list_name,"at",list_fich);
    if (list_fich == NULL)
    {    printf (" Impossible de reouvrir '%s'\n",list_name);
     exit (10);
     }
#endif
          n_par = obrg_s[0] = 0;
          obrg_d[0] = obrg_s[0] = 0;
          obrg_d[1] = obrg_s[1] = 0;
          if (prt_hkl) hkl_fich = tst_open (hkl_name,"w","HKL file");
          if (prt_plg) plg_fich = tst_open (plg_name,"w","PLG file");
          }
      minli = 0;
      clock_now=clock();
      boucle ();
      if (cycle==0) sum0 = summ = t_eff;
      else if (t_eff < summ) summ= t_eff;

    if (fini) { clock_prt+=clock()-clock_now; break; }
    clock_cal+=clock()-clock_now;
    clock_now=clock();
    if (cycle >= 1) inverse (t_eff/xt_eff); else inverse ((FLOAT) 0);
    clock_inv+=clock()-clock_now;

    if (((mod_lsq & 1)!=0) || ((cycle >= 1) && (t_eff > xt_eff))) min_lin();
    else  for (i=0; i<n_par; i++)  y_vect[i] *= stabil;

    xt_eff = t_eff;
    imprime();
    fflush(list_fich);
#ifdef  OS_CHECK_ABORT    
    /* pour forcer une actualisation du catalogue */
    list_fich = freopen (list_name,"at",list_fich);
    if (list_fich == NULL)
    {    printf (" Impossible de reouvrir '%s'\n",list_name);
     exit (10);
     }
#endif    

    if (c_marquardt!=0 && marquardt>MINFLOAT && cycle!=0)
    {    if (t_eff > xt_eff) marquardt *= 0.2*c_marquardt;
         else marquardt /= 0.1*c_marquardt;
         fprintf (list_fich,
         " Nouveau coefficient Marquardt * %.3g\n",marquardt);
         }
    }
    if (prt_hkl) hkl_fich = xclose(hkl_fich);
    if (prt_plg) plg_fich = xclose(plg_fich);

    put_res_brg (list_fich, "\n  Overall ", obrg_n, obrg_s, obrg_d);
    if (bavard)  put_res_brg (stdout, "Overall ", obrg_n, obrg_s, obrg_d);

    dydp_fich = xclose (dydp_fich);
    if (prt_new) new_cdr ();
          
    if (max_cycle == 0) termine (0,"");
    if (t_eff == summ)  i = 0;
    else if (t_eff < sum0) i = 1;
    else  i = 2;
    if (cycle >= max_cycle) i +=3;
    termine (i, "");
    return 0;
	 }

/* ------------------------------------------------------------------ */
       /*  algorithme de minimisation lineaire */
void min_lin ()
{    int  i, t_par, n_parab;
     FLOAT shift, deplace, ot_eff, t_min, t_max;
     FLOAT position, n_pos, pos_max, pos_min;
     FLOAT delta, a ,b, x[3], x2[3], y[3], parab;
     char *motif;

     push_err_msg("min_lin");
     clock_now=clock();
     y[2] = xt_eff = ot_eff = t_eff;
     x2[2] = x[2] = opt_deplace = 0;
     position = shift = deplace = stabil;
     pos_max = 1000;
     pos_min = -1000;
     t_par = n_par;
     n_par = n_parab = 0;
     shift_e = (float *) tst_alloc(t_par, sizeof(float),"vecteur");
     motif = "lsq";

     for (i=0; i<t_par; i++)
     {    shift_e[i] = y_vect[i];
      y_vect[i] *= stabil;
      }
      for (minli=1; minli<12; minli++)
      {   imprime ();
      if ((fini && (minli > 4)) || (fabs(deplace) < 0.02)) break;
      fprintf(list_fich,"\n Position %.3f (%s), Optimum %.3f",
            position, motif, opt_deplace);
      if (pos_min > -900) fprintf(list_fich,", pos_min %.3f", pos_min);
      if (pos_max <  900) fprintf(list_fich,", pos_max %.3f", pos_max);
      fprintf(list_fich,"\n");
      boucle ();

      x[1] = opt_deplace;
      x2[1] = opt_deplace * opt_deplace;
      y[1] = ot_eff;
      x[2] = position;
      x2[2] = position * position;
      y[2] = t_eff;
      if (minli >=2 )
      {   x[1] = opt_deplace;
          x2[1] = opt_deplace * opt_deplace;
          y[1] = ot_eff;
          x[2] = position;
          x2[2] = position * position;
          y[2] = t_eff;
          if ( (position  - pos_min) < (pos_max - position))
			 {    x[0] = pos_min; x2[0] = pos_min * pos_min; y[0] = t_min;
               motif = "quad min"; }
          else
			 {    x[0] = pos_max; x2[0] = pos_max * pos_max; y[0] = t_max;
               motif = "quad max"; }
              delta = x2[0]*(x[1]-x[2])+x2[1]*(x[2]-x[0])+x2[2]*(x[0]-x[1]);
          a = y[0]*(x[1]-x[2])+y[1]*(x[2]-x[0])+y[2]*(x[0]-x[1]);
          b = x2[0]*(y[1]-y[2])+x2[1]*(y[2]-y[0])+x2[2]*(y[0]-y[1]);
          if (a * delta > 0)
          {    parab = -0.5 * b / a;
           n_parab++;
           } else n_parab = 0;
          }

      if (t_eff < ot_eff)
      {  if (shift > 0) {    pos_min = opt_deplace; t_min = ot_eff; }
         else {  pos_max = opt_deplace; t_max = ot_eff; }
         if (minli > 1) shift *= 2;
         }
      else
      {  if (shift > 0 ) {  pos_max = position; t_max = t_eff; }
			else  { pos_min = position; t_min = t_eff; }
         shift *= -0.5;
         }
      if (t_eff < ot_eff)
      {  opt_deplace = position;
         ot_eff = t_eff;
         }
      if (shift >  0.5 * (pos_max - opt_deplace) && pos_max < 900)
          shift = 0.5 * (pos_max - opt_deplace);
      else if (shift < 0.5* (pos_min - opt_deplace) && pos_min > -900)
          shift = 0.5 * (pos_min - opt_deplace);
      n_pos = opt_deplace + shift;

      if (n_parab  && (fabs((parab - n_pos) / shift) < 5) &&
         ( parab < pos_max) && (parab > pos_min))
      {    deplace = parab - position;
           position = parab;
           shift = position - opt_deplace;
           }
      else
      {    deplace =  n_pos - position;
           position = n_pos;
           motif = "lin.";
           }

      for (i=0;i<t_par;i++)
      y_vect[i] = shift_e[i] * deplace;
      xt_eff = t_eff;
      }
     if (fabs(opt_deplace) < 0.01) opt_deplace = position;
     fprintf(list_fich,"\n Position finale %.3f\n",opt_deplace);
     for (i=0;i<t_par;i++) y_vect[i] = shift_e[i] * opt_deplace;
     opt_deplace = -position / opt_deplace;
     free (shift_e);
     minli = -1;
     n_par = t_par;
     t_eff = ot_eff;
     clock_min+=clock()-clock_now;
     pop_err_msg();
     }

/* ------------------------------------------------------------------ */
FILE * xclose (P_(FILE *) file)
#ifdef NO_PRPOTO
FILE *file;
#endif
{    if (file != NULL) fclose (file);
     return NULL;
     }
/* ------------------------------------------------------------------ */
void termine (P_(int) cas, P_(char *) msg)
#ifdef NO_PROTO
int cas;
char *msg;
#endif
{   char texte[200];
    time (&secs_now);
    clock_now=clock()-clock_start;
    str_time = ctime (&secs_now);
    if ( cas >= 10 && cas != 13 ) dump_err_msg();
    sprintf (texte,"%s %s\n Duree %lds STOP %d, %s\n",
		 cas<10?"":ERROR, msg, secs_now-secs_start,
		 cas, str_time);
    fprintf (list_fich,"%s",texte);
    if (bavard) printf ("%s",texte);
    sprintf (texte,
" CPU usage :\n %9s=%.2fs  %9s=%.2fs   %9s=%.2fs\n %9s=%.2fs  %9s=%.2fs   %9s=%.2fs\n",
	 "total", clock_now*CLOCK_UNIT, 
	 "reading", clock_ini*CLOCK_UNIT, 
	 "printing",clock_prt*CLOCK_UNIT,
	 "inverting",clock_inv*CLOCK_UNIT,
	 "min_li",clock_min*CLOCK_UNIT,
	 "cal_deriv",clock_cal*CLOCK_UNIT);
    fprintf (list_fich,"%s",texte);
    if (bavard) printf ("%s",texte);
    fclose (list_fich);
    dydp_fich = xclose (dydp_fich);
    data_fich = xclose (data_fich);
    plg_fich = xclose (plg_fich);
    hkl_fich  = xclose (hkl_fich);
    bragg_fich = xclose(bragg_fich);
    /* on efface si necessaire le fichiers temporaires */
    if (dydp_name && strlen(dydp_name))     unlink (dydp_name);
    if (remark_name && strlen(remark_name)) unlink (remark_name);
    if (data_name && strlen(data_name) && (disk_data==2 || disk_data==8)) unlink (data_name);

    exit (cas);
    }
/* ------------------------------------------------------------------ */
void boucle ()
{   int i,j,n_p;
    char texte[100];
    FLOAT val;

    push_err_msg("boucle(xnd_main.c)");
    time (&secs_now);
    str_time = ctime(&secs_now);
    sprintf (texte,"%s #%d CYCLE #%d #%d %s",minli==0?"\n":"",
         prt_new, cycle, minli,str_time);
    fprintf (list_fich,"%s",texte);
    if (bavard) printf ("%s",texte);
    memset (&indic,0,sizeof(INDIC));
    n_tot = t_pen = t_eff = 0;
    rewind (data_fich);
    for (i=0,l_exper=exper;i<n_exper;i++,l_exper++)
    {       
    push_err_msg(l_exper->nom);
    l_reglage =  &l_exper->reglage;
    l_instru = &l_exper->instru;
    l_assym = &l_exper->assym;
    l_onde = &l_exper->onde;
    dif_nature = l_exper->nature;
    j = l_exper->prof_par + phase_prof_par;
    if (j)
    {   prof_mat = (float *) tst_alloc((j*(j+1))/2,sizeof(float),"prof_mat");
        prof_pos = (int *) tst_alloc(n_par,sizeof(int),"prof_pos");
        }
    else
    {   prof_mat = NULL;
        prof_pos = NULL;
        }
    for (j=0,l_diag=l_exper->diag;j<l_exper->n_diag;j++,l_diag++)
    {   l_indic = &l_diag->indic;
        memset (l_indic,0,sizeof(INDIC));
        n_tot += calcul ();
        indic.sd_wp += l_indic->sd_wp;
        indic.so_wp += l_indic->so_wp;
        indic.sd_p += l_indic->sd_p;
        indic.so_p += l_indic->so_p;
        indic.sd_wp_cor += l_indic->sd_wp_cor;
        indic.s_n +=l_indic->s_n;
        indic.d_val +=l_indic->d_val;
        indic.sd_wp_b += l_indic->sd_wp_b;
        indic.so_wp_b += l_indic->so_wp_b;
        indic.sd_p_b += l_indic->sd_p_b;
        indic.so_p_b += l_indic->so_p_b;
        indic.s_n_b +=l_indic->s_n_b;
        }
     if (prof_pos!=NULL) free (prof_pos);
     if (prof_mat!=NULL) free (prof_mat);
     }
     for (i=0,l_phase=phase;i<n_phase;i++,l_phase++)
     {   if (l_phase->nature>=0 && l_phase->nb_bond) t_pen += penal ();
     }
     fprt_indic (&indic, 1);
     t_eff = t_pen;
     if (mod_lsq & 4) t_eff += indic.sd_wp_cor;
     else if (mod_lsq & 8) t_eff += indic.sd_wp_b;
     else t_eff += indic.sd_wp;
     n_p = n_tot - nt_par;
     if (t_eff>EPSILON)
     {   sprintf (texte," Minimised_Sum =  %.7g (Penalities = %.1f%%)\n",
            t_eff, 100.0*t_pen/t_eff);
    fprintf (list_fich,"%s",texte);
    if (bavard) printf ("%s",texte);
        if (minli==0)
        {   val_sigma = t_eff / n_p;
            val = sqrt ((t_pen+indic.sd_wp_cor)/t_eff);
        fprintf (list_fich,
         "\n Probable errors on variables = %.2f * sigma\n", val);
            val = 3.0/sqrt(1.0*n_p);
            if (n_p > 100)  fprintf (list_fich, 
                " Statisticaly, the model may be accepted if : \n\
   |GoF-1|, |d-2| <~ 3/sqrt(%d)= %.4f\n", n_p, val);
    }   
    pop_err_msg();
    }
    fflush (list_fich);
    pop_err_msg();
    }

/* ------------------------------------------------------------------ */
int calcul ()
{   int    i;
	 int    iphase;
    int    isat;
    char   *modul_txt;

    push_err_msg("calcul(xnd_main.c)");
    dim_bragg = 0;
    temp_exper = l_diag->temp-l_exper->temp_orig;
    temp = &temp_exper;
    minimum = l_diag->w_mini * eps_prof;
    ini_dydp ();
    diag_p0 = l_diag->dtheta0;
    diag_pn = l_diag->dthetaf;
    VAR_init (l_reglage);
    zero   = var_valeur (0);
    polar  = var_valeur (1);
    tan_tm = var_valeur (2);
    eclair = var_valeur (3);
    i_eclair = eclair > EPSILON;

    if (fini && minli==0)
    {   bragg_fich =  tmpfile ();
        if (bragg_fich==NULL)
        fprintf (list_fich," R_BRAGG not calculated, impossible to allocate the needed temporary file\n");
        }

    if (minli==0 && (n_exper>1 || nt_diag>1))
    {   fprintf (list_fich,"\n EXPERIMENT '%s' at %.3f\n", l_exper->nom, l_diag->temp);
        if (bavard) printf (" EXPER '%s' at %.3f\n", l_exper->nom, l_diag->temp);
        }
    /* background is now calculated before the diffraction */
    /* then uncoherent scattering can be added to */
    (*back_ground) ();

    for (act.phase=iphase=0,l_phase=phase;
            iphase<n_phase; iphase++,act.phase++,l_phase++)
    {   push_err_msg(l_phase->nom);
        temp_phase = l_diag->temp-l_phase->temp_orig;
        temp = &temp_phase;
        isat = cas_mag_mod = 0;
        l_satel = NULL;
        l_magnet = NULL;
        modul_txt = "";
        if (l_phase->modul  != NULL)
        {   cas_mag_mod += 2;
            modul_txt = "SATELITES";
            l_magnet = l_phase->modul;
            l_satel = l_magnet->satel;
            }
        if (l_phase->magnet != NULL) 
        {   cas_mag_mod += 1;
            modul_txt = "STUCT. de BASE";                
            l_magnet = l_phase->magnet;
            l_satel = l_magnet->satel;
            }
        if ((dif_nature & EXPER_N)  != 0)         valdif = b_valdif;
        else if ((dif_nature & EXPER_RX) != 0 )   valdif = x_valdif;
        else chk_abort ("dif_nature invalide");
        do
        {   if (minli==0 )
            {   fprintf (list_fich," PHASE #%d : '%s' ", act.phase, l_phase->nom);
                if (cas_mag_mod!=0) fprintf (list_fich," %s #%d\n", modul_txt, isat);
                else fprintf (list_fich,"\n");
                }
             m_bragg = n_bragg = t_bragg= 0;
             if ( l_phase->nature == PHASE_PARASITE || ini_metrique () > 0)
             {   d_echelle = (float *) tst_alloc
                    (l_phase->ech.size+l_phase->transit.size,sizeof(FLOAT),"scale");
                 VAR_init (&l_phase->ech);
            phase_echelle = var_valeur (0);
            bg = var_valeur (1);
            *d_echelle = 1 / phase_echelle;
            for (i=0;i<l_phase->transit.size;i+=TRANSIT)
                 phase_echelle *= f_echelle(i, d_echelle);
            if (n_phase>1 && minli==0)
                 fprintf (list_fich,"  E=%8.3g (%5.3f)",
                     phase_echelle, phase_echelle* *d_echelle);
            if (phase_echelle > EPSILON)
            {   l_atom = l_phase->atom;
                if (l_phase->nature == PHASE_AMORPHE) int_amorphe (); 
                else
                {  make_hkl();
                   dim_bragg += m_bragg;
                   }
                }
            else fprintf (list_fich," Meaningless scale factor\n");
            free (d_echelle);
            }
            else fprintf (list_fich," Cell volume of this phase is non-positive\n");
           fflush(list_fich);

           if (cas_mag_mod!=0) 
           {   push_err_msg("modulated lines");
               /* il y a une structure non magnetique avant les satellites */
               if ( (cas_mag_mod&1) != 0 )
               {   if ((dif_nature & EXPER_MAG) == 0)
                   {   isat = 0;
                       cas_mag_mod &=2;
                       l_satel = NULL;
                       }
                   else if ((cas_mag_mod&4) == 0)
                   {   cas_mag_mod += 4;
                        act.phase++;
                        }
                   else
                   {   if ( ++isat >= l_magnet->nb_sat)
                       {   isat = 0;
                           cas_mag_mod &=2;
                           l_satel = NULL;
                           }
                       else
                       {   act.phase++;
                           l_satel++;
                           }
                       }
                   } /* (cas_mag_mod&1) != 0 */
               if ((cas_mag_mod&1) ==0 && (cas_mag_mod&2) !=0 )
               {
                   if ( ++isat >= l_magnet->nb_sat)
                   {    isat = 0;
                        cas_mag_mod = 0;
                        l_satel = NULL;
                        }
                   else
                   {    act.phase++;
                        l_satel++;
                        }
                    }

              pop_err_msg();
              }
           } while (cas_mag_mod != 0);
		  if (l_phase->uncoherent & 1 )   gen_uncoherent();
        if (l_phase->uncoherent & 6 )   gen_tds();
        pop_err_msg();
        } /* for iphase */

    temp = &temp_exper;
    residu();
    if (bragg_fich!=NULL)
    {    residu_hkl();
    bragg_fich=xclose(bragg_fich);
    }
    free (l_diag->points);
    free (dy_dp); 
    fflush(list_fich);
    pop_err_msg();
    return (n_pts);
	 }
/* ---------------------------------------------------------- */
void fprt_indic (P_(INDIC *) indic, P_(int) cas)
#ifdef NO_PROTO
INDIC *indic;
int cas;
#endif
{    FLOAT rwp,rp,rwp_cor,re,ren,d_val,chi;
     FLOAT rwp_b, rp_b;
     char texte[100];
     if (indic->so_wp < EPSILON) return;
     rwp = sqrt (indic->sd_wp/indic->so_wp);
     rwp_cor = sqrt (indic->sd_wp_cor/indic->so_wp);
     rp = indic->sd_p/indic->so_p;
     if (indic->so_wp_b > EPSILON)
     {   rwp_b = sqrt(indic->sd_wp_b/indic->so_wp_b);
     rp_b = indic->sd_p_b/indic->so_p_b;
     }  else rwp_b = rp_b = 0;
     if (cas) ren = indic->s_n + n_pen - nt_par;
     else    ren =  indic->s_n + (n_pen - nt_par)/ (FLOAT) nt_diag;
     re = sqrt (ren/indic->so_wp);
     d_val = indic->d_val / indic->sd_wp;
     chi = rwp/re;
     sprintf (texte,
        " Rwp=%.4f  Rp=%.4f  Rwp_c=%.4f  GoF=%.2f  (Rwp_b=%.4f Rp_b=%.4f)\n",
     rwp, rp, rwp_cor, chi, rwp_b, rp_b);
     if ((cas!=0) && (minli==0)) fprintf (list_fich,"\n");
     fprintf (list_fich,"%s",texte);
     if ((cas!=0) && (minli==0)) fprintf (list_fich,
" SwDi2=%.5g SwIo2=%.5g SDi=%.5g SIo=%.5g  SwDp_c=%.5g\n\
 SwDi2_b=%.5g SwIo2_b=%.5g SDi_b=%.5g SIo_b=%.5g  N_b=%d\n\
 Rexp=%.3f  d-2=%.2f  Ne=%.0f  N=%d\n",
    indic->sd_wp,indic->so_wp,indic->sd_p,indic->so_p,indic->sd_wp_cor,
    indic->sd_wp_b,indic->so_wp_b, indic->sd_p_b,indic->so_p_b,indic->s_n_b,
    re,d_val-2,ren,indic->s_n); 
     if (cas && bavard) printf ("%s",texte );
     }


