/* XND_MOD.C   traitements specif des struct modules ou magnetiques */

#include "xnd_def.h"
#include "xnd_cah.h"

/* ---------------------------------------------------------- */
/* dummy procedure for magnetic atom in structure factor */
static int  fhkl_magnet (P_(int) pos, P_(int) mul )
#ifdef NO_PROTO
int pos, mul;
#endif
{
    int i,j,nb;
    int   isym;
    float x,y,z,f,fm;
    float bb[6];
    float hh,kk,ll;
    float *l_coef;
    float fbm;
    double trans;
    double phi,c_phi,s_phi,debye;
    double a = 0;
    double b = 0;

    nb = l_atom->nb;
    if ((l_atom->nature && MAGNET) == 0)    
       if (deriv_atom == 0) return 0; else return nb;


   printf( " Magnet. Non Operationel");
   fprintf( list_fich, " Magnet. Non Operationel");

    VAR_init (&l_atom->x);
    x = var_valeur (0);
    y = var_valeur (1);
    z = var_valeur (2);
    if ((l_atom->nature & 1) == 0)
	 debye = exp (-0.25 * var_valeur (4) * q);
    else for (i=0;i<6;i++)
	 bb[i] = var_valeur (4+i);
    if (deriv_atom)   for (j=0;j<nb;j++)
    {    fa_deriv[pos+j] = 0;
	 if (!centro) fb_deriv[pos+j] = 0;
	 }
    for (isym=0,l_coef=l_symgrp->coef;isym<l_symgrp->nops;isym++,l_coef+=12)
    {   hh = l_coef[0] * H + l_coef[1] * K + l_coef[2] * L;
	kk = l_coef[3] * H + l_coef[4] * K + l_coef[5] * L;
	ll = l_coef[6] * H + l_coef[7] * K + l_coef[8] * L;
	trans = H * l_coef[9] + K * l_coef[10] + L * l_coef[11];
	phi = M_2PI * (hh * x + kk * y + ll * z + trans);
	if (l_atom->nature & B_ANISO)
	 {   debye = exp(-(bb[0]*hh*hh+bb[1]*kk*kk+bb[2]*ll*ll
			   +bb[3]*hh*kk+bb[4]*hh*ll+bb[5]*kk*ll));
	    }
        a += c_phi = debye * cos(phi);
	b += s_phi = debye * sin(phi);
       /* Kx .... */
	   
	if (deriv_atom)
	{    fa_deriv [pos]   -= M_2PI * hh * s_phi;
	     fa_deriv [pos+1] -= M_2PI * kk * s_phi;
	     fa_deriv [pos+2] -= M_2PI * ll * s_phi;
	     if (!centro)
	     {    fb_deriv [pos]   += M_2PI * hh * c_phi;
		  fb_deriv [pos+1] += M_2PI * kk * c_phi;
		  fb_deriv [pos+2] += M_2PI * ll * c_phi;
		  }
	     if (l_atom->nature & 1)
	     {     fa_deriv [pos+4] -= hh * hh * c_phi;
		   fa_deriv [pos+5] -= kk * kk * c_phi;
		   fa_deriv [pos+6] -= ll * ll * c_phi;
		   fa_deriv [pos+7] -= hh * kk * c_phi;
		   fa_deriv [pos+8] -= hh * ll * c_phi;
		   fa_deriv [pos+9] -= kk * ll * c_phi;
		   if (!centro)
		   {    fb_deriv [pos+4] -= hh * hh * s_phi;
			fb_deriv [pos+5] -= kk * kk * s_phi;
			fb_deriv [pos+6] -= ll * ll * s_phi;
			fb_deriv [pos+7] -= hh * kk * s_phi;
			fb_deriv [pos+8] -= hh * ll * s_phi;
			fb_deriv [pos+9] -= kk * ll * s_phi;
		   }   }
	     }
	}
	f = (*valdif)();
    fm = f * mul * var_valeur (3);
    F_A += fm * a;
    if (!centro)  F_B += fm * b;
    if (dif_nature == EXPER_RXA)
    {    fbm = mul * anodif_b();
	 act.f_am += fbm * a ;
	 if (!centro)  act.f_bm += fbm * b;
	    }
    if (deriv_atom==0) return (0);
    for (j=0;j<nb;j++)  fa_deriv[pos+j] *= fm;
    fa_deriv[pos+3] = f * a;
    if ((l_atom->nature & 1)==0) fa_deriv[pos+4] = -0.25 * q * F_A;
    if (dif_nature == EXPER_RXA)
	 for (j=0;j<nb;j++)  fam_deriv[pos+j] = fa_deriv[pos+j] * fbm/fm;
    if (centro) return (nb);
    for (j=0;j<nb;j++)  fb_deriv[pos+j] *= fm;
    fb_deriv[pos+3] = f * b;
    if ((l_atom->nature & 1)==0) fb_deriv[pos+4] = -0.25 * q * F_B;
     if (dif_nature == EXPER_RXA)
	 for (j=0;j<nb;j++)  fbm_deriv[pos+j] = fb_deriv[pos+j] * fbm/fm;
    return (nb);
    }

/* ---------------------------------------------------------- */
/* ---------------------------------------------------------- */
void hkl_modul(P_(void))
{    int i;
     int m = 0;

     h_eff = H;
     k_eff = K;
     l_eff = L;
     VAR_init (&l_magnet->vecteur);
     for (i=0; i < l_magnet->dimension; i++, m+= 3)
     {  h_eff +=  l_satel->hkl_sat[i] * var_valeur (m);
        k_eff +=  l_satel->hkl_sat[i] * var_valeur (m+1);
	l_eff +=  l_satel->hkl_sat[i] * var_valeur (m+2);
        }
     }
 /* ---------------------------------------------------------- */
void ini_d_vecteur (P_(float) dt_dq)
#ifdef NO_PROTO
float dt_dq;
#endif
{    int i;
     int m = 0;

     VAR_init (&l_magnet->vecteur);
     for (i=0; i < l_magnet->dimension; i++, m+= 3)
     {  vecteur_deriv[m] = dt_dq  * l_satel->hkl_sat[i] * 
                ( 2 * h_eff * g_aa + k_eff * g_ab + l_eff * g_ac);
        vecteur_deriv[m+1] = dt_dq  * l_satel->hkl_sat[i] *
                ( h_eff * g_ab + 2 * k_eff * g_bb + l_eff * g_bc);
        vecteur_deriv[m+2] = dt_dq  * l_satel->hkl_sat[i] *
                ( h_eff * g_ac + k_eff * g_bc + 2 * l_eff * g_cc);
        }
    }
 /* ---------------------------------------------------------- */
void magnet_hkl (P_(void))
{
    
    hkl_eff = hkl_modul;
    vecteur_deriv = (float *) tst_alloc (3 * l_magnet->dimension,
              sizeof(float), "derivees vecteur");
                  
    l_phase->hkl = l_satel->hkl;
    l_phase->nb_hkl = l_satel->nb_hkl;
    l_phase->intens = l_satel->intens;

    if (cas_mag_mod & 1)          fhkl_eff = fhkl_atom;
    else if (cas_mag_mod & 4)     fhkl_eff = fhkl_magnet;
    else if (cas_mag_mod & 2)
         fhkl_eff = (l_magnet->nature <= 0)? fhkl_incmod : fhkl_commod;
    else chk_abort ("magnet_hkl");

    if (l_satel->nb_hkl > 0)  get_hkl();
         else                 gen_hkl();

       
    free (vecteur_deriv);
    }
  /* ---------------------------------------------------------- */
