/* XND_NEW.C       new file */

#include "xnd_def.h"
#include <string.h>
#include <ctype.h>

/* -------------------------------------------------------------------- */
/* -------------------------------------------------------------------- */
void write_remark( P_(sint) nombre)
#ifdef NO_PROTO
sint nombre;
#endif
{   char remark[102];
    fprintf (new_fich,"\n");
    while (nombre--) 
    if (remark_fich != NULL)
     {    fgets (remark, 100, remark_fich);
          fputs (remark, new_fich);
          }
     }
/* -------------------------------------------------------------------- */
/* cas speciaux selon xnd_rvar.c */

static void fnew_var ( P_(VAR *) var, P_(int) arg)
#ifdef NO_PROTO
VAR * var;
int arg;
#endif
{    int  i,j;
     float *v,*s;
     int *c;
     float *pos;
     HKL *p_hkl;
     int  ligne;

     write_remark (var->remark);

     if (var->size==0) return;
     VAR_init(var);
     if (dim==1) fprintf(new_fich,"\n %d",ordre);
     else fprintf(new_fich,"\n -%d %d",ordre,dim);
     ligne = ((dim == 1) && (ordre == 1)) ? 2 : 1;
     switch (arg)
     {    case VAR_BG  : pos = l_exper->back_pos;
		break;
	  case VAR_HKL : p_hkl = l_phase->hkl;
		if (ordre==0 && l_phase->n_atom!=0)
		 for (j=0;j<l_phase->nb_hkl;j++,p_hkl++)
		   fprintf (new_fich,"\n %3d %3d %3d   ",
		   p_hkl->h[0],p_hkl->h[1],p_hkl->h[2]);  break;
	   case VAR_RADIAL : pos = l_radial->diff_pos;
		break;
	  }
     if (ligne == 3 && (var->ncle == 2 || var->ncle==4)) ligne = 2;
     v = variable->value;
     s = variable->shift;
     c = variable->codelu;
    if (ordre==0) return;
     for (i=0;i<var->size;i++)
     {       switch (arg)
     {    case VAR_BG :
	  case VAR_RADIAL :
		fprintf (new_fich,"\n %8.3f   ", *pos ); pos++;
		break;
	  case VAR_HKL :   fprintf (new_fich,"\n %3d %3d %3d   ",
		   p_hkl->h[0],p_hkl->h[1],p_hkl->h[2]); p_hkl++; break;
	  default :  fprintf(new_fich,"%s", (i%ligne==0)?"\n":"  ");
	  }
	 for (io=0;io<ordre;(io++,v++))
	 {   fprintf(new_fich,"  %15.8g",*v);
	     for (id=0;id<dim;(id++,c++,s++))
	     {   if (arg == VAR_HKL && *v < 0  && *c > 0 && io == 0 ) *c = - *c;
		 fprintf(new_fich," %3d",*c);
		 if (*c >= 10 || *c <= -10) fprintf(new_fich," %8f",*s);
		 else fprintf(new_fich,"         ");
		 };
	     if (ordre > 2 && io % 3 == 2 ) fprintf(new_fich,"\n           ");
	     };	 
	 if (ordre > 2 && io % 3 != 2 ) fprintf(new_fich,"\n");
         };
         fprintf(new_fich,"\n");
     }

/* -------------------------------------------------------------------- */

static void new_coord (P_(int) nb, P_(int) angle, P_(DIST *) dist)
#ifdef NO_PROTO
int nb, angle;
DIST *dist;
#endif
{   int   i,j,n;
	DIST  *p_dist = dist;
	COORD *coord;
	for (i=0;i<nb;i++,p_dist++)
	{   write_remark (p_dist->remark);
	    fprintf (new_fich,"%d %f",p_dist->nb_coord,p_dist->sigma);
		fnew_var (&p_dist->dist,VAR_STD);
		coord = p_dist->coord;
		for (j=0;j<p_dist->nb_coord;j++,coord++)
		{   fprintf (new_fich,"%s %6s",j==0?"\n":"",
			atom_ptr(coord->at0)->nom);
		    for (n=0; n<=angle;n++)
		    {	fprintf (new_fich,"  %6s",
			    atom_ptr(coord->endat[n].at)->nom);
			fprint_xyz_pos  (new_fich, coord->endat[n].coef, '\n');
			}
		    }
		}
	}

/* -------------------------------------------------------------------- */
static char *new_dif (P_(char *) esp)
#ifdef NO_PROTO
char *esp;
#endif
{   char *p_esp, *x_esp;
	if (l_atom->ndif!=NULL)
	{   strcpy (esp,(l_atom->ndif)->nom);
		if (l_atom->xdif!=NULL)
		{   x_esp = (l_atom->xdif)->nom;
			while (isalpha(*x_esp)) x_esp++;
			strcat (esp,x_esp);
			};
		p_esp = esp + (esp[0]=='0'? 1 : 0);
		}
	else
	{   strcpy (esp,(l_atom->xdif)->nom);
		p_esp = esp;
		}
	return (p_esp);
	}

/* -------------------------------------------------------------------- */
static void new_magnet (P_(TMODUL *) magnet)
#ifdef NO_PROTO
TMODUL * magnet;
#endif
{   int i, j, nb_sat;
    SATEL *satel;

   nb_sat = magnet->nb_sat;
    satel = magnet->satel;

    fprintf (new_fich," %d %d %d\n", magnet->dimension,
	 magnet->nature, magnet->nb_sat);
    fprintf (new_fich," %s\n",magnet->symgrp);
  if (magnet==l_phase->magnet)
     {   fprintf (new_fich," %d\n", satel->nb_hkl);
	 satel++;
	 }
  for (i=0; i<nb_sat; i++, satel++)
   {   fprintf (new_fich," %d", satel->nb_hkl);
       for (j=0; j<dim;j++)
	   fprintf (new_fich,"  %d ", satel->hkl_sat[j]);
       fprintf (new_fich,"\n");
       }
    fnew_var (&magnet->vecteur, VAR_STD);

    }

/* ------------------------------------------------------------------ */
static void new_magnet_hkl (P_(TMODUL *) magnet)
#ifdef NO_PROTO
TMODUL * magnet;
#endif
{
    SATEL *satel;
    int i, nb_sat;
    nb_sat = magnet->nb_sat;
    satel = magnet->satel;

    for (i=0; i<nb_sat; i++, satel++)  if (satel->nb_hkl > 0)
    {   l_phase->hkl = satel->hkl;
	l_phase->nb_hkl = satel->nb_hkl;
	    fnew_var (&satel->intens, VAR_HKL );
       }
    }
/* -------------------------------------------------------------------- */

static void new_crystal (P_(void))
{    int    i,j;
     char esp[10];
     float *p_bond;

	fprintf (new_fich,"%s\n %d  %d  %d  %d  %d  %d\n",
	  l_phase->symgrp->nom, l_phase->n_orien, l_phase->n_prof, 
	  l_phase->n_atom, l_phase->nb_bloc, l_phase->nb_tds, l_phase->nb_bond);
	fnew_var (&l_phase->cell, VAR_STD);
        if (l_phase->nature == PHASE_MAGNET) new_magnet (l_phase->magnet);
        if (l_phase->nature == PHASE_MODUL)  new_magnet (l_phase->modul);
	if (l_phase->nt_orien)
	{   write_remark (l_phase->remark_orien);
             for (j=0; j<l_phase->nt_orien; j++) 
			fprintf (new_fich," %d",l_phase->c_orien[j]);
	     fprintf (new_fich,"\n");
	     fnew_var(&l_phase->orien, VAR_ORIEN);
	     };
	if (l_phase->n_prof)
	{    write_remark (l_phase->remark_prof);
             for (j=0; j<l_phase->n_prof; j++) 
                    fprintf (new_fich," %d",l_phase->c_prof[j]);
	     fprintf (new_fich,"\n");
	     fnew_var(&l_phase->prof, VAR_ORIEN);
	     fnew_var(&l_phase->assym, VAR_ORIEN);
	     };
	fprintf (new_fich,"\n");
	for (j=0,l_atom=l_phase->atom;j<l_phase->n_atom;j++,l_atom++)
	{   write_remark (l_atom->remark);
            fprintf (new_fich,"\n %s %s %d",l_atom->nom,
		new_dif(esp),l_atom->nature);
	     fnew_var (&l_atom->x, VAR_ATOM);
	     if ( l_atom->n_modul ) fnew_var (&l_atom->modul, VAR_STD);
	     };
	if (l_phase->nb_bloc)
	{    fnew_var(&l_phase->bloc, VAR_STD);
	     for (i=0;i<l_phase->nb_bloc;i++)
	     {   fprintf (new_fich,"\n %d",l_phase->bl_atom[i]);
	         for (j=0,l_atom=l_phase->bl_ortho[i];j<l_phase->bl_atom[i];
	         		j++,l_atom++)
	         {   write_remark (l_atom->remark);
                     fprintf (new_fich,"\n %s %s %d",l_atom->nom,
		     new_dif(esp),l_atom->nature);
	             fnew_var (&l_atom->x, VAR_STD); 
	    };  };   };
	if (l_phase->nature == PHASE_HKL_LU)
                         fnew_var(&l_phase->intens, VAR_HKL);
        else if (l_phase->nature == PHASE_MAGNET)
                        new_magnet_hkl (l_phase->magnet);
        else if (l_phase->nature == PHASE_MODUL)
                        new_magnet_hkl (l_phase->modul);

	if (l_phase->nb_bond)
	{   write_remark (l_phase->remark_bond);
            p_bond = l_phase->bond;
	    fprintf (new_fich,"%3d%3d\n",l_phase->nb_dist,l_phase->nb_angl);
	    for (i=0;i<l_phase->nb_bond;i++,p_bond++)
			fprintf (new_fich," %f\n",*p_bond);
		new_coord (l_phase->nb_dist, 0, l_phase->dist);
		new_coord (l_phase->nb_angl, 1, l_phase->angl);
		}
	fprintf (new_fich,"\n");
	}
/* -------------------------------------------------------------------- */
static void new_quasi (P_(void))
{    int    j;

	fprintf (new_fich," %d  %d\n", l_phase->n_prof, l_phase->nb_dist);
	fnew_var (&l_phase->cell,1);
	if (l_phase->n_prof)
	{    fprintf (new_fich,"\n");
	     for (j=0; j<l_phase->n_prof; j++) 
	         fprintf (new_fich," %d",l_phase->c_prof[j]);
	     fprintf (new_fich,"\n");
	     fnew_var(&l_phase->prof, VAR_STD);
	     fnew_var(&l_phase->assym, VAR_STD);
	     };
	fnew_var (&l_phase->intens, VAR_HKL);
	}
/* -------------------------------------------------------------------- */
static void new_parasite (P_(void))
{    int    j;

	fprintf (new_fich," %d  %d\n", l_phase->n_prof, l_phase->nb_hkl);
	if (l_phase->n_prof)
	{    fprintf (new_fich,"\n");
             for (j=0; j<l_phase->n_prof; j++) 
 		  fprintf (new_fich," %d",l_phase->c_prof[j]);
	     fprintf (new_fich,"\n");
	     fnew_var(&l_phase->prof, VAR_STD);
	     fnew_var(&l_phase->assym, VAR_STD);
	     }
	fnew_var (&l_phase->intens, VAR_STD);
	}
/* -------------------------------------------------------------------- */
static void new_amorphe (P_(void))
{    int    i;

	fprintf (new_fich," %d\n", l_phase->nb_dist);
	l_radial = l_phase->radial;
	for (i=0; i<l_phase->nb_dist;i++,l_radial++)
	{   fprintf (new_fich," %d\n %6s %6s\n",
                 l_radial->nb_pos, l_radial->at0.nom, l_radial->at1.nom);
	    fnew_var (&l_radial->distrib, VAR_RADIAL);
	    }
	}
/* -------------------------------------------------------------------- */
/* -------------------------------------------------------------------- */
void new_cdr (P_(void))
{   int    i, j, id, nature;
	 float  pas;
    F_INFO *l_info;

#ifndef SEEK_SET
#define SEEK_SET 0
#endif

    new_fich = tst_open (new_name,"a", "NEW file");
    if (remark_fich != NULL) fseek (remark_fich, 0, SEEK_SET);
	for (i=0,l_exper = exper;i<n_exper;i++,l_exper++)
	{   write_remark (l_exper->remark);
            switch (l_exper->nature)
	   {  case EXPER_RX  : nature = 0; break;
	      case EXPER_N   : nature = 1; break;
	      case EXPER_RXA : nature = 2; break;
	      case EXPER_NM  : nature = 3; break;
	      }
		if ( l_exper->nature & EXPER_SINGLE_CRYSTAL ) nature +=8;
		fprintf(new_fich,"\n %d  %d  %d  %d  %d  %d  %.3f\n %s\n",
		nature, l_exper->techn, l_exper->n_diag,l_exper->dfich,
		l_exper->n_lambda, l_exper->n_back,
		l_exper->temp_orig,l_exper->nom);
		if (l_exper->dfich/10  != 2)
		{
		for (j=0,l_diag=l_exper->diag;j<l_exper->n_diag;j++,l_diag++)
		if (l_exper->dfich == 0)
		{	pas = (l_diag->dthetaf - l_diag->dtheta0)
				/ l_diag->n_points;
			fprintf (new_fich,"%f  %f  %f  %f\n",
			l_diag->temp, l_diag->dtheta0, pas, l_diag->dthetaf);
			}
		else fprintf (new_fich," %.3f %d  %s\n",
			l_diag->temp, l_diag->n_points, l_diag->fich_name);
			}
		else 
		{     l_diag = l_exper->diag;
		      l_info = l_exper->f_info;
		      fprintf (new_fich," %d %f %d %d %d %f %s\n",
     	   	        l_diag->n_points, l_info->tmin, 
     	    	        l_info->cumul, l_info->skip, l_info->numvar, 
     	    		l_info->mono, l_diag->fich_name);
			}	
		fnew_var (&l_exper->onde, VAR_STD);
		fnew_var (&l_exper->back, VAR_BG);
		fnew_var (&l_exper->reglage, VAR_STD);
		fnew_var (&l_exper->instru, VAR_STD);
		fnew_var (&l_exper->assym, VAR_STD);
		};
		
	fprintf(new_fich,"\n");
	for (i=0,l_phase = phase;i<n_phase;i++,l_phase++)
	{   write_remark (l_phase->remark);
            id = l_phase->nature;
            if (id == 1) id = l_phase->nb_hkl;
            fprintf (new_fich,"\n %d  %d %.3f\n %s\n",
		  id, l_phase->transit.size/TRANSIT,
		  l_phase->temp_orig,l_phase->nom);
	  	fnew_var(&l_phase->ech, VAR_STD);
	  	fnew_var (&l_phase->transit, VAR_STD);
                if (l_phase->transit.size) fprintf(new_fich,"\n");
		switch (l_phase->nature)
		{  case PHASE_AMORPHE  : new_amorphe (); break;
		   case PHASE_PARASITE : new_parasite (); break;
		   case PHASE_QUASI    : new_quasi (); break;
		   default             : new_crystal ();
                    };
		};
        write_remark (end0_remark);
	fprintf(new_fich,"\n %.4g  %d \n %f\n",
	      marquardt,c_marquardt,xt_eff);
        write_remark (end1_remark);
        if (ferror (new_fich) ) termine (19,"ecriture fichier new");
	new_fich = xclose (new_fich);
	}
/* -------------------------------------------------------------------- */
/* -------------------------------------------------------------------- */

