/* XND_PRO.C     main procedure for profile functions */
/*               they are now in xnd_pr??.c files     */
#define EXTERN_PROF
#include "xnd_prof.h"
float (*f_assym)(P_(void));
/* =========================================================== */
/* define the line profile and initialize the profil functions */
/* ----------------------------------------------------------- */
int def_profil (P_(void))
{    int i, j;
     float v, w;
     float val;
     temp = &temp_exper;
     VAR_init (l_onde);
     val = var_valeur (act.lambda*LAMBDA+2);
     sign_onde = val >= 0 ? 1 : -1;
     W_L = fabs ( val * (tan_t-tan_tm));
     W_G = sqr (var_valeur (act.lambda*LAMBDA+3) * (tan_t-tan_tm));
     VAR_init (l_instru);
     val = var_valeur( 0 );
     sign_instru0 = val >= 0 ? 1 : -1;
     W_L +=   fabs( val );
     val = var_valeur( 2 );
     sign_instru2 = val >= 0 ? 1 : -1;
     W_L +=  fabs( val / tan_2t );
     W_G +=  sqr (var_valeur (1)) + sqr (var_valeur (3) / tan_2t);
     for (i=0; i<max_assym;i++) act.assym[i]  = 0;
     VAR_init (l_assym);
     for (i=j=0; i<max_assym;i++,j+=ASSYM)
         act.assym[i]  = var_valeur (j) / tan_2t + var_valeur (1+j) / tan_t
          + var_valeur (2+j) * sin_2t;
     temp = &temp_phase;
     /* new def in 1.07 : the unique width of a phase depends on the direction */
     VAR_init (&l_phase->prof);
     phase_wg = phase_wl = 0;
     for (i=0;i<l_phase->n_prof;i++)
     {   val = f_orien(i,1);    /* stores also values in orien_prof[0..2] */
         orien_prof[i*ORIEN_PROF+3]=orien_prof[i*ORIEN_PROF+4]=0;
         if ((v= var_valeur (i*PROF))!=0) 
         {   phase_wl += w = val * v / cos_t;
             orien_prof[i*ORIEN_PROF+3] += w;
             }
         if ((v= var_valeur (1+i*PROF)) >0)
         {   phase_wg += w = val * v / cos_t;
             orien_prof[i*ORIEN_PROF+4] += w;
             }
     if ((v= var_valeur (2+i*PROF))!=0)
     {   phase_wl += w =val * v * tan_t;
         orien_prof[i*ORIEN_PROF+3] += w;
         }
     if ((v= var_valeur (3+i*PROF)) >0)
     {   phase_wg += w =val * v * tan_t;
         orien_prof[i*ORIEN_PROF+4] += w;
         }
     }
     W_L += fabs( phase_wl );
     sign_phase = phase_wl >= 0 ? 1 : -1;
     W_G += sqr( phase_wg );
     if ( W_L < 0 ) W_L = 0;
     if ( W_G > 0 ) W_G = sqrt (W_G); else W_G = 0;
     w_assym = W_G + W_L;
     /* new def in 1.08 : assym no more in width block */
     VAR_init (&l_phase->assym);
     for (i=0;i<l_phase->n_prof;i++)
     {   val = f_orien(i,1);
     for (j=0;j<max_assym;j++)
     {   orien_prof[i*ORIEN_PROF+5+j]=0;
         if ((v= var_valeur (j*(PASSYM+i*max_assym)))!=0)
         {    act.assym[j] += w = v * val ;
              orien_prof[i*ORIEN_PROF+5+j] += w;
              }
         if ((v= var_valeur (1+j*(PASSYM+i*max_assym)))!=0)
         {    act.assym[j] += w = v * val * tan_t;
              orien_prof[i*ORIEN_PROF+5+j] += w;
              }
     }   }
    return (1);
    }
/* -------------------------------------------------------- */
int ini_profil (P_(void))
{   x_coef = y_coef = 0;
    prof_case = 0;
    if (W_L<EPSILON)
    {   if (W_G > EPSILON)     return ( ini_gauss ());
    else return (0);
    }
    else if (W_G < EPSILON)     return ( ini_lorentz ());
    else if (voigt_mode)        return ( ini_voigt ());
    else                        return ( ini_psvoigt ());
    }

/* -------------------------------------------------------- */
float profil (P_(void))
{  float valeur;
   switch (prof_case)
   {    case  1 : valeur = gauss_profil   (); break;
		  case  2 : valeur = lorentz_profil (); break;
		  case  3 : valeur = psvoigt_profil (); break;
		  case  4 : valeur = voigt_profil   (); break;
        default : return 0;
    }
	 return (valeur * (*f_assym)());
    }
/* ----------------------------------------------------------- */
void d_pil   ( P_(void))
{   int i;
    switch (prof_case)
    { case 0 : d_p_t = d_p_g= d_p_l= 0;
        break;
      case 1 : d_p_t = gauss_dprof_dt() * as_coef - w_x * as_deriv; 
        d_p_g = gauss_dprof_dg() * as_coef;
        d_p_l = 0;
        for ( i = 0; i < max_assym ; i++) d_p_a[i] = w_x * as_d[i];
        break;
      case 2 : d_p_t = lorentz_dprof_dt() * as_coef - w_y * as_deriv;
        d_p_l = lorentz_dprof_dl() * as_coef;
        d_p_g = 0;
		  for ( i = 0; i < max_assym ; i++) d_p_a[i] = w_y * as_d[i];
        break;
       case 3 : d_p_t = psvoigt_dprof_dt()* as_coef-(w_x+w_y)*as_deriv;
        d_p_g = psvoigt_dprof_dg() * as_coef;
        d_p_l = psvoigt_dprof_dl() * as_coef;
		  for ( i = 0; i < max_assym ; i++) d_p_a[i] = (w_x+w_y) * as_d[i];
        break;
       case 4 : d_p_t = voigt_dprof_dt() * as_coef - w_x * as_deriv;
        d_p_g = voigt_dprof_dg() * as_coef;
        d_p_l = voigt_dprof_dl() * as_coef;
		  for ( i = 0; i < max_assym ; i++) d_p_a[i] = w_x * as_d[i];
        break;
    }
    }
/* ----------------------------------------------------------- */
void init_assym_function(P_(void))
{   	 fprintf (list_fich," The assymetry functions code %d implies : ", max_assym);
	 if (max_assym )
	 {   if (max_assym>0)
		  {   assym_mode = 1;
			fprintf (list_fich,"odd derivative of gaussian\n");
			f_assym = assym_herm;
			}
		  else
		  {   assym_mode = 2;
			fprintf (list_fich,"odd power expansion with gaussian\n");
			max_assym = -max_assym;
			f_assym = assym_power;
			}
        tst_abort (( max_assym>MAX_ASSYM) , "too much assym functions required max(%d)", MAX_ASSYM);
		  }
	 else
	 {   assym_mode = 0;
		  max_assym=2;
		  fprintf (list_fich,"no expansion but power adjustment\n");
		  f_assym = assym_adj;
		  }
	}
/* =========================================================== */


