/* XND_RDini.C    read the first data */

#include "xnd_def.h"

#define  EXTERN_RD
#include "xnd_rdh.h"

#ifndef MAC_OS
#include <sys/stat.h>   /* used in get_tmpfile */
#define DUMMYSTAT   {  long  dummy[100]; } 
#else
#include <unix.h>   
#define DUMMYSTAT
#endif

#include <errno.h>
#ifndef ENOENT
#define ENOENT   2
#endif

/* mode d'ouverture des fichiers */
#ifdef MSDOS
#define R_MODE  "rb"
#define W_MODE  "w+b"
#else
#define R_MODE  "r"
#define W_MODE  "w+"
#endif
/* ------------------------------------------------------------------ */
void make_path(P_(char *)result, P_(char *) path, P_(char *) id)
#ifdef NO_PROTO
char * result;
char * path;
char * id;
#endif
{   char *pos;
    strcpy(result, path);
#ifndef VAXC
    pos = result + strlen(result)-1;
    if (*pos!=END_PATH_STR[0])  strcat(result, END_PATH_STR); 
#endif
    strcat(result, id);
    }
/* ------------------------------------------------------------------ */
/*   pour connaitre le path du programme a l'execution */
/*   ce sous programme est machine dependant           */
/*   sys/stat.h n'est pas inclu car il coince parfois  */
void path2prog (P_(void))
{
     char *pos;
#ifdef UNIX_OS
     char * chaine;
     char * prg;
     char  prog[NAME_LG];
     struct stat DUMMYSTAT stat_val;

    strcpy (lect->data_path,PROG_PATH);     /* empty path now */
    prg = lect->argc;                       /* name of executable */
    if ( ( prg[0] == '/' )             
        || ( prg[0] == '.' && prg[1] == '/' )
        || ( prg[0] == '.' && prg[1] == '.' && prg[2] == '/' ) ) 
         strcpy (lect->data_path, prg);     /* absolute path */
    else   
    if ( prg[0] == '~' )                  /* path relative to home */
    {    chaine = (char *) getenv ("HOME"); 
         if (chaine != NULL) strcpy (lect->data_path, chaine);
     strcat (lect->data_path, prg+1);
         }
    else   
    {   chaine = (char *) getenv ("PATH"); /* exploring path */
        while (chaine != NULL)
        {     pos = strchr (chaine, ':');
          if (pos != NULL) *pos = 0;
              strcpy (prog, chaine);
          strcat (prog, "/");
          strcat (prog, lect->argc);
          if ( stat (prog , &stat_val)==0)
          {    strcpy (lect->data_path, prog);
               break;
               }
              if (pos != NULL) chaine = pos + 1; else chaine = NULL;
          }
     }
#else
#ifdef MAC_OS
    strcpy (lect->data_path, "");
#else
    strcpy (lect->data_path, lect->argc);
#endif
#endif
    pos = strrchr (lect->data_path,END_PATH_STR[0]);
    if (pos != NULL) *(pos+1) = 0;
    }
/* ------------------------------------------------------------------ */
void prog_id(P_(char *)string)
#ifdef NO_PROTO
char * string;
#endif
{    char *pos;
#ifdef MSDOS
     strcpy  (string, lect->argc);      return;
#else
#ifdef VAXC
     strcpy  (string, lect->argc);      return;
#else
     strcpy (string, lect->data_path);
#ifndef MAC_OS
     pos = strrchr (lect->argc, END_PATH_STR[0]);
     if (pos == NULL) pos = lect->argc;
    else if ( *(pos+1) != 0) pos++;
#else
     pos = PRG_ID;
#endif

     strcat (string, pos);     return;
#endif
#endif
     }
/* ------------------------------------------------------------------ */
void strup (P_(char *) string)
#ifdef NO_PROTO
char * string;
#endif
{    char *c;
    c = string;
    while (*c !=0)
    {    if (islower(*c)) *c = toupper(*c);
        c++;
    }    }

/* ------------------------------------------------------------------ */
/* avoid fscans to be cancelled by cr                                 */
/* allowing dos files to be used with Sun KK compiler                 */
void purge_cr(P_(void))
{     char cr[5];
      push_err_msg("purge_cr(xnd-rd.c)");
      while( fscanf(coord_fich, " %[\r]", cr)==1 );
      pop_err_msg();
      }
/* ------------------------------------------------------------------ */
/* traiter les lignes de commentaires en lecture                      */
sint read_remark()
{     sint lues = 0;
      char ligne[102];
      push_err_msg("read_remark(xnd-rd.c)");
      purge_cr();
      while ( fscanf (coord_fich, " %[#]", ligne) == 1)
      {  fgets ( &ligne[1], 100, coord_fich);
         fputs (ligne, list_fich);
         if (remark_fich != NULL)
         {    fputs (ligne, remark_fich);
              lues++;
              }
         else if (new_fich != NULL)
         {    fputs (ligne, new_fich);
              }
         purge_cr();
         }
      pop_err_msg();
      return lues;
      }
/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */
FILE *get_tmpfile (P_(char *) path, P_(char *) name, P_(char *) reason)
#ifdef NO_PROTO
char *path;
char *name;
char *reason;
#endif
{   struct stat DUMMYSTAT stat_buf;
    char buffer[100];
    int num, result;
	 if (path == NULL || strlen(path) == 0)
    {    fprintf(list_fich, " Using system tmpfile for %s\n", reason);
         name = NULL;
     return tmpfile();
     }
    make_path(name, path, PRG_ID);
    for (num = result = 0; num < 999; num++ )
    {   sprintf(buffer,"%s_%d.$$$", name, num);
		  result = stat( buffer, &stat_buf );
        if ( result != -1 ) continue;
        if ( errno != ENOENT ) continue;
		  errno = 0;
        strcpy( name, buffer);
        fprintf(list_fich, " Using '%s' as temporary file for %s\n", name, reason);
        return fopen (name, W_MODE);         
        }
   fprintf( stderr," No tmp file found in %s\n", path);
   return get_tmpfile (NULL, name, reason);
   }

/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */
#define TYPE_INT    0
#define TYPE_FLOAT  1
#define TYPE_STRING 2
void get_init_param( P_(void *)par, P_(int)itype, P_(char**)rem ,
                  P_(char *)name, P_(char *) pform, P_(char) apend )
#ifdef NO_PROTO
void * par;
int itype;
char **rem;
char *name;
char *pform;
char apend;
#endif
{   char buffer[102];
    int  n, size;
    char *c, *d;
    int  *ival;
    float *fval;
    char  *sval;
    c = buffer;
    d = c + 1;
    rem[0]=rem[1]=NULL;
    size = 0;
    purge_cr();
    while ( fscanf(coord_fich, " %[#]", c) )
    {   fgets( d, 100, coord_fich);
        size += 2+strlen(buffer);
        rem[0] =  (rem[0]) ? (char *) realloc(rem[0], size) : (char *) malloc(size);
        purge_cr();
        }
    if ( rem[0] ) 
    {   strcpy(rem[0], c);
        fputs(rem[0], list_fich);
        }
    switch (itype )
    { case TYPE_INT :  ival = par;
                       n = fscanf(coord_fich, "%d", ival );
                   fprintf (list_fich, pform, name, *ival );
                       break;
      case TYPE_FLOAT : fval = par;
                       n = fscanf(coord_fich, "%f", fval );
                   fprintf (list_fich, pform, name, *fval );
                       break;
      case TYPE_STRING : sval = par;
                       n = fscanf(coord_fich, " %[^ #\n\r\t]", sval );
                   fprintf (list_fich, pform, name, sval );
                       break;
      default : termine(16, "Unvalid type in get_init_param, please report!");
      }            
     tst_abort ((n==0), "Unable to read initial parameter '%s' (type %d)", name, itype);
     while ( fscanf(coord_fich, "%[ ]", c) );
     if ( fscanf(coord_fich, "%[#]", c++) )
     {    fgets( c, 100, coord_fich);
          size = 2+strlen(buffer);
          rem[1]=(char *)malloc( size );
          strcpy(rem[1], buffer);
          }
     if (rem[1])  fputs(rem[1], list_fich);
     else putc (apend, list_fich);
     }
/* ------------------------------------------------------------------ */
void new_init_param( P_(void *)par, P_(int)itype, P_(char**)rem, P_(char) apend )
#ifdef NO_PROTO
void * par;
int itype;
char **rem;
char apend;
#endif
{   
    int  *ival;
    float *fval;
    char *sval;
    if (rem[0])
    {   if (prt_new) fputs(rem[0], new_fich);
        free(rem[0]);
        }
    if (prt_new) switch (itype )
    { case TYPE_INT :  ival = par;
                       fprintf (new_fich, "%5d", *ival );
                       break;
      case TYPE_FLOAT : fval = par;
                       fprintf (new_fich, "%10.4f", *fval );
                       break;
      case TYPE_STRING : sval = par;
                       fprintf (new_fich, " %s", sval );
                       break;
      default : termine(16, "Unvalid type in new_init_param, please report!");
      }            
    if (rem[1])
    {   if (prt_new) fprintf(new_fich, "   %s", rem[1]);
        free(rem[1]);
        }
    else if (prt_new)  putc (apend, new_fich); 
    }
/* ------------------------------------------------------------------ */
#define INIT_PAR 20
void read_init (P_(int) argn, P_(char **) argv)
#ifdef NO_PROTO
int argn;
char **argv;
#endif
{   int    i;
    int    nl_sym;
    int    nl_dif;
    int    back_code;
    int    tmp_default;
    char   file_name[NAME_LG];
    char   tmp_path[NAME_LG];
    char   *car;
    long   l;
    char   *rem[INIT_PAR][2];

    remark_fich = NULL;
    plg_fich = hkl_fich = new_fich = NULL;
    prt_new = 0;
    lect = (LECT *) tst_alloc (1,sizeof(LECT),"Reading");
    car = " Usage : '%s [-s] coord_file'\n Documentation file : '%s'\n\
 Coordinates file ? ";
    bavard = 1;
    
    if (argn != 0)
    {   lect->argc = argv[0];
        path2prog ();
        prog_id(file_name);
        make_path(tmp_path, lect->data_path, DOC_ID);
        }
    else 
    {   strcpy(file_name,"xnd");   
        strcpy(tmp_path,".");   
        strcpy(lect->data_path,".");
        }   
    switch (argn)
    {    case 0 :
         case 1 : printf (car, file_name, tmp_path);
         scanf(" %[^\n]",data_name);
         car = data_name;
         break;
    case 2 : car = argv[1]; break;
    case 3 : car = argv[2];
         if (((i=(argv[1][0]=='-'))!=0)
           && (strchr(argv[1],'s')!=NULL))   bavard = 0;
    }
    if (bavard) printf ("\n %s : %s [%s] (%s)\n", file_name,
            xnd_ver(), xnd_host(), xnd_dat());
    coord_fich = freopen ( car, "r", stdin);
    if (coord_fich==NULL)
     {       printf(E_FOPEN, "coordinates", car);
          exit (10);
         }
    fscanf (coord_fich," %[^\n]%*[\n] %[^ \n]",titre,list_name);
    list_fich = freopen ( list_name, "w",stderr);
    if (list_fich==NULL)
     {    printf (E_FOPEN, "listing", list_name);
          exit (10);
          }
    init_error();
    push_err_msg("read_init(xnd_rd.c)");
    if (bavard) printf ("\n  %s\n\n files '%s' --> '%s' :  %s\n",
    titre, car, list_name, str_time);
    fprintf (list_fich,
     " %s : %s [%s] (%s)\n Look at %s\n %s \n\n  %s\n\n files '%s' --> '%s' :  %s\n",
    file_name, xnd_ver(), xnd_host(), xnd_dat(), tmp_path, xnd_ref(),
    titre, car, list_name, str_time);

    i=0;
    get_init_param( &max_cycle, TYPE_INT, rem[i++],
          "Number of cycle(s)", " %s : %d ", '\n');
    get_init_param( &nl_sym, TYPE_INT, rem[i++],
          "Symetry group(s)", " %s : %d ", ',' );
    get_init_param( &lect->nl_ano, TYPE_INT, rem[i++],
          "Anomalous diffusion table(s)", " %s : %d ", ',' );
    get_init_param( &nl_dif, TYPE_INT, rem[i++],
          "Scattering table(s)", " %s : %d ", '\n' );
    get_init_param( &n_exper, TYPE_INT, rem[i++],
          "Number of experiment(s)", " %s : %d ", ',' );
    get_init_param( &n_phase, TYPE_INT, rem[i++],
          "Number of phase(s)", " %s : %d ", '\n' );
    get_init_param( &eps_stop, TYPE_FLOAT, rem[i++],
          "Eps_stop", " %s : %.4f ", ',' );
    get_init_param( &eps_prof, TYPE_FLOAT, rem[i++],
          "Eps_prof", " %s : %.4f ", ',' );
    get_init_param( &stabil, TYPE_FLOAT, rem[i++],
          "Relaxation coef", " %s : %.4f ", '\n' );
    get_init_param( &mod_lsq, TYPE_INT, rem[i++],
          "method", " %s : %d ", ',' );
    get_init_param( &back_code, TYPE_INT, rem[i++],
          "back_ground", " %s : %d ", ',' );
    get_init_param( &voigt_mode, TYPE_INT, rem[i++],
          "Profile", " %s : %d ", '\n' );

    if (mod_lsq ) fprintf (list_fich,"\n The method code implies : %s, %s, %s, %s\n",
      mod_lsq & 1 ? "min.lin.":" ", mod_lsq & 2 ? "w(y_calc)":" ",
     mod_lsq & 4 ? "correl.":" ", mod_lsq & 8 ? "x_back":" ");
    else fprintf (list_fich,"\n The method code implies defaults\n");
    back_mode = back_code & 0x1;
    unc_mode  = (back_code & 0x6) >> 1;
    fprintf (list_fich," The background code implies : %s%s%s\n",
		(back_mode&0x1)==0?"interpol":"spline",
		(unc_mode&1)!=0?", adding uncoherent":"",
		(unc_mode&2)!=0?", printing uncoherent":"");
    fprintf (list_fich," The profile code implies : %svoigt\n\n",
	  voigt_mode==0?"pseudo":"");
    if (stabil < 0) { stabil =fabs(stabil); mod_lsq |=1; }
     
    get_init_param( &max_assym, TYPE_INT, rem[i++],
          "Assymetry functions code", " %s : %d ", '\n' );
    init_assym_function();
    
    get_init_param( &lect->max_ordre, TYPE_INT, rem[i++],
          "Parameters expansion order", " %s : %d ", ',' );
    get_init_param( &valid_ref, TYPE_INT, rem[i++],
          "valid_ref", " %s : %d ", '\n' );
    get_init_param( &lect->prt_sym, TYPE_INT, rem[i++],
          "Print sym", " %s : %d ", ',' );
    get_init_param( &lect->prt_dif, TYPE_INT, rem[i++],
          "Print dif", " %s : %d ", ',' );
    get_init_param( &prt_cor, TYPE_INT, rem[i++],
          "Print correl", " %s : %d ", '\n' );

    fprintf(list_fich,"\n");
    get_init_param( &prt_new, TYPE_INT, rem[i++],
          "NEW file", " %s : %d ", ' ' );
    if (prt_new) 
    {    prt_new ++;
             get_init_param( new_name, TYPE_STRING, rem[i++],
          "NEW name", " %s : '%s' ", '\n' );
             new_fich = tst_open ( new_name, "w", "NEW file");
             tst_abort ((prt_new && strcmp(new_name,car)==0), "NEW file is the same than the coord file");
         fprintf (new_fich,"%s\n%s\n", titre, list_name);
         }  
        i=0;
        new_init_param( &max_cycle, TYPE_INT, rem[i++], '\n');
        new_init_param( &nl_sym, TYPE_INT, rem[i++], ' ');
        new_init_param( &lect->nl_ano, TYPE_INT, rem[i++], ' ');
        new_init_param( &nl_dif, TYPE_INT, rem[i++], '\n');
        new_init_param( &n_exper, TYPE_INT, rem[i++], ' ');
        new_init_param( &n_phase, TYPE_INT, rem[i++], '\n');
        new_init_param( &eps_stop, TYPE_FLOAT, rem[i++], ' ');
        new_init_param( &eps_prof, TYPE_FLOAT, rem[i++], ' ');
        new_init_param( &stabil, TYPE_FLOAT, rem[i++], '\n');
        new_init_param( &mod_lsq, TYPE_INT, rem[i++], ' ');
        new_init_param( &back_code, TYPE_INT, rem[i++], '\n');
        new_init_param( &voigt_mode, TYPE_INT, rem[i++], ' ');
        new_init_param( &max_assym, TYPE_INT, rem[i++], ' ');
        new_init_param( &lect->max_ordre, TYPE_INT, rem[i++], ' ');
        new_init_param( &valid_ref, TYPE_INT, rem[i++], '\n');
        new_init_param( &lect->prt_sym, TYPE_INT, rem[i++], ' ');
        new_init_param( &lect->prt_dif, TYPE_INT, rem[i++], ' ');
        new_init_param( &prt_cor, TYPE_INT, rem[i++], '\n');
        new_init_param( &prt_new, TYPE_INT, rem[i++], ' ');
        if (prt_new) new_init_param( new_name, TYPE_STRING, rem[i++], '\n');
    tst_abort ((i>INIT_PAR),E_CHK,"To much init_param to read, please report");
    
    get_init_param( &prt_hkl, TYPE_INT, rem[0],
          "HKL file", " %s : %d ", ' ' );
        new_init_param( &prt_hkl, TYPE_INT, rem[0], ' ');
    if (prt_hkl) 
    {    get_init_param( hkl_name, TYPE_STRING, rem[i++],
          "HKL name", " %s : '%s' ", '\n' );
         new_init_param( hkl_name, TYPE_STRING, rem[0], '\n');
         }
    get_init_param( &prt_plg, TYPE_INT, rem[0],
          "HKL file", " %s : %d ", ' ' );
        new_init_param( &prt_plg, TYPE_INT, rem[0], ' ');
    if (prt_plg) 
    {    get_init_param( plg_name, TYPE_STRING, rem[i++],
          "HKL name", " %s : '%s' ", '\n' );
         new_init_param( plg_name, TYPE_STRING, rem[0], '\n');
         if (prt_plg >1 )
         fprintf(list_fich,"        plg_code implies : %s %s %s\n",
             prt_plg&PLG_NHEADER?"no_header":"",
             prt_plg&PLG_ADDEND?"add_endrecord":"",
             prt_plg&PLG_ADDSEMI?"add_semicolumn":"");
             }
          
       if (prt_new) fprintf(new_fich,"\n");
       fprintf(list_fich,"\n");
       if (valid_ref > 1)
       {   lect->valid_reste = abs(prt_new) % valid_ref;
       fprintf (list_fich,"\nvalid_ref non nul ==> affinement restreint :\n\
 1 < code < 10 : (code - 2) modulo %d == %d ==> codes affines %d, %dxx\n",
 valid_ref, lect->valid_reste, 2+lect->valid_reste, 2+lect->valid_reste );
      }

      if (prt_hkl>1) fprintf (list_fich,"\nPrinting non calculated lines : prt_hkl = %d\n",prt_hkl);


      if (max_cycle < 0)
      {    test_mode = -max_cycle;
           get_init_param( &max_cycle, TYPE_INT, rem[0],
              "TEST_MODE max_cycle", " %s : %d ", '\n' );
           new_init_param( &max_cycle, TYPE_INT, rem[0], '\n');
       if (test_mode && 256)
       {    get_init_param( &bragg_repart, TYPE_FLOAT, rem[0],
              "TEST_MODE bragg_repart", " %s : %d ", '\n' );
                new_init_param( &bragg_repart, TYPE_FLOAT, rem[0], '\n');
        }
           } else test_mode = 0;

      get_init_param( &disk_dydp, TYPE_INT, rem[0],
          "disk_dydp", " %s : %d ", ' ' );
      new_init_param( &disk_dydp, TYPE_INT, rem[0], ' ');
      get_init_param( &disk_data, TYPE_INT, rem[0],
          "disk_data", " %s : %d ", ' ' );
      new_init_param( &disk_data, TYPE_INT, rem[0], ' ');

    strcpy(data_name,"");
    if (disk_data)
    {   get_init_param( data_name, TYPE_STRING, rem[i++],
          "data name", " %s : '%s' ", '\n' );
        new_init_param( data_name, TYPE_STRING, rem[0], '\n');
        }

    /* chemin vers fichiers standarts et temporaires */
      get_init_param( &tmp_default, TYPE_INT, rem[0],
          "tmp_default", " %s : %d ", ' ' );
      new_init_param( &tmp_default, TYPE_INT, rem[0], ' ');
     if (tmp_default&1)
     {     get_init_param( lect->data_path, TYPE_STRING, rem[i++],
          "data_path", " %s : '%s' ", '\n' );
     new_init_param( lect->data_path, TYPE_STRING, rem[0], '\n');
     }    
     if (tmp_default&2)
     {     get_init_param( tmp_path, TYPE_STRING, rem[i++],
          "tmp_path", " %s : '%s' ", '\n' );
     new_init_param( tmp_path, TYPE_STRING, rem[0], '\n');
     }    
     else strcpy (tmp_path,"");

    if (prt_new) fprintf(new_fich,"\n");
    fprintf(list_fich,"\n");
    
    /* get the programme directory and used it for std file */
    make_path (lect->dif_name, lect->data_path, DIF_FILE);
    fprintf(list_fich," if needed '%s' will be searched\n", lect->dif_name);
    make_path (lect->sym_name, lect->data_path, SYM_FILE);
    fprintf(list_fich," if needed '%s' will be searched\n", lect->sym_name);

    lect->max_points = nt_diag = n_sym = n_dif= n_var =
    n_par = n_pen = lect->nature = tot_prof_par = phase_prof_par = 0;
    lect->tot_points = 0L;
    lect->ini_date = 0;
    for (i=1;i<MAX_COD;i++) lect->codepar[i]=0;

    if (nl_sym)
    {   fprintf(list_fich,"\n\nReading %d symetry group(s)\n", nl_sym);
        for (i=0;i<nl_sym;i++)
    {   if (prt_new) fprintf(new_fich,"\n\n");
        read_remark();
        lect->symgrp[i] = (SYMGRP *) read_sym (coord_fich);
        if (lect->prt_sym & 1) print_sym (lect->symgrp[i], 1);
        if (prt_new)    new_sym (lect->symgrp[i]);
        }
    }
    if (lect->nl_ano)
    {    fprintf(list_fich,"\nReading %d anomalous tables\n", lect->nl_ano);
         read_remark();
         lecture_ano ();
         }
    else lect->anodat = NULL;
    if (nl_dif)
    {    fprintf(list_fich,"\nReading %d diffusion tables\n", nl_dif);
         for (i=0;i<nl_dif;i++)
         {     read_remark();
           lect->difdat[i] = lecture_dif(coord_fich);
           if (lect->prt_dif & 1) put_dif (lect->difdat[i], list_fich);
           if (prt_new)     put_dif (lect->difdat[i], new_fich);
           }
      }
     fflush (list_fich);

        read_remark();
        if (disk_data & 2)
        data_fich = fopen (data_name, R_MODE);
    else if (disk_data & 1)
        data_fich = fopen (data_name, W_MODE);
    else
    {      disk_data = 8;
           data_fich = get_tmpfile(tmp_path, data_name, "datafile");
           }
    tst_abort ((data_fich==NULL)," bin data file");

    /* fin d'ecriture du fichier new, on stocke les remarques */
    remark_fich = get_tmpfile(tmp_path, remark_name, "remarks");


    tst_abort ((n_exper<=0), "No experiment to read");
    l_exper = exper = (EXPER *) tst_alloc (n_exper,sizeof(EXPER),"exper");
    for (i=0;i<n_exper;(i++,l_exper++)) 
    {     l_exper->number = i;
          lect->nature |= read_exper();
          }

    tst_abort ((n_phase<=0), "No phase to read");
    tot_phase = n_phase;
    l_phase = phase = (PHASE *) tst_alloc(n_phase,sizeof(PHASE),"phase");
    for (i=0;i<n_phase;i++,l_phase++) read_phase (i);

    end0_remark = read_remark();

    marquardt = 0; c_marquardt=0;
     fscanf (coord_fich,"%f %d %*lf",&marquardt,&c_marquardt);
     if (marquardt > 1)
     {     fprintf (list_fich,"\n  Parametre de Marquardt  incoherent %f modifie", marquardt);
          marquardt = 0.0002;
           c_marquardt = 12;
           }
    fprintf (list_fich,
     "\n Parametre Marquardt initial %.3_FG, variation  en descente %d/10\n",
     marquardt,c_marquardt);

    end1_remark = read_remark();

    lect->tot_points += 2*nt_diag;
    fprintf (list_fich,"\n Taille des fichiers temporaires :\
 DAT = %s %ld ko, DY_DP %ld ko\n",data_name,1 + (long) (sizeof(OBS)*lect->tot_points)/1024,
         1L+((1L+lect->max_points)*(4+n_par)*sizeof(FLOAT))/1024);

    fprintf (list_fich," Fin des lectures, %d variables (%d parametres), %d cycles max\n",n_var,n_par,max_cycle);
    if (bavard) printf (" Fin des lectures, %d variables (%d parametres), %d cycles max\n",n_var,n_par,max_cycle);
    fflush (list_fich);
    if (tot_phase != n_phase) fprintf (list_fich,
        " Nombre de phases internes %d (magnetisme ou modulation)\n",
          tot_phase);


    if (n_par==0) max_cycle=0;
    if (max_cycle==0) n_par=0;
    n_mat = (n_par * (n_par+1))/2;

	 if (MAX_ALLOC)  /* check if not zero or undefined */
    {   l = floor ( MAX_ALLOC / (FLOAT) ((DYDP_NB+n_par)*sizeof(FLOAT)));
		  if (disk_dydp == 0)
		  {   if (l > lect->max_points)
				{   disk_dydp = lect->max_points;
					 fprintf (list_fich," disk_dydp parameter : %d points are in memory\n",disk_dydp);
					 }
				else
				{   disk_dydp =  (l > 100) ? 20 : l ;
					 fprintf (list_fich," parametre disk_dydp defini : %d points en memoire, maximum %ld\n",disk_dydp,l);
				}   }
		  else if (disk_dydp>l)
		  {   disk_dydp = l;
				fprintf (list_fich," parametre disk_dydp modifie : %d points en memoire\n",disk_dydp);
				}
		  else fprintf (list_fich," valeur maximale possible pour disk_dydp : %ld points en memoire\n",l);
		  }

       dydp_fich = get_tmpfile (tmp_path, dydp_name,"dy_dp file");
    tst_abort ((dydp_fich==NULL)," dy_dp file");

    if (lect->nl_ano) free (lect->anodat);
    free (lect);
    bragg_fich = NULL;

    if (n_par && max_cycle)
    {   fini = 0;
    y_vect  = (FLOAT *) tst_alloc (n_par,sizeof(FLOAT),"vecteur");
    matrice = (FLOAT *) tst_alloc (n_mat,sizeof(FLOAT),"matrice");
    }
    else fini = 1;


    if (new_fich) fclose (new_fich);
    fclose (coord_fich);
    pop_err_msg();
    }
/* ------------------------------------------------------------------ */

