/* XND_RDH.H   */

#include <string.h>
#include <ctype.h>
#include <time.h>

/* code identification exper : lecture.nature */
#define LECT_NAT_RX   1
#define LECT_NAT_N    2
#define LECT_NAT_RXA  4
#define LECT_NAT_NM   8



#ifndef EXTERN_RD
#define EXTERN_RD extern
#endif

typedef struct
{
		 int    codepar[MAX_COD];
		 DIFDAT *difdat[MAX_DIF];
		 SYMGRP *symgrp[MAX_SYM];
		 int    max_ordre;
		 int    nl_ano;
		 int    prt_sym;
		 int    prt_dif;
		 int    nature;
		 int    n_magnet;
		 int    n_modul;
		 long   tot_points;
		 long   max_points;
		 int    ini_date;
		 int    valid_reste;
		 struct tm date;
		 char   sym_name[NAME_LG];
		 char   dif_name[NAME_LG];
		 char   data_path[NAME_LG];
		 char   *argc;
		 ANODAT **anodat;
		 }      LECT;

EXTERN_RD  LECT   *lect;
EXTERN_RD  FILE   *coord_fich;

/* ------------------------------------------------------------------ */
/* define in XND_RD.C */

void strup     PROTO((char *string));
void purge_cr  PROTO((void));

 /* define in XND_RSYM.C */

int analyse_xyz_pos  PROTO((char *ligne, float * l_coef, SYMGRP *l_sym));
SYMGRP *get_sym      PROTO((char *modele));
SYMGRP *read_sym     PROTO((FILE *file));
void print_sym       PROTO((SYMGRP *symgrp, int cas));
void new_sym         PROTO((SYMGRP *symgrp));

 /* define in XND_RDIF.C */

DIFDAT *get_dif     PROTO((char *modele, int fatal));
ANODAT *get_adif    PROTO((char *modele));
void    lecture_ano PROTO((void));
void put_dif        PROTO((DIFDAT *difdat, FILE *file));
void new_dif        PROTO((DIFDAT *difdat));
DIFDAT *lecture_dif PROTO((FILE *file));

 /* define in XND_RVAR.C */

void fget_var  PROTO((VAR *var,int nombre,int ncle, int arg, char *nature, void **cle));

 /* define in XND_REXP.C */
void write_chk PROTO((void));
FLOAT read_chk PROTO((void));
int  read_exper PROTO((void));
 /* define in XND_REX1.C */
void get_real_data PROTO ((void));
 /* define in XND_REX2.C */
void get_mult_data PROTO ((void));
 /* define in XND_REX3.C */
void get_hkl_data PROTO ((void));

 /* define in XND_RPHA.C */

void read_phase PROTO(( int phase_num ));

 /* define in XND_RCRY.C */
void fget_phase_prof PROTO((void));
void fget_phase_orien PROTO((void));
void fget_crystal PROTO((void));
 
/* -------------------------------------------------- */
#undef  EXTERN_RD
