/* XND_RDIF.C    lecture tables de diffusion */

#include "xnd_def.h"
#include "xnd_rdh.h"

/* ------------------------------------------------------------------ */
void put_dif(P_(DIFDAT *) difdat, P_(FILE *) file)
#ifdef NO_PROTO
DIFDAT *difdat;
FILE * file;
#endif
{   int i;
    float *l_coef;
    char prefix = ' ';
    if (difdat->cas == 1 )
     switch (difdat->nom[0])
     {    case '_' : 
	  case '$' : 
	  case '@' : prefix = ' '; break;
	  default :  prefix ='*';
	  }
     fprintf(file,"  %c%s ", prefix, difdat->nom);
	l_coef = &difdat->coef;
	if (difdat->cas==1) 
	{    fprintf(file," %d   %f\n",difdat->tot, *l_coef);
	     l_coef++;
	     }
      	for (i=0;i<difdat->tot;i++,l_coef++)
      	    fprintf(file," %9.5f%c",*l_coef,i%5==4?'\n':' ');
       	fprintf(file,"\n");
    }

/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */

DIFDAT *lecture_dif (P_(FILE *) file)
#ifdef NO_PROTO
FILE *file;
#endif
{   char ligne[60];
    char cas, *nom;
    int  i,n,s,tot;
    float  *l_coef;
    DIFDAT *l_dif;

    	fscanf(file,"%s",ligne);
    	strup (ligne);
   	 if (isdigit(ligne[0]) ) 
   	 {   	nom = ligne;
		cas = 0;
		n = tot = 1;
		}
    else if (ligne[0]=='_' || ligne[0]=='*'|| ligne[0]=='@'|| ligne[0]=='$')
   	 {	if (ligne[0]=='*') nom = ligne+1; else nom = ligne;
   	 	cas = 1;
   	 	fscanf (file,"%d",&tot);
   	 	n=1+tot;
   	 	}
    else if ( ligne[0]=='&')
   	 {	nom = ligne;
   	 	cas = 3;
   	 	n = tot=13;
		}
	else
	{  	nom = ligne;
		cas = 2;
		n = tot = 9;
		}
	s = sizeof(DIFDAT)+n*sizeof(float);
    	l_dif = (DIFDAT *)tst_alloc(1,s,"difdat");
     	strcpy (l_dif->nom,nom);
	l_dif->tot = tot;
	l_dif->cas = cas;
	l_coef= &l_dif->coef;
    	for (i=0;i<n;i++,l_coef++) fscanf(file,"%f",l_coef);
    n_dif++;	
    return (l_dif);
    }

/* ------------------------------------------------------------------ */

DIFDAT *get_dif (P_(char *) modele,P_(int) fatal)
#ifdef NO_PROTO
char *modele;
int fatal;
#endif
{   DIFDAT **l_dif;
    FILE   *dif_fich;
    int i;

    strup(modele);
    for (i=0,l_dif=lect->difdat; i<n_dif; i++,l_dif++)
    {   if (strcmp((*l_dif)->nom,modele)==0)  return(*l_dif);
	}
    
    dif_fich = tst_open (lect->dif_name,"r","open diffusion file");
    tst_abort ((n_dif>MAX_DIF),"Dim table dif");
    do
    {   *l_dif = lecture_dif(dif_fich);
		if (strcmp((*l_dif)->nom,modele)==0)
		{   if (lect->prt_dif>1) put_dif(*l_dif, list_fich);
			fclose (dif_fich);
			return(*l_dif);
			};
		n_dif--;
		free(*l_dif);
		} while (!feof(dif_fich));
    fclose (dif_fich);
    tst_abort (fatal,"No Dif : %s",modele);
    return(NULL);
    }

/* ------------------------------------------------------------------ */

ANODAT *get_adif (P_(char *) modele)
#ifdef NO_PROTO
char *modele;
#endif
{   int i;

    strup(modele);
    for (i=0;i<lect->nl_ano;i++)
	   if (strcmp(lect->anodat[i]->nom,modele)==0)  return(lect->anodat[i]);
       return(NULL);
    }

/* ------------------------------------------------------------------ */

void lecture_ano(P_(void))
{   int i,j;
	char nom[8];
	int tot;
    ANODAT *val;
    float *coef;
    lect->anodat = (ANODAT **) tst_alloc (lect->nl_ano, sizeof(ANODAT *), "anomal");
    for (i=0;i<lect->nl_ano;i++)
	{   fscanf (coord_fich," %s%d",nom,&tot);
		if (lect->prt_dif)    fprintf (list_fich," correction anomale : %s a %d lambda\n",nom,tot);
		if (prt_new) fprintf (new_fich," %s %d\n",nom,tot);
   	 val = (ANODAT *) tst_alloc (lect->nl_ano,sizeof(ANODAT)+3*tot*sizeof(float), "anomal");
	lect->anodat[i] =val;
	strcpy (val->nom,nom);
	val->tot=tot;
	coef = val->coef+3;
	for (j=0; j<tot; j++, coef +=3)
	{	fscanf (coord_fich,"%f%f%f",coef,coef+1,coef+2);
		if (lect->prt_dif) fprintf (list_fich,"  %f  f'= %f +i f''= %f\n",
		    coef[0],coef[1],coef[2]);
		if (prt_new) fprintf (new_fich,"  %f  %f  %f\n",coef[0],
		    coef[1],coef[2]);
		};
	};
    }
