/* XND_REXP.C   read the experimental data (1dim files) */

#include "xnd_def.h"
#include "xnd_rdh.h"
#define EPS_CHK 0.01

/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */
static step_fich (P_(FILE *)fich, P_(int) ligne, P_(int) compteur)
#ifdef NO_PROTO
FILE *fich;
int ligne;
int compteur;
#endif
{    int    i,j,lig;
     int    bloc,blk;
     int    nb,total=0;
     float  dtheta,pas,dthetaf,smono;
     OBS    obs;
     float  dt,dtx,dt0,dtf,val;
     float  sdiv,scale,smono0,scale0,wscale,wscale0;
     int    moniteur,iscale;
     char   buffer[100], *res;

     push_err_msg("step_fich(xnd_rex1.c)");
	  lig = ligne-1;
     if (fgets (buffer,100,fich) == NULL) return(0);
     switch (sscanf (buffer,"%d %f %f",&bloc,&scale0,&wscale0))
     {    case 1 : scale0 = 1;
          case 2 : wscale0 = 1;
          }
     if (scale0 < EPSILON) scale0= 1;
     if (wscale0 < EPSILON) wscale0= 1;
     dtx = MINFLOAT;
     for (blk=0; blk<bloc; blk++)
     {    buffer[0]= 0;
          while (((res =fgets (buffer,100,fich)) == NULL) || (strlen(buffer) < 3) ) 
                tst_abort( (res == NULL), "Bloc #%d / %d non trouve", blk, bloc);
  	  switch (sscanf (buffer,"%f%f%f%f%f%f",&dtheta,&pas,&dthetaf,&smono,&dt0,&dtf))
	  {   case 0 : case 1 :
	      case 2 : pas = -1;
	      case 3 : smono = 0;
	      case 4 : dt0 = dtheta;
	      case 5 : dtf = dthetaf;
	      }
          if (bloc > 1) fprintf(list_fich,
             " bloc #%d : dt0 %.3f ddt %.3f dtf %.3f sm %.0f dt0 %.3f dtf %.3f\n",
             blk, dtheta, pas, dthetaf, smono, dt0, dtf);
	  tst_abort( (dtheta<=0 || pas<= 0 || dthetaf <= dtheta), " parametre en lecture bloc #%d /%d", blk, bloc);;
	  tst_abort ( (dtheta<= dtx) ,E_NEGAT, dtx, dtheta);
	  iscale =  ! (smono==0 || blk==0 );
	  if (blk==0) smono0=smono;
	  if (iscale) scale = scale0 * fabs( smono / smono0);
	  else scale = scale0;
	  wscale = wscale0 * scale/scale0;
	  moniteur = smono > 0;
	  nb = 1+(dtf + EPSILON - dt0)/pas;
	  for (i=0; i<nb; i++)
	  {   dt = i * pas + dt0;
              j=fscanf(fich,"%f",&val);
	      tst_abort((j==0),E_READ,"i_obs",dt);
	      tst_abort ((dt>=180),E_READ,"dtheta",dt);
	      if (compteur) fscanf (fich,"%f",&sdiv);
	      if (dt >= dtheta && dt <= dthetaf)
	      {   total++;
		  obs.dtheta=dtx=dt;
		  obs.i_obs = val;
		  obs.weight = (obs.i_obs>0) ? 1/obs.i_obs : 0;
		  if (total==1) l_diag->dtheta0 = obs.dtheta;
		  if (compteur>0) obs.weight *= sdiv;
		  obs.i_obs *= scale;
		  obs.weight *= scale * wscale;
		  if (moniteur)   obs.weight += 1/smono;
		  write_data (&obs);
		  if (obs.weight>0 && obs.weight>l_diag->w_mini)
		      l_diag->w_mini = obs.weight;
		  }
	      else if (dt + pas > dthetaf && blk == bloc-1) break; 
	      if (i%ligne == lig) fscanf(fich,"%*[^\n]%*[\n]");
	      }
	  if (i%ligne != lig) fscanf(fich,"%*[^\n]%*[\n]");
	  }
     l_diag->dthetaf = dtx;
     pop_err_msg();
     return (total);
     }

/* ------------------------------------------------------------------ */
static int tab_fich (P_(FILE *)fich, P_(int) i1, P_(int) i2, P_(int) iw)
#ifdef NO_PROTO
FILE *fich;
int i1, i2, iw;
#endif
{    int    i;
     int    total=0;
     OBS    obs;
     float  s, dth;
     float  dt = MINFLOAT;
     char *c;
     char  buffer[250];
     long  fichpos;
     
     push_err_msg("step_fich(xnd_rex1.c)");
     while (!feof(fich)  )
     {    fichpos = ftell( fich);
          fgets( buffer, 249, fich);
          if ( feof(fich) )  continue;
          c = buffer;
          while (*c == ' ' || *c < '#') c++;
          if ( *c != '#' ) break;
          }
#ifndef SEEK_SET
#define SEEK_SET 0
#endif
     fseek( fich, fichpos, SEEK_SET );
     while (!feof(fich) )
     {    for(i=0;i<i1;i++) fscanf (fich, "%*f");
	  if (fscanf (fich, "%f", &dth)!=1) break;
	  tst_abort ( (dth<= dt) ,E_NEGAT, dt, dth);
	  if (dth>=998.0) break;
	  tst_abort ( (dth>=180 || dth<0) ,E_RANGE, i, dth);
	  obs.dtheta = dt = dth;
	  for(i=0;i<i2;i++) fscanf (fich,"%*f");
	  if (fscanf (fich, "%f", &s)==0) break;
	  obs.i_obs = s;
	  if (iw)
	  {    for(i=1;i<iw;i++) fscanf (fich, "%*f");
		   fscanf (fich, "%f",&s);
                   obs.weight = s>0 ? 1/(s*s) : 0;
		   }
	  else obs.weight = obs.i_obs>0 ? 1/obs.i_obs : 0;
	  total++;
	  fscanf( fich,"%*[^\n]%*[\n]");
	  if (total==1) l_diag->dtheta0 = obs.dtheta;
	  write_data (&obs);
	  if (obs.weight>0 && obs.weight>l_diag->w_mini)
		      l_diag->w_mini = obs.weight;
	  }
     l_diag->dthetaf = dt;
     pop_err_msg();
     return (total);
     }

/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */
void get_real_data (P_(void))
{    FILE   *fich;
     int    i, nb, num;
     OBS    obs;

    for (num=0; num < l_exper->n_diag; num++,l_diag++)
    {    l_diag->w_mini = MINFLOAT;
     fscanf (coord_fich,"%f%d %[^\n]",&l_diag->temp,&nb,l_diag->fich_name);
     fprintf (list_fich," DIAG : T = %.3f,   pts %4d  : '%s'\n",
		 l_diag->temp, nb, l_diag->fich_name);
     if ((disk_data&2) == 0)
     {    fich = tst_open (l_diag->fich_name,"r","data file");
	  switch (l_exper->dfich)
	  {    case 10: l_diag->n_points = step_fich(fich, 1, 0); break;
	       case 11: l_diag->n_points = step_fich(fich, 8, 0); break;
	       case 12: l_diag->n_points = step_fich(fich,10,0); break;
	       case 13: l_diag->n_points = step_fich(fich,10,-1); break;
	       case 14: l_diag->n_points = step_fich(fich,10, 1); break;
	       case 15: l_diag->n_points = step_fich(fich,8,-1); break;
	       case 16: l_diag->n_points = step_fich(fich,8, 1); break;
	       case 1 : l_diag->n_points = tab_fich(fich, 0, 0, 0); break;
	       case 2 : l_diag->n_points = tab_fich(fich, 1, 0, 0); break;
	       case 3 : l_diag->n_points = tab_fich(fich, 0, 0, 1); break;
	       case 4 : l_diag->n_points = tab_fich(fich, 1, 0, 1); break;
	       default: if (l_exper->dfich>=100 && l_exper->dfich<200)
   l_diag->n_points = tab_fich(fich, (l_exper->dfich/10)%10, l_exper->dfich%10, 0);
	  		if (l_exper->dfich>=1000 && l_exper->dfich<2000)
   l_diag->n_points = tab_fich(fich, (l_exper->dfich/100)%10, (l_exper->dfich/10)%10, 1+l_exper->dfich%10);
		else tst_abort (1,"%s","Type fichier inconnu");
	       }
	  fclose (fich);
	  tst_abort((l_diag->n_points==0),E_ZEROP,l_diag->fich_name);
	  fprintf (list_fich," %d points lus entre %.3f et %.3f\n",
		  l_diag->n_points,l_diag->dtheta0,l_diag->dthetaf);
	  if (bavard) printf (" %d points lus sur '%s'\n",l_diag->n_points,l_diag->fich_name);
	  if ( nb && nb != l_diag->n_points)
	     fprintf (list_fich,"Nb de points declares non conforme\n");
	  l_diag->w_mini = 1 / sqrt (l_diag->w_mini);
	  write_chk();
	  }
     else
     {    l_diag->n_points = nb;
	  for (i=0;i<nb;i++) read_data(&obs);
	  tst_abort ((fabs(read_chk()-l_diag->temp)>EPS_CHK),"Verif data_fich");
	  }
     lect->tot_points += l_diag->n_points;
     if (l_diag->n_points > lect->max_points)
	lect->max_points = l_diag->n_points;
	 }
     }

/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */
