/* XND_REX3.C   read the experimental data (hkl files) */

#include "xnd_def.h"
#include "xnd_rdh.h"
#define EPS_CHK 0.01

/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */
static int hkl_file_rd (P_(FILE *)fich, P_(int) i1, P_(int) i2)
#ifdef NO_PROTO
FILE *fich;
int i1, i2;
#endif
#pragma argsused
{    int total = 0;
     HKL_OBS hkl_obs; 
     while (!feof(fich) )
     {    fscanf (fich, " %d %d %d", &hkl_obs.h, &hkl_obs.k, &hkl_obs.l);
	  if (fscanf (fich, " %f", &hkl_obs.f_obs)==0) break;
	  if (i2) fscanf (fich, " %f",&hkl_obs.weight);
	  else	hkl_obs.weight=1;
	  total++;
	  fscanf( fich,"%*[^\n]%*[\n]");
	  /* write_hkldata (&hkl_obs); */
	  }
     return (total);
     }

/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */
void get_hkl_data (P_(void))
{    FILE   *fich;
     int    i, nb, num;
     OBS    obs;

    for (num=0; num < l_exper->n_diag; num++,l_diag++)
    {    l_diag->w_mini = MINFLOAT;
     fscanf (coord_fich,"%f%d %[^\n]",&l_diag->temp,&nb,l_diag->fich_name);
     fprintf (list_fich," DIAG : T = %.3f,   pts %4d  : '%s'\n",
		 l_diag->temp, nb, l_diag->fich_name);
     if ((disk_data&2) == 0)
     {    fich = tst_open (l_diag->fich_name,"r","data file");
	  switch (l_exper->dfich)
	  {    case 50 : l_diag->n_points = hkl_file_rd(fich, 1, 0); break;
		 default : tst_abort (1,"%s","File type unknown");
	       }
	  fclose (fich);
	  tst_abort((l_diag->n_points==0),E_ZEROP,l_diag->fich_name);
	  fprintf (list_fich," %d hkl lines found\n",
		  l_diag->n_points);
	  if (bavard) printf (" %d  hkl lines found in '%s'\n",l_diag->n_points,l_diag->fich_name);
	  if ( nb && nb != l_diag->n_points)
	     fprintf (list_fich,"Nb de points declares non conforme\n");
	  l_diag->w_mini = 1 / sqrt (l_diag->w_mini);
	  write_chk();
	  }
     else
     {    l_diag->n_points = nb;
	  for (i=0;i<nb;i++) read_data(&obs);
	  tst_abort ((fabs(read_chk()-l_diag->temp)>EPS_CHK),"Verif data_fich");
	  }
     lect->tot_points += l_diag->n_points;
     if (l_diag->n_points > lect->max_points)
	lect->max_points = l_diag->n_points;
	 }
     }

/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */
