/* XND_RVAR.C     lecture des variables */

#include "xnd_def.h"
#include "xnd_rdh.h"

/* ------------------------------------------------------------------ */
void fget_var (P_(VAR *) var, P_(int) nombre, P_(int) ncle, P_(int) arg,
	  P_(char *) nature, P_(void **) cle)
#ifdef NO_PROTO
VAR *var;
int nombre;         /* nombre de variable a lire */
int ncle;           /* 0 ou repetition du texte */
int arg;            /* selon constantes VAR_ de def.h */
char *nature;                 
void **cle;
#endif
{    float *v,*s;
     int *c,*p;
     int  i,j,h,k,l;
     float *pos;
     HKL *p_hkl;
     int  tot;
     int  ok;

     var->remark = read_remark();
     var->size = nombre;
     var->ordre = 0;
	  if (nombre==0)
	  {   fprintf(list_fich," %s : ignored\n", nature);
			return;
			}
     if (ncle==0) ncle=nombre;
     var->ncle = ncle;
     j=fscanf (coord_fich,"%d",&ordre);
	  tst_abort ((j==0), " Expansion order not found, reading parameters %s\n", nature);
     if (ordre<0)
     {   ordre = -ordre;
         fscanf (coord_fich,"%d",&dim);
	} 
	else dim=1; 
	  fprintf(list_fich," %s : %d parameters : expansion order %d (size %d)\n",
	  nature, nombre, ordre, dim);
     var->dim = dim;
     var->ordre = ordre;
     var->size = nombre;

     switch (arg)
     {    case VAR_BG : pos = l_exper->back_pos
		= (float *) tst_alloc (l_exper->n_back,sizeof(float),nature);
		break;
	  case VAR_HKL : p_hkl
		= (HKL *) tst_alloc(nombre, sizeof(HKL),"hkl");
		if (cle == NULL) l_phase->hkl = p_hkl;
		else *cle = p_hkl;
		if (ordre==0)
		{	tst_abort((l_phase->n_atom==0),"n_atom=ordrehkl=0");
			for (j=0; j<nombre; j++,p_hkl++)
			{       i=fscanf (coord_fich,"%d%d%d",&h,&k,&l);
                                p_hkl->h[0] = h;  p_hkl->h[1] = k;  p_hkl->h[2] = l;
				fprintf (list_fich,
                                      "%3d hkl %3d %3d %3d\n",j,h,k,l);
				tst_abort( (i != 3 || (h==0 && k==0 && l==0 )),
                                                      "lecture HKL #%d", j);
				};
			fprintf (list_fich," hkl lus\n");
		};
		break;
         case VAR_RADIAL : pos = l_radial->diff_pos
		= (float *) tst_alloc (l_radial->nb_pos,sizeof(float),nature);
		break;
	  	  };

     if (ordre==0)  return; 
     tst_abort ((ordre>lect->max_ordre),E_READ,"max_ordre",(float)lect->max_ordre);
     tot =  ordre * dim  *nombre;
     var->value = v = (float *) tst_alloc (nombre*ordre,sizeof(float),"var");
     var->shift = s = (float *) tst_alloc (tot,sizeof(float),"var");
     var->codelu = c = (int *) tst_alloc (tot,sizeof(int),"var");
     var->param = p = (int *) tst_alloc (tot,sizeof(int),"var");
     for (i=0;i<nombre;i++)
     {   switch (arg)
	 {    case VAR_BG :    
              case VAR_RADIAL :    
		fscanf (coord_fich,"%f", pos);
		fprintf(list_fich," %8.3f", *pos);
		pos++;   break;
	      case VAR_STD :
		fprintf(list_fich," %8s",cle[i%ncle]);
		break;
	      case VAR_ATOM :   /* coord atomiques */
		fprintf(list_fich," %8s", txt_atom[coord_index(i%ncle)]);
		break;
	      case VAR_ORIEN :  /* profil,  orientation */
		fprintf(list_fich," %2d_%5s",i/ncle,cle[i%ncle]);
		break;
	      case VAR_HKL :  /* hkl intensities */
		j=fscanf (coord_fich,"%d%d%d",&h,&k,&l);
		p_hkl->h[0] = h;  p_hkl->h[1] = k;  p_hkl->h[2] = l;
		fprintf (list_fich,"%3d hkl%3d%3d%3d  ",i,h,k,l);
		tst_abort( (j != 3 || (h==0 && k==0 && l==0 )),
                                                      "lecture HKL #%d", i);
		p_hkl++;
		break;
		  };
	VAR_init(var);	  
	 for (io=0;io<ordre;(io++,v++))
	 {   fscanf (coord_fich,"%f",v);
	     fprintf(list_fich,"  %12.6g",*v);
	     for (id=0;id<dim;(id++,s++,p++,c++))
 	 {   fscanf (coord_fich,"%d",c);
	     fprintf(list_fich," %3d",*c);
	     *p= 0;
	     if (*c != 0)
	     {   if (valid_ref<=1) ok = ( *c > 0 );
		 else ok = (*c==1 || (*c>=10 && *c<200)
	   || (*c > 0 && *c <10 &&(((*c - 2) % valid_ref) == lect->valid_reste))
	   || (*c > 200 && (((*c / 100 - 2) % valid_ref) == lect->valid_reste)));
		 if (ok > 0 ) n_var++;
		 if (ok && *c >= 10)
		 {   tst_abort((*c>=MAX_COD),"erreur code");
		     fscanf (coord_fich,"%f",s);
		     if (lect->codepar[*c]==0) lect->codepar[*c]= ++n_par;
		     *p = lect->codepar[*c];
		     }
		 else
		 if (*c <= -10 || *c >= 100)
		 {   fscanf (coord_fich,"%f",s);
		     }
		 else
		 {   *s =1;
		     if (ok) *p = ++n_par;
		     };
		 fprintf(list_fich," (%2d %10.6f)",*p,*s);
		 }
		else fprintf(list_fich," (             )");
		if ( ( id % 4 ) && ( id+1-dim != 0 )) fprintf (list_fich,"\n");
                }; /* for id */
 	    if ( dim != 1 || ( io % 4 == 3 ) && ( io+1-ordre != 0) ) fprintf (list_fich,"\n          ");
            };	/* for io */ 
           if  (ordre==1 &&  (i %2)  || ordre>1 )  fprintf(list_fich,"\n"); 
	 };
	if (ordre==1 && (i%2) ) fprintf(list_fich,"\n");
	fprintf(list_fich,"\n");
	fflush (list_fich);
     }

