/* XND_SWP.C */

#include "xnd_def.h"
#include <string.h>
#ifdef __TURBOC__
#include <alloc.h>
#endif
/* ------------------------------------------------------------ */
/* routines allowing i_obs, weight, i_calc, iback and the table */
/* of the derivatives dy_dp to be stored on disk                */
/* they are totally contain in memory if disk_dydp is zero      */           

 static unsigned dydp_nb;
 static unsigned dydp_size;
 static unsigned dydp_dim;
 static unsigned dydp_pos;
 static unsigned dydp_max;
 static unsigned dydp_mod;

#ifndef SEEK_SET
#define SEEK_SET 0
#endif

static void rw_dydp (P_(unsigned) pos)
#ifdef NO_PROTO
unsigned pos;
#endif
{    unsigned long offset;
     if (dydp_mod)
     {   offset =  dydp_pos * (long) dydp_size;
	 if (fseek (dydp_fich, offset, SEEK_SET)!=0) 
	 	termine (15,E_DYDPS);
	 if (fwrite (dy_dp, dydp_size, dydp_nb, dydp_fich)!=dydp_nb) 
	 	termine (15,E_DYDPW);
	 dydp_mod = 0;
	 }
     dydp_pos = (pos / dydp_nb) * dydp_nb;
     dydp_max = dydp_nb + dydp_pos;
     offset =  dydp_pos * (long) dydp_size;
     if (fseek (dydp_fich, offset, SEEK_SET)!=0) 
     	termine (15,E_DYDPS);
     if (fread (dy_dp, dydp_size, dydp_nb, dydp_fich)!=dydp_nb) 
     	termine (15,E_DYDPR);
     }

void ini_dydp (P_(void))
{    int  i,j,n,m;
     OBS  obs;
     FLOAT *point;
     FLOAT *p_o;
     n_pts = l_diag->n_points;
     point = l_diag->points = (FLOAT *)tst_alloc(n_pts, sizeof(FLOAT),"points");
     dydp_nb = disk_dydp > n_pts ? n_pts : disk_dydp;
     dydp_dim = 4 + n_par;
     dydp_size = dydp_dim * sizeof(FLOAT);
     dy_dp = (FLOAT *) tst_alloc (dydp_nb, dydp_size, "dy_dp");
     memset (dy_dp,0, dydp_nb * dydp_size);
     dydp_mod = 0;
     if (disk_dydp) if (fseek (dydp_fich, 0, SEEK_SET)!=0) termine (15,E_DYDPS);
     m = 1+(n_pts-1) / dydp_nb;
     for (i=0, n=0; i<m; i++)
     {    for (j=0,p_o = dy_dp; j<dydp_nb; j++,n++,p_o+=dydp_dim)
	  if (n<n_pts)
	  {   read_data (&obs);
	      *point++ = obs.dtheta;
	      *p_o = obs.i_obs;
	      *(p_o+1) = obs.weight;
	      } else
	  {   *p_o = *(p_o+1) =0;
	      }
	  if (disk_dydp) if (dydp_nb!=fwrite (dy_dp, dydp_size, dydp_nb, dydp_fich))
	      termine (15,E_DYDPW);
	  }
    read_data (&obs);
    read_data (&obs);
    dydp_max = i*dydp_nb;
    dydp_pos = dydp_max - dydp_nb;
     }

int pos_dydp (P_(unsigned) cas, P_(unsigned) pts, P_(unsigned) par)
#ifdef NO_PROTO
unsigned cas, pts, par;
#endif
{   int i;
    if (pts < dydp_pos || pts >= dydp_max) rw_dydp (pts);
    if (cas) dydp_mod = 1;
    i =(pts-dydp_pos)*dydp_dim + par;
    return (i);
    }

/* --------- end of the derivatives table routines -------------- */
