/* XND_UNC    generate uncoherent scatering ... */

#include "xnd_def.h"
#include "xnd_cah.h"

 /* ---------------------------------------------------------- */
static void add_print_unc( P_(int) p, P_(float) uncoherent, P_(char *) txt)
#ifdef NO_PROTO
int p;
float uncoherent;
char *txt;
#endif
{   float ic;
    char *c;

    ic = uncoherent * act.cor * echelle;
    if ( ( unc_mode & 1 ) == 0 ) 
    {   c= "ic";
        put_ical(p) += ic;
        } 
     else
     {  c= "bg";
        put_back(p) += ic; 
        }
    if ( fini && act.lambda==0 && ( unc_mode&2 ) != 0 && ( p%(n_pts/20)) ==0)
            fprintf(list_fich, " %9.3f (lambda 0) %s=%9.3g(=%9.3g*%6.2g*%7.3g) added to %s\n", 
                 *l_points, txt, ic, uncoherent, act.cor, echelle, c); 
     }     
/* ---------------------------------------------------------- */
static void gen_tds_0 (P_(void))
{
    int i, j, p;
    float f, b, debye, uncoherent;
    if ((dif_nature & EXPER_N)  != 0)            valdif = b_valdif;
       else if ((dif_nature & EXPER_RX) != 0 )   valdif = x_valdif;
    else chk_abort ("dif_nature invalide");
    temp = &temp_phase;
    VAR_init (&l_phase->ech);
    phase_echelle = var_valeur (0);
    VAR_init (&l_phase->dif_ech);
    phase_echelle *= var_valeur(0);
         act.cor=1;
    for (act.lambda=0;act.lambda<l_exper->n_lambda;act.lambda++)
    {    temp = &temp_exper;
         VAR_init (l_onde);
         lambda = var_valeur (act.lambda * LAMBDA);
         exper_echelle = var_valeur(act.lambda*LAMBDA + 1);
         temp = &temp_phase;
         echelle = phase_echelle * exper_echelle;
         temp = &temp_phase;
         for (p=0,l_points=l_diag->points;p<n_pts;p++,l_points++)
         {    uncoherent = 0;
              sin_t = sin(RAD* *l_points/2);
              cos_t = sqrt(1-sin_t*sin_t);
              s=sin_t/lambda;
              /* act.cor = 1/ sin_t*cos_t; 
              if (i_eclair && sin_t<eclair) act.cor *= sin_t/eclair;*/
              for (i=0,l_atom=l_phase->atom;i<l_phase->n_atom;i++,l_atom++)
                  {   VAR_init (&l_atom->x);
                      if ((l_atom->nature & 1) == 0) b= var_valeur(4);
	              else b = b_equiv(&l_atom->x);
	              debye = 1.0 - exp (-2 * var_valeur (4) * s * s);
                      f = fhkl_mult * (*valdif)();
                      uncoherent += f * f * var_valeur(3) * debye;
                     }
              for (j=0;j<l_phase->nb_bloc;j++)
                for (i=0,l_atom=l_phase->bl_relat[j];i<l_phase->bl_atom[j];i++,l_atom++)
                  {  VAR_init (&l_atom->x);
                     if ((l_atom->nature & 1) == 0) b= var_valeur(4);
	             else b = b_equiv(&l_atom->x);
	              debye =  1.0 - exp (-2 * b * s * s);
                      f = fhkl_mult * (*valdif)();
                      uncoherent += f * f * var_valeur(3) * debye;
                     }
              add_print_unc(p, uncoherent, "tds");
              } /* points */
         } /* lambda */
    }
/* ---------------------------------------------------------- */
 /* ---------------------------------------------------------- */
static int  unc_fhkl_atom (P_(int) pos, P_(int) mul )
#ifdef NO_PROTO
int pos, mul;
#endif
{
    int i,j,nb;
    float x,y,z,f,fm;
    float hh,kk,ll;
    float *l_coef;
    float fbm;
    double trans, taux;
    double phi, c_phi, s_phi, d_a, d_b;
    double a = 0;
    double b = 0;

    nb = l_atom->nb;
    VAR_init (&l_atom->x);
    x = var_valeur (0);
    y = var_valeur (1);
    z = var_valeur (2);
    if (deriv_atom)   for (j=0;j<nb;j++)
    {    fa_deriv[pos+j] = 0;
	 if (!centro) fb_deriv[pos+j] = 0;
	 }
    for (i=0,l_coef=l_symgrp->coef;i<l_symgrp->nops;i++,l_coef+=12)
    {   hh = l_coef[0] * H + l_coef[1] * K + l_coef[2] * L;
	kk = l_coef[3] * H + l_coef[4] * K + l_coef[5] * L;
	ll = l_coef[6] * H + l_coef[7] * K + l_coef[8] * L;
	trans = H * l_coef[9] + K * l_coef[10] + L * l_coef[11];
	phi = 2 * M_PI * (hh * x + kk * y + ll * z + trans);
	a += c_phi = cos(phi);
	b += s_phi = sin(phi);
	if (deriv_atom)
	{    d_a = - 2 * M_PI * s_phi;
             fa_deriv [pos]   += hh * d_a;
	     fa_deriv [pos+1] += kk * d_a;
	     fa_deriv [pos+2] += ll * d_a;
	     if (!centro)
	     {    d_b = 2 * M_PI * c_phi;
                  fb_deriv [pos]   += hh * d_b;
		  fb_deriv [pos+1] += kk * d_b;
		  fb_deriv [pos+2] += ll * d_b;
		  }
	     }
	}
    f = (*valdif)();
    /* si diffusion anomale on traite a part la contrib imaginaire de f */
    if (dif_nature == EXPER_RXA)  f += anodif();
    fm = f * mul * ( taux = var_valeur (3) );
    F_A += fm * a;
    if (!centro)  F_B += fm * b;
    if (dif_nature == EXPER_RXA)
    {    fbm = mul * taux * anodif_b();
    	 act.f_am += fbm * a ;
	 if (!centro)  act.f_bm += fbm * b;
/* fprintf(list_fich,"XND_HKL.C hkl %3d %3d %3d %8s %6.3f %6.3f %6.3f (%6.1f  %6.1f) (%6.1f  %6.1f)\n",
/*   H, K, L, l_atom->nom, x, y, z, F_A, F_B, act.f_am, act.f_bm);*/
	 }
    if (deriv_atom==0) return (0);
    for (j=0;j<3;j++)  fa_deriv[pos+j] *= fm;
    fa_deriv[pos+3] = f * mul * a;
    if (dif_nature == EXPER_RXA)
    	 for (j=0;j<nb;j++)  fam_deriv[pos+j] = fa_deriv[pos+j] * fbm/fm;
    if (centro) return (nb);
    for (j=0;j<3;j++)  fb_deriv[pos+j] *= fm;
    fb_deriv[pos+3] = f * mul * b;
    if (dif_nature == EXPER_RXA)
   	 for (j=0;j<nb;j++)  fbm_deriv[pos+j] = fb_deriv[pos+j] * fbm/fm;
    return (nb);
    }

 /* ---------------------------------------------------------- */
/* prep */float  unc_fhkl (P_(void))
{   int i,j;
    int pos=0;
    float fhkl_2;
    
    temp = &temp_phase;
    if ( l_phase->nb_atom == 0 ) F_A = 1;
    for (i=0,l_atom=l_phase->atom;i<l_phase->n_atom;i++,l_atom++)
	pos +=  unc_fhkl_atom(pos, fhkl_mult);
    for (j=0;j<l_phase->nb_bloc;j++)
		for (i=0,l_atom=l_phase->bl_relat[j];i<l_phase->bl_atom[j];i++,l_atom++)
	pos +=  unc_fhkl_atom(pos, fhkl_mult);

    fhkl_2 = F_A * F_A + F_B * F_B;
     /* anomal sur poudre , moyenne sur hkl et -hkl */
    if (dif_nature && EXPER_RXA) fhkl_2 += act.f_am*act.f_am +act.f_bm+act.f_bm;
    return (fhkl_2);
    }

void gen_tds_hkl (P_(void))
{
    /* unc_fhk(); */
    }
/* ---------------------------------------------------------- */
void gen_tds (P_(void))
{    if ( l_phase->nb_tds==0) gen_tds_0();
     else tst_abort ( 1, " unable to generate non isotropic diffuse scatering");
     }
 /* ---------------------------------------------------------- */
void gen_uncoherent (P_(void))
{
    int i, j, p;
    float uncoherent;
    if ((dif_nature & EXPER_N)  != 0)            valdif = ub_valdif;
       else if ((dif_nature & EXPER_RX) != 0 )   valdif = ux_valdif;
    else chk_abort ("dif_nature invalide");
    temp = &temp_phase;
    VAR_init (&l_phase->ech);
    phase_echelle = var_valeur (0);
    VAR_init (&l_phase->dif_ech);
    phase_echelle *= var_valeur(0);
         act.cor=1;
    for (act.lambda=0;act.lambda<l_exper->n_lambda;act.lambda++)
    {    temp = &temp_exper;
         VAR_init (l_onde);
         lambda = var_valeur (act.lambda * LAMBDA);
         exper_echelle = var_valeur(act.lambda*LAMBDA + 1);
         temp = &temp_phase;
         echelle = phase_echelle * exper_echelle;
         temp = &temp_phase;
         for (p=0,l_points=l_diag->points;p<n_pts;p++,l_points++)
         {    uncoherent = 0;
              sin_t = sin(RAD* *l_points/2);
              cos_t = sqrt(1-sin_t*sin_t);
              s=sin_t/lambda;
              /* act.cor = 1/ sin_t*cos_t; 
              if (i_eclair && sin_t<eclair) act.cor *= sin_t/eclair;*/
              for (i=0,l_atom=l_phase->atom;i<l_phase->n_atom;i++,l_atom++)
                  {   VAR_init (&l_atom->x);
                      uncoherent +=  fhkl_mult * (*valdif)() * var_valeur(3);
                     }
              for (j=0;j<l_phase->nb_bloc;j++)
                for (i=0,l_atom=l_phase->bl_relat[j];i<l_phase->bl_atom[j];i++,l_atom++)
                  {  VAR_init (&l_atom->x);
                     uncoherent +=  fhkl_mult * (*valdif)() * var_valeur (3);
                     }
              add_print_unc(p, uncoherent, "cpt");
              } /* points */
         } /* lambda */
    }
 /* ---------------------------------------------------------- */
