/* XND_USE.C */

#include "xnd_def.h"
#ifdef __TURBOC__
#include <alloc.h>
#endif
#include <string.h>

/* ------------------------------------------------------------ */
/* retourne un index independant du type atomique */
/* pour l'ecriture des noms des coordonnees */
int coord_index (P_(int) pos)
#ifdef NO_PROTO
int pos;
#endif
{
    if (pos <= 3) return pos;
    if ((l_atom->nature & B_ANISO)==0)
    {   if (pos == 4) return pos;
	pos -= 5;
	} else
    {   if (pos < 10) return 1+pos;
	pos -= 10;
	}
    if (l_atom->nature & MAGNET)
    {   if (pos < 3) return (COORD_0+NUMER_K) + pos;
	pos -= COORD_MAGN;
	}
    return -1;
    }
/* ------------------------------------------------------------ */
/* retourne le numero de la coordonnee selon le type atomique */
/* XYZTb BBBBBB KKK      */
/* 01234 567890 123      */
int coord_numer (P_(int) pos)
#ifdef NO_PROTO
int pos;
#endif
{   int decal;
    char *msg;
    msg = "Invalid coordinate number(probably internal error, report please)" ;
  
    if ( pos <= 3 ) return pos;
    if ((l_atom->nature & B_ANISO)==0) 
    {   if ( pos < NUMER_B ) return 4;
        decal = 1;
        }
    else 
    {   if ( pos < NUMER_K ) return pos - 1;
        decal = 6;
        }
    if ( pos < NUMER_A ) 
            if ((l_atom->nature & MAGNET)!=0) return pos - decal;
            else     chk_abort (msg) ;

	 decal += ((l_atom->nature & MAGNET)==0) ? COORD_MAGN : 0;
    chk_abort (msg);
	 return 0;
	 }
/* ------------------------------------------------------------ */
/* ------------------------------------------------------------ */
void read_data (P_(OBS *) obs)
#ifdef NO_PROTO
OBS * obs;
#endif
{

 if (fread ( (void *) obs,   sizeof(OBS),  1, data_fich) != 1)
       termine (15,E_RDATF);
    }

void write_data (P_(OBS *) obs)
#ifdef NO_PROTO
OBS * obs;
#endif
{
   if (fwrite ((void *) obs, sizeof(OBS), 1, data_fich) != 1)
       termine (15,E_WDATF);
    }
/* ------------------------------------------------------------ */

/* tst_abort et chk_abort utilisent ou stdarg.h ou varargs.h si KK */
#ifndef NO_PROTO
#include <stdarg.h>
void tst_abort (int test, char *format, ... )
{   char msg[80];
    va_list argptr;
    if (test)
    {    va_start (argptr, format);
	 vsprintf (msg,format, argptr);
	 va_end (argptr);
	 termine(10, msg);
    }   }
void chk_abort (char *format, ... )
{   char msg[80];
    va_list argptr;

    va_start (argptr, format);
    vsprintf (msg,format, argptr);
    va_end (argptr);
    termine(16, msg);
    }
#else
/*  les memes avec varargs............... */
#include <varargs.h>
void tst_abort (va_alist)
va_dcl
{   va_list args;
    int test;
    char *format;
    char msg[80];
    va_start (args);
    test = va_arg(args, int);
    if (test)
    {    format = va_arg(args, char *);
	 vsprintf (msg,format, args);
	 va_end (args);
	 termine(10, msg);
    }   }
void chk_abort (va_alist)
va_dcl
{   va_list args;
    char *format;
    char msg[80];
    va_start (args);
    format = va_arg(args, char *);
    vsprintf (msg,format, args);
    va_end (args);
    termine(16, msg);
    }
#endif
/* ------------------------------------------------------- */

void *tst_alloc (P_(int) nb, P_(int) size, P_(char *) name)
#ifdef NO_PROTO
int nb;
int size;
char *name;
#endif
{   void  *ptr;
    char msg[80];
    if (size * (long) nb > MAX_ALLOC)
    {    sprintf (msg," Alloc %d * %d %s > %ld",nb,size,name,MAX_ALLOC);
	 termine (14,msg);
	 }
    if (nb && size) ptr = (void *) calloc (nb,size); else ptr = NULL;
    if (ptr==NULL && nb!=0)
	{    sprintf (msg,E_ALLOC,nb,size,name);
	while (ptr == NULL)
	{	nb = (nb * 3) / 4;
		ptr = (void *) calloc (nb,size); 
		if (ptr != NULL)
		{   	 fprintf(list_fich," Memoire restante disponible pour %u elements de dimension %u\n",nb, size);	
			 termine (14, msg);
			}
		if (nb <= 2)
		{ 	fprintf (list_fich," Aucune memoire disponible\n");
			 termine (14, msg);
			}
	}	 }
    return ptr;
    }

/* ------------------------------------------------------------------ */
FILE *tst_open (P_(char *) name, P_(char *) mode, P_(char *) msg)
#ifdef NO_PROTO
char *name;
char *mode;
char *msg;
#endif
{   FILE *file;
    char nmsg[100];
    file = fopen (name, mode);
    if (file==NULL)
    {    sprintf (nmsg,E_FOPEN,name,msg);
	 termine(10, nmsg);
	 }
    return(file);
    }

/* ================================================================ */

